// This file is generated by TypeBuilder_h.template.

// Copyright (c) 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef protocol_Cast_h
#define protocol_Cast_h

#include "chrome/browser/devtools/protocol/protocol.h"
// For each imported domain we generate a ValueConversions struct instead of a full domain definition
// and include Domain::API version from there.

namespace protocol {
namespace Cast {

// ------------- Forward and enum declarations.
class SinksUpdatedNotification;
class IssueUpdatedNotification;

// ------------- Type and builder declarations.

class  SinksUpdatedNotification : public Serializable{
    PROTOCOL_DISALLOW_COPY(SinksUpdatedNotification);
public:
    static std::unique_ptr<SinksUpdatedNotification> fromValue(protocol::Value* value, ErrorSupport* errors);

    ~SinksUpdatedNotification() override { }

    protocol::Array<String>* GetSinkNames() { return m_sinkNames.get(); }
    void SetSinkNames(std::unique_ptr<protocol::Array<String>> value) { m_sinkNames = std::move(value); }

    std::unique_ptr<protocol::DictionaryValue> toValue() const;
    String serializeToJSON() override { return toValue()->serializeToJSON(); }
    std::vector<uint8_t> serializeToBinary() override { return toValue()->serializeToBinary(); }
    String toJSON() const { return toValue()->toJSONString(); }
    std::unique_ptr<SinksUpdatedNotification> clone() const;

    template<int STATE>
    class SinksUpdatedNotificationBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            SinkNamesSet = 1 << 1,
            AllFieldsSet = (SinkNamesSet | 0)};


        SinksUpdatedNotificationBuilder<STATE | SinkNamesSet>& SetSinkNames(std::unique_ptr<protocol::Array<String>> value)
        {
            static_assert(!(STATE & SinkNamesSet), "property sinkNames should not be set yet");
            m_result->SetSinkNames(std::move(value));
            return castState<SinkNamesSet>();
        }

        std::unique_ptr<SinksUpdatedNotification> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class SinksUpdatedNotification;
        SinksUpdatedNotificationBuilder() : m_result(new SinksUpdatedNotification()) { }

        template<int STEP> SinksUpdatedNotificationBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<SinksUpdatedNotificationBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Cast::SinksUpdatedNotification> m_result;
    };

    static SinksUpdatedNotificationBuilder<0> Create()
    {
        return SinksUpdatedNotificationBuilder<0>();
    }

private:
    SinksUpdatedNotification()
    {
    }

    std::unique_ptr<protocol::Array<String>> m_sinkNames;
};


class  IssueUpdatedNotification : public Serializable{
    PROTOCOL_DISALLOW_COPY(IssueUpdatedNotification);
public:
    static std::unique_ptr<IssueUpdatedNotification> fromValue(protocol::Value* value, ErrorSupport* errors);

    ~IssueUpdatedNotification() override { }

    String GetIssueMessage() { return m_issueMessage; }
    void SetIssueMessage(const String& value) { m_issueMessage = value; }

    std::unique_ptr<protocol::DictionaryValue> toValue() const;
    String serializeToJSON() override { return toValue()->serializeToJSON(); }
    std::vector<uint8_t> serializeToBinary() override { return toValue()->serializeToBinary(); }
    String toJSON() const { return toValue()->toJSONString(); }
    std::unique_ptr<IssueUpdatedNotification> clone() const;

    template<int STATE>
    class IssueUpdatedNotificationBuilder {
    public:
        enum {
            NoFieldsSet = 0,
            IssueMessageSet = 1 << 1,
            AllFieldsSet = (IssueMessageSet | 0)};


        IssueUpdatedNotificationBuilder<STATE | IssueMessageSet>& SetIssueMessage(const String& value)
        {
            static_assert(!(STATE & IssueMessageSet), "property issueMessage should not be set yet");
            m_result->SetIssueMessage(value);
            return castState<IssueMessageSet>();
        }

        std::unique_ptr<IssueUpdatedNotification> Build()
        {
            static_assert(STATE == AllFieldsSet, "state should be AllFieldsSet");
            return std::move(m_result);
        }

    private:
        friend class IssueUpdatedNotification;
        IssueUpdatedNotificationBuilder() : m_result(new IssueUpdatedNotification()) { }

        template<int STEP> IssueUpdatedNotificationBuilder<STATE | STEP>& castState()
        {
            return *reinterpret_cast<IssueUpdatedNotificationBuilder<STATE | STEP>*>(this);
        }

        std::unique_ptr<protocol::Cast::IssueUpdatedNotification> m_result;
    };

    static IssueUpdatedNotificationBuilder<0> Create()
    {
        return IssueUpdatedNotificationBuilder<0>();
    }

private:
    IssueUpdatedNotification()
    {
    }

    String m_issueMessage;
};


// ------------- Backend interface.

class  Backend {
public:
    virtual ~Backend() { }

    virtual DispatchResponse Enable(Maybe<String> in_presentationUrl) = 0;
    virtual DispatchResponse Disable() = 0;
    virtual DispatchResponse SetSinkToUse(const String& in_sinkName) = 0;
    class  StartTabMirroringCallback {
    public:
        virtual void sendSuccess() = 0;
        virtual void sendFailure(const DispatchResponse&) = 0;
        virtual void fallThrough() = 0;
        virtual ~StartTabMirroringCallback() { }
    };
    virtual void StartTabMirroring(const String& in_sinkName, std::unique_ptr<StartTabMirroringCallback> callback) = 0;
    virtual DispatchResponse StopCasting(const String& in_sinkName) = 0;

};

// ------------- Frontend interface.

class  Frontend {
public:
    explicit Frontend(FrontendChannel* frontendChannel) : m_frontendChannel(frontendChannel) { }
    void SinksUpdated(std::unique_ptr<protocol::Array<String>> sinkNames);
    void IssueUpdated(const String& issueMessage);

    void flush();
    void sendRawNotification(String);
    void sendRawNotification(std::vector<uint8_t>);
private:
    FrontendChannel* m_frontendChannel;
};

// ------------- Dispatcher.

class  Dispatcher {
public:
    static void wire(UberDispatcher*, Backend*);

private:
    Dispatcher() { }
};

// ------------- Metainfo.

class  Metainfo {
public:
    using BackendClass = Backend;
    using FrontendClass = Frontend;
    using DispatcherClass = Dispatcher;
    static const char domainName[];
    static const char commandPrefix[];
    static const char version[];
};

} // namespace Cast
} // namespace protocol

#endif // !defined(protocol_Cast_h)
