// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_PARAMS_DATA_H_
#define CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace mojom {
namespace internal {
class  BluetoothInternalsHandler_GetAdapter_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothInternalsHandler_GetAdapter_Params_Data));
      new (data()) BluetoothInternalsHandler_GetAdapter_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothInternalsHandler_GetAdapter_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothInternalsHandler_GetAdapter_Params_Data>(index_);
    }
    BluetoothInternalsHandler_GetAdapter_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothInternalsHandler_GetAdapter_Params_Data();
  ~BluetoothInternalsHandler_GetAdapter_Params_Data() = delete;
};
static_assert(sizeof(BluetoothInternalsHandler_GetAdapter_Params_Data) == 8,
              "Bad sizeof(BluetoothInternalsHandler_GetAdapter_Params_Data)");
class  BluetoothInternalsHandler_GetAdapter_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothInternalsHandler_GetAdapter_ResponseParams_Data));
      new (data()) BluetoothInternalsHandler_GetAdapter_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothInternalsHandler_GetAdapter_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothInternalsHandler_GetAdapter_ResponseParams_Data>(index_);
    }
    BluetoothInternalsHandler_GetAdapter_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data adapter;

 private:
  BluetoothInternalsHandler_GetAdapter_ResponseParams_Data();
  ~BluetoothInternalsHandler_GetAdapter_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothInternalsHandler_GetAdapter_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothInternalsHandler_GetAdapter_ResponseParams_Data)");

}  // namespace internal
class BluetoothInternalsHandler_GetAdapter_ParamsDataView {
 public:
  BluetoothInternalsHandler_GetAdapter_ParamsDataView() {}

  BluetoothInternalsHandler_GetAdapter_ParamsDataView(
      internal::BluetoothInternalsHandler_GetAdapter_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::BluetoothInternalsHandler_GetAdapter_Params_Data* data_ = nullptr;
};

class BluetoothInternalsHandler_GetAdapter_ResponseParamsDataView {
 public:
  BluetoothInternalsHandler_GetAdapter_ResponseParamsDataView() {}

  BluetoothInternalsHandler_GetAdapter_ResponseParamsDataView(
      internal::BluetoothInternalsHandler_GetAdapter_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeAdapter() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::bluetooth::mojom::AdapterPtrDataView>(
            &data_->adapter, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::BluetoothInternalsHandler_GetAdapter_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};





}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_PARAMS_DATA_H_