// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_TEST_UTILS_H_
#define CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_TEST_UTILS_H_

#include "chrome/browser/ui/webui/bluetooth_internals/bluetooth_internals.mojom.h"


namespace mojom {


class  BluetoothInternalsHandlerInterceptorForTesting : public BluetoothInternalsHandler {
  virtual BluetoothInternalsHandler* GetForwardingInterface() = 0;
  void GetAdapter(GetAdapterCallback callback) override;
};
class  BluetoothInternalsHandlerAsyncWaiter {
 public:
  explicit BluetoothInternalsHandlerAsyncWaiter(BluetoothInternalsHandler* proxy);
  ~BluetoothInternalsHandlerAsyncWaiter();
  void GetAdapter(
      ::bluetooth::mojom::AdapterPtr* out_adapter);

 private:
  BluetoothInternalsHandler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothInternalsHandlerAsyncWaiter);
};




}  // namespace mojom

#endif  // CHROME_BROWSER_UI_WEBUI_BLUETOOTH_INTERNALS_BLUETOOTH_INTERNALS_MOJOM_TEST_UTILS_H_