// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/browser/ui/webui/discards/discards.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "chrome/browser/resource_coordinator/lifecycle_unit_state.mojom.h"


#ifndef CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_JUMBO_H_
#endif


namespace mojom {


void DiscardsDetailsProviderInterceptorForTesting::GetTabDiscardsInfo(GetTabDiscardsInfoCallback callback) {
  GetForwardingInterface()->GetTabDiscardsInfo(std::move(callback));
}
void DiscardsDetailsProviderInterceptorForTesting::GetSiteCharacteristicsDatabase(const std::vector<std::string>& explicitly_requested_origins, GetSiteCharacteristicsDatabaseCallback callback) {
  GetForwardingInterface()->GetSiteCharacteristicsDatabase(std::move(explicitly_requested_origins), std::move(callback));
}
void DiscardsDetailsProviderInterceptorForTesting::GetSiteCharacteristicsDatabaseSize(GetSiteCharacteristicsDatabaseSizeCallback callback) {
  GetForwardingInterface()->GetSiteCharacteristicsDatabaseSize(std::move(callback));
}
void DiscardsDetailsProviderInterceptorForTesting::SetAutoDiscardable(int32_t tab_id, bool is_auto_discardable, SetAutoDiscardableCallback callback) {
  GetForwardingInterface()->SetAutoDiscardable(std::move(tab_id), std::move(is_auto_discardable), std::move(callback));
}
void DiscardsDetailsProviderInterceptorForTesting::DiscardById(int32_t tab_id, bool urgent, DiscardByIdCallback callback) {
  GetForwardingInterface()->DiscardById(std::move(tab_id), std::move(urgent), std::move(callback));
}
void DiscardsDetailsProviderInterceptorForTesting::FreezeById(int32_t tab_id) {
  GetForwardingInterface()->FreezeById(std::move(tab_id));
}
void DiscardsDetailsProviderInterceptorForTesting::LoadById(int32_t tab_id) {
  GetForwardingInterface()->LoadById(std::move(tab_id));
}
void DiscardsDetailsProviderInterceptorForTesting::Discard(bool urgent, DiscardCallback callback) {
  GetForwardingInterface()->Discard(std::move(urgent), std::move(callback));
}
DiscardsDetailsProviderAsyncWaiter::DiscardsDetailsProviderAsyncWaiter(
    DiscardsDetailsProvider* proxy) : proxy_(proxy) {}

DiscardsDetailsProviderAsyncWaiter::~DiscardsDetailsProviderAsyncWaiter() = default;

void DiscardsDetailsProviderAsyncWaiter::GetTabDiscardsInfo(
    std::vector<TabDiscardsInfoPtr>* out_infos) {
  base::RunLoop loop;
  proxy_->GetTabDiscardsInfo(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<TabDiscardsInfoPtr>* out_infos
,
             std::vector<TabDiscardsInfoPtr> infos) {*out_infos = std::move(infos);
            loop->Quit();
          },
          &loop,
          out_infos));
  loop.Run();
}
void DiscardsDetailsProviderAsyncWaiter::GetSiteCharacteristicsDatabase(
    const std::vector<std::string>& explicitly_requested_origins, SiteCharacteristicsDatabasePtr* out_result) {
  base::RunLoop loop;
  proxy_->GetSiteCharacteristicsDatabase(std::move(explicitly_requested_origins),
      base::BindOnce(
          [](base::RunLoop* loop,
             SiteCharacteristicsDatabasePtr* out_result
,
             SiteCharacteristicsDatabasePtr result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}
void DiscardsDetailsProviderAsyncWaiter::GetSiteCharacteristicsDatabaseSize(
    SiteCharacteristicsDatabaseSizePtr* out_db_size) {
  base::RunLoop loop;
  proxy_->GetSiteCharacteristicsDatabaseSize(
      base::BindOnce(
          [](base::RunLoop* loop,
             SiteCharacteristicsDatabaseSizePtr* out_db_size
,
             SiteCharacteristicsDatabaseSizePtr db_size) {*out_db_size = std::move(db_size);
            loop->Quit();
          },
          &loop,
          out_db_size));
  loop.Run();
}
void DiscardsDetailsProviderAsyncWaiter::SetAutoDiscardable(
    int32_t tab_id, bool is_auto_discardable) {
  base::RunLoop loop;
  proxy_->SetAutoDiscardable(std::move(tab_id),std::move(is_auto_discardable),
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}
void DiscardsDetailsProviderAsyncWaiter::DiscardById(
    int32_t tab_id, bool urgent) {
  base::RunLoop loop;
  proxy_->DiscardById(std::move(tab_id),std::move(urgent),
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}
void DiscardsDetailsProviderAsyncWaiter::Discard(
    bool urgent) {
  base::RunLoop loop;
  proxy_->Discard(std::move(urgent),
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}





}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif