// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/browser/ui/webui/discards/discards.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/browser/ui/webui/discards/discards.mojom-params-data.h"
#include "chrome/browser/ui/webui/discards/discards.mojom-shared-message-ids.h"

#include "chrome/browser/ui/webui/discards/discards.mojom-import-headers.h"


#ifndef CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_JUMBO_H_
#define CHROME_BROWSER_UI_WEBUI_DISCARDS_DISCARDS_MOJOM_JUMBO_H_
#endif
namespace mojom {
SiteCharacteristicsFeature::SiteCharacteristicsFeature()
    : observation_duration(),
      use_timestamp() {}

SiteCharacteristicsFeature::SiteCharacteristicsFeature(
    int64_t observation_duration_in,
    int64_t use_timestamp_in)
    : observation_duration(std::move(observation_duration_in)),
      use_timestamp(std::move(use_timestamp_in)) {}

SiteCharacteristicsFeature::~SiteCharacteristicsFeature() = default;
size_t SiteCharacteristicsFeature::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->observation_duration);
  seed = mojo::internal::Hash(seed, this->use_timestamp);
  return seed;
}

bool SiteCharacteristicsFeature::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SiteCharacteristicsPerformanceMeasurement::SiteCharacteristicsPerformanceMeasurement()
    : avg_cpu_usage_us(),
      avg_footprint_kb(),
      avg_load_duration_us() {}

SiteCharacteristicsPerformanceMeasurement::SiteCharacteristicsPerformanceMeasurement(
    float avg_cpu_usage_us_in,
    float avg_footprint_kb_in,
    float avg_load_duration_us_in)
    : avg_cpu_usage_us(std::move(avg_cpu_usage_us_in)),
      avg_footprint_kb(std::move(avg_footprint_kb_in)),
      avg_load_duration_us(std::move(avg_load_duration_us_in)) {}

SiteCharacteristicsPerformanceMeasurement::~SiteCharacteristicsPerformanceMeasurement() = default;
size_t SiteCharacteristicsPerformanceMeasurement::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->avg_cpu_usage_us);
  seed = mojo::internal::Hash(seed, this->avg_footprint_kb);
  seed = mojo::internal::Hash(seed, this->avg_load_duration_us);
  return seed;
}

bool SiteCharacteristicsPerformanceMeasurement::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SiteCharacteristicsDatabaseSize::SiteCharacteristicsDatabaseSize()
    : num_rows(),
      on_disk_size_kb() {}

SiteCharacteristicsDatabaseSize::SiteCharacteristicsDatabaseSize(
    int64_t num_rows_in,
    int64_t on_disk_size_kb_in)
    : num_rows(std::move(num_rows_in)),
      on_disk_size_kb(std::move(on_disk_size_kb_in)) {}

SiteCharacteristicsDatabaseSize::~SiteCharacteristicsDatabaseSize() = default;
size_t SiteCharacteristicsDatabaseSize::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->num_rows);
  seed = mojo::internal::Hash(seed, this->on_disk_size_kb);
  return seed;
}

bool SiteCharacteristicsDatabaseSize::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SiteCharacteristicsDatabaseValue::SiteCharacteristicsDatabaseValue()
    : last_loaded(),
      updates_favicon_in_background(),
      updates_title_in_background(),
      uses_audio_in_background(),
      uses_notifications_in_background(),
      load_time_estimates() {}

SiteCharacteristicsDatabaseValue::SiteCharacteristicsDatabaseValue(
    uint32_t last_loaded_in,
    SiteCharacteristicsFeaturePtr updates_favicon_in_background_in,
    SiteCharacteristicsFeaturePtr updates_title_in_background_in,
    SiteCharacteristicsFeaturePtr uses_audio_in_background_in,
    SiteCharacteristicsFeaturePtr uses_notifications_in_background_in,
    SiteCharacteristicsPerformanceMeasurementPtr load_time_estimates_in)
    : last_loaded(std::move(last_loaded_in)),
      updates_favicon_in_background(std::move(updates_favicon_in_background_in)),
      updates_title_in_background(std::move(updates_title_in_background_in)),
      uses_audio_in_background(std::move(uses_audio_in_background_in)),
      uses_notifications_in_background(std::move(uses_notifications_in_background_in)),
      load_time_estimates(std::move(load_time_estimates_in)) {}

SiteCharacteristicsDatabaseValue::~SiteCharacteristicsDatabaseValue() = default;

bool SiteCharacteristicsDatabaseValue::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SiteCharacteristicsDatabaseEntry::SiteCharacteristicsDatabaseEntry()
    : origin(),
      is_dirty(),
      value() {}

SiteCharacteristicsDatabaseEntry::SiteCharacteristicsDatabaseEntry(
    const std::string& origin_in,
    bool is_dirty_in,
    SiteCharacteristicsDatabaseValuePtr value_in)
    : origin(std::move(origin_in)),
      is_dirty(std::move(is_dirty_in)),
      value(std::move(value_in)) {}

SiteCharacteristicsDatabaseEntry::~SiteCharacteristicsDatabaseEntry() = default;

bool SiteCharacteristicsDatabaseEntry::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SiteCharacteristicsDatabase::SiteCharacteristicsDatabase()
    : db_rows() {}

SiteCharacteristicsDatabase::SiteCharacteristicsDatabase(
    std::vector<SiteCharacteristicsDatabaseEntryPtr> db_rows_in)
    : db_rows(std::move(db_rows_in)) {}

SiteCharacteristicsDatabase::~SiteCharacteristicsDatabase() = default;

bool SiteCharacteristicsDatabase::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
TabDiscardsInfo::TabDiscardsInfo()
    : tab_url(),
      title(),
      visibility(),
      loading_state(),
      state(),
      can_freeze(),
      cannot_freeze_reasons(),
      can_discard(),
      cannot_discard_reasons(),
      discard_count(),
      discard_reason(),
      utility_rank(),
      last_active_seconds(),
      id(),
      is_auto_discardable(),
      has_reactivation_score(),
      reactivation_score(),
      site_engagement_score(),
      has_focus() {}

TabDiscardsInfo::TabDiscardsInfo(
    const std::string& tab_url_in,
    const std::string& title_in,
    LifecycleUnitVisibility visibility_in,
    ::mojom::LifecycleUnitLoadingState loading_state_in,
    ::mojom::LifecycleUnitState state_in,
    bool can_freeze_in,
    const std::vector<std::string>& cannot_freeze_reasons_in,
    bool can_discard_in,
    const std::vector<std::string>& cannot_discard_reasons_in,
    int32_t discard_count_in,
    ::mojom::LifecycleUnitDiscardReason discard_reason_in,
    int32_t utility_rank_in,
    int32_t last_active_seconds_in,
    int32_t id_in,
    bool is_auto_discardable_in,
    bool has_reactivation_score_in,
    double reactivation_score_in,
    double site_engagement_score_in,
    bool has_focus_in)
    : tab_url(std::move(tab_url_in)),
      title(std::move(title_in)),
      visibility(std::move(visibility_in)),
      loading_state(std::move(loading_state_in)),
      state(std::move(state_in)),
      can_freeze(std::move(can_freeze_in)),
      cannot_freeze_reasons(std::move(cannot_freeze_reasons_in)),
      can_discard(std::move(can_discard_in)),
      cannot_discard_reasons(std::move(cannot_discard_reasons_in)),
      discard_count(std::move(discard_count_in)),
      discard_reason(std::move(discard_reason_in)),
      utility_rank(std::move(utility_rank_in)),
      last_active_seconds(std::move(last_active_seconds_in)),
      id(std::move(id_in)),
      is_auto_discardable(std::move(is_auto_discardable_in)),
      has_reactivation_score(std::move(has_reactivation_score_in)),
      reactivation_score(std::move(reactivation_score_in)),
      site_engagement_score(std::move(site_engagement_score_in)),
      has_focus(std::move(has_focus_in)) {}

TabDiscardsInfo::~TabDiscardsInfo() = default;

bool TabDiscardsInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char DiscardsDetailsProvider::Name_[] = "mojom.DiscardsDetailsProvider";

class DiscardsDetailsProvider_GetTabDiscardsInfo_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_GetTabDiscardsInfo_ForwardToCallback(
      DiscardsDetailsProvider::GetTabDiscardsInfoCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::GetTabDiscardsInfoCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetTabDiscardsInfo_ForwardToCallback);
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ForwardToCallback(
      DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ForwardToCallback);
};

class DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ForwardToCallback(
      DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ForwardToCallback);
};

class DiscardsDetailsProvider_SetAutoDiscardable_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_SetAutoDiscardable_ForwardToCallback(
      DiscardsDetailsProvider::SetAutoDiscardableCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::SetAutoDiscardableCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_SetAutoDiscardable_ForwardToCallback);
};

class DiscardsDetailsProvider_DiscardById_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_DiscardById_ForwardToCallback(
      DiscardsDetailsProvider::DiscardByIdCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::DiscardByIdCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_DiscardById_ForwardToCallback);
};

class DiscardsDetailsProvider_Discard_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  DiscardsDetailsProvider_Discard_ForwardToCallback(
      DiscardsDetailsProvider::DiscardCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  DiscardsDetailsProvider::DiscardCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_Discard_ForwardToCallback);
};

DiscardsDetailsProviderProxy::DiscardsDetailsProviderProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void DiscardsDetailsProviderProxy::GetTabDiscardsInfo(
    GetTabDiscardsInfoCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetTabDiscardsInfo");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetTabDiscardsInfo");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_GetTabDiscardsInfo_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DiscardsDetailsProviderProxy::GetSiteCharacteristicsDatabase(
    const std::vector<std::string>& in_explicitly_requested_origins, GetSiteCharacteristicsDatabaseCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabase");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->explicitly_requested_origins)::BaseType::BufferWriter
      explicitly_requested_origins_writer;
  const mojo::internal::ContainerValidateParams explicitly_requested_origins_validate_params(
      0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
  mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
      in_explicitly_requested_origins, buffer, &explicitly_requested_origins_writer, &explicitly_requested_origins_validate_params,
      &serialization_context);
  params->explicitly_requested_origins.Set(
      explicitly_requested_origins_writer.is_null() ? nullptr : explicitly_requested_origins_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->explicitly_requested_origins.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null explicitly_requested_origins in DiscardsDetailsProvider.GetSiteCharacteristicsDatabase request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetSiteCharacteristicsDatabase");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DiscardsDetailsProviderProxy::GetSiteCharacteristicsDatabaseSize(
    GetSiteCharacteristicsDatabaseSizeCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSize");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetSiteCharacteristicsDatabaseSize");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DiscardsDetailsProviderProxy::SetAutoDiscardable(
    int32_t in_tab_id, bool in_is_auto_discardable, SetAutoDiscardableCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::SetAutoDiscardable");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->tab_id = in_tab_id;
  params->is_auto_discardable = in_is_auto_discardable;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("SetAutoDiscardable");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_SetAutoDiscardable_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DiscardsDetailsProviderProxy::DiscardById(
    int32_t in_tab_id, bool in_urgent, DiscardByIdCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardById");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_DiscardById_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_DiscardById_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->tab_id = in_tab_id;
  params->urgent = in_urgent;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("DiscardById");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_DiscardById_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void DiscardsDetailsProviderProxy::FreezeById(
    int32_t in_tab_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::FreezeById");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_FreezeById_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_FreezeById_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->tab_id = in_tab_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("FreezeById");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DiscardsDetailsProviderProxy::LoadById(
    int32_t in_tab_id) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::LoadById");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_LoadById_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_LoadById_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->tab_id = in_tab_id;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("LoadById");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

void DiscardsDetailsProviderProxy::Discard(
    bool in_urgent, DiscardCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::Discard");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_Discard_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_Discard_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->urgent = in_urgent;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("Discard");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new DiscardsDetailsProvider_Discard_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::GetTabDiscardsInfoCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::GetTabDiscardsInfoCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      std::vector<TabDiscardsInfoPtr> in_infos);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder);
};

bool DiscardsDetailsProvider_GetTabDiscardsInfo_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetTabDiscardsInfoCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  std::vector<TabDiscardsInfoPtr> p_infos{};
  DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadInfos(&p_infos))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::GetTabDiscardsInfo response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_infos));
  return true;
}

void DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder::Run(
    std::vector<TabDiscardsInfoPtr> in_infos) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->infos)::BaseType::BufferWriter
      infos_writer;
  const mojo::internal::ContainerValidateParams infos_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::mojom::TabDiscardsInfoDataView>>(
      in_infos, buffer, &infos_writer, &infos_validate_params,
      &serialization_context);
  params->infos.Set(
      infos_writer.is_null() ? nullptr : infos_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->infos.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null infos in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetTabDiscardsInfoCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetTabDiscardsInfo");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      SiteCharacteristicsDatabasePtr in_result);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder);
};

bool DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  SiteCharacteristicsDatabasePtr p_result{};
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::GetSiteCharacteristicsDatabase response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder::Run(
    SiteCharacteristicsDatabasePtr in_result) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->result)::BaseType::BufferWriter
      result_writer;
  mojo::internal::Serialize<::mojom::SiteCharacteristicsDatabaseDataView>(
      in_result, buffer, &result_writer, &serialization_context);
  params->result.Set(
      result_writer.is_null() ? nullptr : result_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetSiteCharacteristicsDatabase");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      SiteCharacteristicsDatabaseSizePtr in_db_size);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder);
};

bool DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  SiteCharacteristicsDatabaseSizePtr p_db_size{};
  DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadDbSize(&p_db_size))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSize response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_db_size));
  return true;
}

void DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder::Run(
    SiteCharacteristicsDatabaseSizePtr in_db_size) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->db_size)::BaseType::BufferWriter
      db_size_writer;
  mojo::internal::Serialize<::mojom::SiteCharacteristicsDatabaseSizeDataView>(
      in_db_size, buffer, &db_size_writer, &serialization_context);
  params->db_size.Set(
      db_size_writer.is_null() ? nullptr : db_size_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("GetSiteCharacteristicsDatabaseSize");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::SetAutoDiscardableCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::SetAutoDiscardableCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder);
};

bool DiscardsDetailsProvider_SetAutoDiscardable_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::SetAutoDiscardableCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  DiscardsDetailsProvider_SetAutoDiscardable_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::SetAutoDiscardable response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::SetAutoDiscardableCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("SetAutoDiscardable");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DiscardsDetailsProvider_DiscardById_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::DiscardByIdCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_DiscardById_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_DiscardById_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_DiscardById_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_DiscardById_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_DiscardById_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::DiscardByIdCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_DiscardById_ProxyToResponder);
};

bool DiscardsDetailsProvider_DiscardById_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardByIdCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  DiscardsDetailsProvider_DiscardById_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::DiscardById response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void DiscardsDetailsProvider_DiscardById_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_DiscardById_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardByIdCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("DiscardById");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class DiscardsDetailsProvider_Discard_ProxyToResponder {
 public:
  static DiscardsDetailsProvider::DiscardCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<DiscardsDetailsProvider_Discard_ProxyToResponder> proxy(
        new DiscardsDetailsProvider_Discard_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&DiscardsDetailsProvider_Discard_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~DiscardsDetailsProvider_Discard_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  DiscardsDetailsProvider_Discard_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "DiscardsDetailsProvider::DiscardCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      );

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(DiscardsDetailsProvider_Discard_ProxyToResponder);
};

bool DiscardsDetailsProvider_Discard_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::DiscardsDetailsProvider_Discard_ResponseParams_Data* params =
      reinterpret_cast<
          internal::DiscardsDetailsProvider_Discard_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  DiscardsDetailsProvider_Discard_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "DiscardsDetailsProvider::Discard response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run();
  return true;
}

void DiscardsDetailsProvider_Discard_ProxyToResponder::Run(
    ) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kDiscardsDetailsProvider_Discard_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::mojom::internal::DiscardsDetailsProvider_Discard_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(DiscardsDetailsProvider::Name_);
  message.set_method_name("Discard");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool DiscardsDetailsProviderStubDispatch::Accept(
    DiscardsDetailsProvider* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetTabDiscardsInfo",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabase",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSize",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::SetAutoDiscardable",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_DiscardById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardById",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_FreezeById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::FreezeById",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DiscardsDetailsProvider_FreezeById_Params_Data* params =
          reinterpret_cast<internal::DiscardsDetailsProvider_FreezeById_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_tab_id{};
      DiscardsDetailsProvider_FreezeById_ParamsDataView input_data_view(params, &serialization_context);
      
      p_tab_id = input_data_view.tab_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::FreezeById deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->FreezeById(
std::move(p_tab_id));
      return true;
    }
    case internal::kDiscardsDetailsProvider_LoadById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::LoadById",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::DiscardsDetailsProvider_LoadById_Params_Data* params =
          reinterpret_cast<internal::DiscardsDetailsProvider_LoadById_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_tab_id{};
      DiscardsDetailsProvider_LoadById_ParamsDataView input_data_view(params, &serialization_context);
      
      p_tab_id = input_data_view.tab_id();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::LoadById deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->LoadById(
std::move(p_tab_id));
      return true;
    }
    case internal::kDiscardsDetailsProvider_Discard_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::Discard",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

// static
bool DiscardsDetailsProviderStubDispatch::AcceptWithResponder(
    DiscardsDetailsProvider* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetTabDiscardsInfo",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DiscardsDetailsProvider_GetTabDiscardsInfo_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::GetTabDiscardsInfo deserializer");
        return false;
      }
      DiscardsDetailsProvider::GetTabDiscardsInfoCallback callback =
          DiscardsDetailsProvider_GetTabDiscardsInfo_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetTabDiscardsInfo(std::move(callback));
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabase",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::vector<std::string> p_explicitly_requested_origins{};
      DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadExplicitlyRequestedOrigins(&p_explicitly_requested_origins))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::GetSiteCharacteristicsDatabase deserializer");
        return false;
      }
      DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseCallback callback =
          DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetSiteCharacteristicsDatabase(
std::move(p_explicitly_requested_origins), std::move(callback));
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSize",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSize deserializer");
        return false;
      }
      DiscardsDetailsProvider::GetSiteCharacteristicsDatabaseSizeCallback callback =
          DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetSiteCharacteristicsDatabaseSize(std::move(callback));
      return true;
    }
    case internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::SetAutoDiscardable",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_tab_id{};
      bool p_is_auto_discardable{};
      DiscardsDetailsProvider_SetAutoDiscardable_ParamsDataView input_data_view(params, &serialization_context);
      
      p_tab_id = input_data_view.tab_id();
      p_is_auto_discardable = input_data_view.is_auto_discardable();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::SetAutoDiscardable deserializer");
        return false;
      }
      DiscardsDetailsProvider::SetAutoDiscardableCallback callback =
          DiscardsDetailsProvider_SetAutoDiscardable_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetAutoDiscardable(
std::move(p_tab_id), 
std::move(p_is_auto_discardable), std::move(callback));
      return true;
    }
    case internal::kDiscardsDetailsProvider_DiscardById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::DiscardById",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_DiscardById_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_DiscardById_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      int32_t p_tab_id{};
      bool p_urgent{};
      DiscardsDetailsProvider_DiscardById_ParamsDataView input_data_view(params, &serialization_context);
      
      p_tab_id = input_data_view.tab_id();
      p_urgent = input_data_view.urgent();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::DiscardById deserializer");
        return false;
      }
      DiscardsDetailsProvider::DiscardByIdCallback callback =
          DiscardsDetailsProvider_DiscardById_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->DiscardById(
std::move(p_tab_id), 
std::move(p_urgent), std::move(callback));
      return true;
    }
    case internal::kDiscardsDetailsProvider_FreezeById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::FreezeById",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_LoadById_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::LoadById",
               "message", message->name());
#endif
      break;
    }
    case internal::kDiscardsDetailsProvider_Discard_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::DiscardsDetailsProvider::Discard",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::DiscardsDetailsProvider_Discard_Params_Data* params =
          reinterpret_cast<
              internal::DiscardsDetailsProvider_Discard_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      bool p_urgent{};
      DiscardsDetailsProvider_Discard_ParamsDataView input_data_view(params, &serialization_context);
      
      p_urgent = input_data_view.urgent();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "DiscardsDetailsProvider::Discard deserializer");
        return false;
      }
      DiscardsDetailsProvider::DiscardCallback callback =
          DiscardsDetailsProvider_Discard_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Discard(
std::move(p_urgent), std::move(callback));
      return true;
    }
  }
  return false;
}

bool DiscardsDetailsProviderRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DiscardsDetailsProvider RequestValidator");

  switch (message->header()->name) {
    case internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetTabDiscardsInfo_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_SetAutoDiscardable_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_DiscardById_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_DiscardById_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_FreezeById_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_FreezeById_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_LoadById_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_LoadById_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_Discard_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_Discard_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool DiscardsDetailsProviderResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "DiscardsDetailsProvider ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kDiscardsDetailsProvider_GetTabDiscardsInfo_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetTabDiscardsInfo_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabase_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabase_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_GetSiteCharacteristicsDatabaseSize_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_SetAutoDiscardable_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_SetAutoDiscardable_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_DiscardById_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_DiscardById_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kDiscardsDetailsProvider_Discard_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::DiscardsDetailsProvider_Discard_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom

namespace mojo {


// static
bool StructTraits<::mojom::SiteCharacteristicsFeature::DataView, ::mojom::SiteCharacteristicsFeaturePtr>::Read(
    ::mojom::SiteCharacteristicsFeature::DataView input,
    ::mojom::SiteCharacteristicsFeaturePtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsFeaturePtr result(::mojom::SiteCharacteristicsFeature::New());
  
      result->observation_duration = input.observation_duration();
      result->use_timestamp = input.use_timestamp();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::SiteCharacteristicsPerformanceMeasurement::DataView, ::mojom::SiteCharacteristicsPerformanceMeasurementPtr>::Read(
    ::mojom::SiteCharacteristicsPerformanceMeasurement::DataView input,
    ::mojom::SiteCharacteristicsPerformanceMeasurementPtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsPerformanceMeasurementPtr result(::mojom::SiteCharacteristicsPerformanceMeasurement::New());
  
      result->avg_cpu_usage_us = input.avg_cpu_usage_us();
      result->avg_footprint_kb = input.avg_footprint_kb();
      result->avg_load_duration_us = input.avg_load_duration_us();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::SiteCharacteristicsDatabaseSize::DataView, ::mojom::SiteCharacteristicsDatabaseSizePtr>::Read(
    ::mojom::SiteCharacteristicsDatabaseSize::DataView input,
    ::mojom::SiteCharacteristicsDatabaseSizePtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsDatabaseSizePtr result(::mojom::SiteCharacteristicsDatabaseSize::New());
  
      result->num_rows = input.num_rows();
      result->on_disk_size_kb = input.on_disk_size_kb();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::SiteCharacteristicsDatabaseValue::DataView, ::mojom::SiteCharacteristicsDatabaseValuePtr>::Read(
    ::mojom::SiteCharacteristicsDatabaseValue::DataView input,
    ::mojom::SiteCharacteristicsDatabaseValuePtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsDatabaseValuePtr result(::mojom::SiteCharacteristicsDatabaseValue::New());
  
      result->last_loaded = input.last_loaded();
      if (!input.ReadUpdatesFaviconInBackground(&result->updates_favicon_in_background))
        success = false;
      if (!input.ReadUpdatesTitleInBackground(&result->updates_title_in_background))
        success = false;
      if (!input.ReadUsesAudioInBackground(&result->uses_audio_in_background))
        success = false;
      if (!input.ReadUsesNotificationsInBackground(&result->uses_notifications_in_background))
        success = false;
      if (!input.ReadLoadTimeEstimates(&result->load_time_estimates))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::SiteCharacteristicsDatabaseEntry::DataView, ::mojom::SiteCharacteristicsDatabaseEntryPtr>::Read(
    ::mojom::SiteCharacteristicsDatabaseEntry::DataView input,
    ::mojom::SiteCharacteristicsDatabaseEntryPtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsDatabaseEntryPtr result(::mojom::SiteCharacteristicsDatabaseEntry::New());
  
      if (!input.ReadOrigin(&result->origin))
        success = false;
      result->is_dirty = input.is_dirty();
      if (!input.ReadValue(&result->value))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::SiteCharacteristicsDatabase::DataView, ::mojom::SiteCharacteristicsDatabasePtr>::Read(
    ::mojom::SiteCharacteristicsDatabase::DataView input,
    ::mojom::SiteCharacteristicsDatabasePtr* output) {
  bool success = true;
  ::mojom::SiteCharacteristicsDatabasePtr result(::mojom::SiteCharacteristicsDatabase::New());
  
      if (!input.ReadDbRows(&result->db_rows))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::mojom::TabDiscardsInfo::DataView, ::mojom::TabDiscardsInfoPtr>::Read(
    ::mojom::TabDiscardsInfo::DataView input,
    ::mojom::TabDiscardsInfoPtr* output) {
  bool success = true;
  ::mojom::TabDiscardsInfoPtr result(::mojom::TabDiscardsInfo::New());
  
      if (!input.ReadTabUrl(&result->tab_url))
        success = false;
      if (!input.ReadTitle(&result->title))
        success = false;
      if (!input.ReadVisibility(&result->visibility))
        success = false;
      if (!input.ReadLoadingState(&result->loading_state))
        success = false;
      if (!input.ReadState(&result->state))
        success = false;
      result->can_freeze = input.can_freeze();
      if (!input.ReadCannotFreezeReasons(&result->cannot_freeze_reasons))
        success = false;
      result->can_discard = input.can_discard();
      if (!input.ReadCannotDiscardReasons(&result->cannot_discard_reasons))
        success = false;
      result->discard_count = input.discard_count();
      if (!input.ReadDiscardReason(&result->discard_reason))
        success = false;
      result->utility_rank = input.utility_rank();
      result->last_active_seconds = input.last_active_seconds();
      result->id = input.id();
      result->is_auto_discardable = input.is_auto_discardable();
      result->has_reactivation_score = input.has_reactivation_score();
      result->reactivation_score = input.reactivation_score();
      result->site_engagement_score = input.site_engagement_score();
      result->has_focus = input.has_focus();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif