// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_OMNIBOX_OMNIBOX_MOJOM_PARAMS_DATA_H_
#define CHROME_BROWSER_UI_WEBUI_OMNIBOX_OMNIBOX_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace mojom {
namespace internal {
class  OmniboxPageHandler_SetClientPage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OmniboxPageHandler_SetClientPage_Params_Data));
      new (data()) OmniboxPageHandler_SetClientPage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OmniboxPageHandler_SetClientPage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OmniboxPageHandler_SetClientPage_Params_Data>(index_);
    }
    OmniboxPageHandler_SetClientPage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data page;

 private:
  OmniboxPageHandler_SetClientPage_Params_Data();
  ~OmniboxPageHandler_SetClientPage_Params_Data() = delete;
};
static_assert(sizeof(OmniboxPageHandler_SetClientPage_Params_Data) == 16,
              "Bad sizeof(OmniboxPageHandler_SetClientPage_Params_Data)");
class  OmniboxPageHandler_StartOmniboxQuery_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OmniboxPageHandler_StartOmniboxQuery_Params_Data));
      new (data()) OmniboxPageHandler_StartOmniboxQuery_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OmniboxPageHandler_StartOmniboxQuery_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OmniboxPageHandler_StartOmniboxQuery_Params_Data>(index_);
    }
    OmniboxPageHandler_StartOmniboxQuery_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> input_string;
  uint8_t reset_autocomplete_controller : 1;
  uint8_t zero_suggest : 1;
  uint8_t prevent_inline_autocomplete : 1;
  uint8_t prefer_keyword : 1;
  uint8_t pad4_[3];
  int32_t cursor_position;
  mojo::internal::Pointer<mojo::internal::String_Data> current_url;
  int32_t page_classification;
  uint8_t padfinal_[4];

 private:
  OmniboxPageHandler_StartOmniboxQuery_Params_Data();
  ~OmniboxPageHandler_StartOmniboxQuery_Params_Data() = delete;
};
static_assert(sizeof(OmniboxPageHandler_StartOmniboxQuery_Params_Data) == 40,
              "Bad sizeof(OmniboxPageHandler_StartOmniboxQuery_Params_Data)");
class  OmniboxPage_handleNewAutocompleteResponse_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OmniboxPage_handleNewAutocompleteResponse_Params_Data));
      new (data()) OmniboxPage_handleNewAutocompleteResponse_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OmniboxPage_handleNewAutocompleteResponse_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OmniboxPage_handleNewAutocompleteResponse_Params_Data>(index_);
    }
    OmniboxPage_handleNewAutocompleteResponse_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::OmniboxResponse_Data> response;
  uint8_t isPageController : 1;
  uint8_t padfinal_[7];

 private:
  OmniboxPage_handleNewAutocompleteResponse_Params_Data();
  ~OmniboxPage_handleNewAutocompleteResponse_Params_Data() = delete;
};
static_assert(sizeof(OmniboxPage_handleNewAutocompleteResponse_Params_Data) == 24,
              "Bad sizeof(OmniboxPage_handleNewAutocompleteResponse_Params_Data)");
class  OmniboxPage_HandleNewAutocompleteQuery_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OmniboxPage_HandleNewAutocompleteQuery_Params_Data));
      new (data()) OmniboxPage_HandleNewAutocompleteQuery_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OmniboxPage_HandleNewAutocompleteQuery_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OmniboxPage_HandleNewAutocompleteQuery_Params_Data>(index_);
    }
    OmniboxPage_HandleNewAutocompleteQuery_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t isPageController : 1;
  uint8_t padfinal_[7];

 private:
  OmniboxPage_HandleNewAutocompleteQuery_Params_Data();
  ~OmniboxPage_HandleNewAutocompleteQuery_Params_Data() = delete;
};
static_assert(sizeof(OmniboxPage_HandleNewAutocompleteQuery_Params_Data) == 16,
              "Bad sizeof(OmniboxPage_HandleNewAutocompleteQuery_Params_Data)");
class  OmniboxPage_HandleAnswerImageData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OmniboxPage_HandleAnswerImageData_Params_Data));
      new (data()) OmniboxPage_HandleAnswerImageData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OmniboxPage_HandleAnswerImageData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OmniboxPage_HandleAnswerImageData_Params_Data>(index_);
    }
    OmniboxPage_HandleAnswerImageData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> image_url;
  mojo::internal::Pointer<mojo::internal::String_Data> image_data;

 private:
  OmniboxPage_HandleAnswerImageData_Params_Data();
  ~OmniboxPage_HandleAnswerImageData_Params_Data() = delete;
};
static_assert(sizeof(OmniboxPage_HandleAnswerImageData_Params_Data) == 24,
              "Bad sizeof(OmniboxPage_HandleAnswerImageData_Params_Data)");

}  // namespace internal
class OmniboxPageHandler_SetClientPage_ParamsDataView {
 public:
  OmniboxPageHandler_SetClientPage_ParamsDataView() {}

  OmniboxPageHandler_SetClientPage_ParamsDataView(
      internal::OmniboxPageHandler_SetClientPage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakePage() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::mojom::OmniboxPagePtrDataView>(
            &data_->page, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::OmniboxPageHandler_SetClientPage_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OmniboxPageHandler_StartOmniboxQuery_ParamsDataView {
 public:
  OmniboxPageHandler_StartOmniboxQuery_ParamsDataView() {}

  OmniboxPageHandler_StartOmniboxQuery_ParamsDataView(
      internal::OmniboxPageHandler_StartOmniboxQuery_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInputStringDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInputString(UserType* output) {
    auto* pointer = data_->input_string.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  bool reset_autocomplete_controller() const {
    return data_->reset_autocomplete_controller;
  }
  int32_t cursor_position() const {
    return data_->cursor_position;
  }
  bool zero_suggest() const {
    return data_->zero_suggest;
  }
  bool prevent_inline_autocomplete() const {
    return data_->prevent_inline_autocomplete;
  }
  bool prefer_keyword() const {
    return data_->prefer_keyword;
  }
  inline void GetCurrentUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCurrentUrl(UserType* output) {
    auto* pointer = data_->current_url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  int32_t page_classification() const {
    return data_->page_classification;
  }
 private:
  internal::OmniboxPageHandler_StartOmniboxQuery_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OmniboxPage_handleNewAutocompleteResponse_ParamsDataView {
 public:
  OmniboxPage_handleNewAutocompleteResponse_ParamsDataView() {}

  OmniboxPage_handleNewAutocompleteResponse_ParamsDataView(
      internal::OmniboxPage_handleNewAutocompleteResponse_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetResponseDataView(
      OmniboxResponseDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResponse(UserType* output) {
    auto* pointer = data_->response.Get();
    return mojo::internal::Deserialize<::mojom::OmniboxResponseDataView>(
        pointer, output, context_);
  }
  bool isPageController() const {
    return data_->isPageController;
  }
 private:
  internal::OmniboxPage_handleNewAutocompleteResponse_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class OmniboxPage_HandleNewAutocompleteQuery_ParamsDataView {
 public:
  OmniboxPage_HandleNewAutocompleteQuery_ParamsDataView() {}

  OmniboxPage_HandleNewAutocompleteQuery_ParamsDataView(
      internal::OmniboxPage_HandleNewAutocompleteQuery_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool isPageController() const {
    return data_->isPageController;
  }
 private:
  internal::OmniboxPage_HandleNewAutocompleteQuery_Params_Data* data_ = nullptr;
};

class OmniboxPage_HandleAnswerImageData_ParamsDataView {
 public:
  OmniboxPage_HandleAnswerImageData_ParamsDataView() {}

  OmniboxPage_HandleAnswerImageData_ParamsDataView(
      internal::OmniboxPage_HandleAnswerImageData_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetImageUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImageUrl(UserType* output) {
    auto* pointer = data_->image_url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetImageDataDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadImageData(UserType* output) {
    auto* pointer = data_->image_data.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::OmniboxPage_HandleAnswerImageData_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void OmniboxPageHandler_StartOmniboxQuery_ParamsDataView::GetInputStringDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->input_string.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void OmniboxPageHandler_StartOmniboxQuery_ParamsDataView::GetCurrentUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->current_url.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void OmniboxPage_handleNewAutocompleteResponse_ParamsDataView::GetResponseDataView(
    OmniboxResponseDataView* output) {
  auto pointer = data_->response.Get();
  *output = OmniboxResponseDataView(pointer, context_);
}




inline void OmniboxPage_HandleAnswerImageData_ParamsDataView::GetImageUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->image_url.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void OmniboxPage_HandleAnswerImageData_ParamsDataView::GetImageDataDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->image_data.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_BROWSER_UI_WEBUI_OMNIBOX_OMNIBOX_MOJOM_PARAMS_DATA_H_