// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_BROWSER_UI_WEBUI_SNIPPETS_INTERNALS_SNIPPETS_INTERNALS_MOJOM_SHARED_INTERNAL_H_
#define CHROME_BROWSER_UI_WEBUI_SNIPPETS_INTERNALS_SNIPPETS_INTERNALS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace snippets_internals {
namespace mojom {
namespace internal {
class SuggestionCategory_Data;
class SuggestionItem_Data;

#pragma pack(push, 1)
class  SuggestionCategory_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SuggestionCategory_Data));
      new (data()) SuggestionCategory_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SuggestionCategory_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SuggestionCategory_Data>(index_);
    }
    SuggestionCategory_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t categoryId;
  mojo::internal::Pointer<mojo::internal::String_Data> categoryTitle;
  mojo::internal::Pointer<mojo::internal::String_Data> status;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SuggestionItem_Data>>> suggestions;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::SuggestionItem_Data>>> dismissedSuggestions;

 private:
  SuggestionCategory_Data();
  ~SuggestionCategory_Data() = delete;
};
static_assert(sizeof(SuggestionCategory_Data) == 48,
              "Bad sizeof(SuggestionCategory_Data)");
// Used by SuggestionCategory::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SuggestionCategory_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SuggestionCategory_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SuggestionCategory_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SuggestionCategory_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SuggestionCategory_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  SuggestionItem_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SuggestionItem_Data));
      new (data()) SuggestionItem_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SuggestionItem_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SuggestionItem_Data>(index_);
    }
    SuggestionItem_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> suggestionTitle;
  mojo::internal::Pointer<mojo::internal::String_Data> suggestionId;
  mojo::internal::Pointer<mojo::internal::String_Data> suggestionIdWithinCategory;
  mojo::internal::Pointer<mojo::internal::String_Data> url;
  mojo::internal::Pointer<mojo::internal::String_Data> faviconUrl;
  mojo::internal::Pointer<mojo::internal::String_Data> snippet;
  mojo::internal::Pointer<mojo::internal::String_Data> publishDate;
  mojo::internal::Pointer<mojo::internal::String_Data> publisherName;
  float score;
  uint8_t padfinal_[4];

 private:
  SuggestionItem_Data();
  ~SuggestionItem_Data() = delete;
};
static_assert(sizeof(SuggestionItem_Data) == 80,
              "Bad sizeof(SuggestionItem_Data)");
// Used by SuggestionItem::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct SuggestionItem_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  SuggestionItem_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~SuggestionItem_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    SuggestionItem_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    SuggestionItem_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace snippets_internals

#endif  // CHROME_BROWSER_UI_WEBUI_SNIPPETS_INTERNALS_SNIPPETS_INTERNALS_MOJOM_SHARED_INTERNAL_H_