// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/chrome_render_frame.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "third_party/blink/public/mojom/window_features/window_features.mojom.h"
#include "ui/gfx/geometry/mojo/geometry.mojom.h"


#ifndef CHROME_COMMON_CHROME_RENDER_FRAME_MOJOM_JUMBO_H_
#define CHROME_COMMON_CHROME_RENDER_FRAME_MOJOM_JUMBO_H_
#include "chrome/common/browser_controls_state_param_traits.h"
#include "chrome/common/web_application_info_provider_param_traits.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace chrome {
namespace mojom {


void ChromeRenderFrameInterceptorForTesting::SetWindowFeatures(::blink::mojom::WindowFeaturesPtr window_features) {
  GetForwardingInterface()->SetWindowFeatures(std::move(window_features));
}
void ChromeRenderFrameInterceptorForTesting::RequestReloadImageForContextNode() {
  GetForwardingInterface()->RequestReloadImageForContextNode();
}
void ChromeRenderFrameInterceptorForTesting::RequestThumbnailForContextNode(int32_t thumbnail_min_area_pixels, const gfx::Size& thumbnail_max_size_pixels, ImageFormat image_format, RequestThumbnailForContextNodeCallback callback) {
  GetForwardingInterface()->RequestThumbnailForContextNode(std::move(thumbnail_min_area_pixels), std::move(thumbnail_max_size_pixels), std::move(image_format), std::move(callback));
}
void ChromeRenderFrameInterceptorForTesting::ExecuteWebUIJavaScript(const base::string16& javascript) {
  GetForwardingInterface()->ExecuteWebUIJavaScript(std::move(javascript));
}
void ChromeRenderFrameInterceptorForTesting::SetClientSidePhishingDetection(bool enable_phishing_detection) {
  GetForwardingInterface()->SetClientSidePhishingDetection(std::move(enable_phishing_detection));
}
void ChromeRenderFrameInterceptorForTesting::GetWebApplicationInfo(GetWebApplicationInfoCallback callback) {
  GetForwardingInterface()->GetWebApplicationInfo(std::move(callback));
}
void ChromeRenderFrameInterceptorForTesting::UpdateBrowserControlsState(content::BrowserControlsState constraints, content::BrowserControlsState current, bool animate) {
  GetForwardingInterface()->UpdateBrowserControlsState(std::move(constraints), std::move(current), std::move(animate));
}
ChromeRenderFrameAsyncWaiter::ChromeRenderFrameAsyncWaiter(
    ChromeRenderFrame* proxy) : proxy_(proxy) {}

ChromeRenderFrameAsyncWaiter::~ChromeRenderFrameAsyncWaiter() = default;

void ChromeRenderFrameAsyncWaiter::RequestThumbnailForContextNode(
    int32_t thumbnail_min_area_pixels, const gfx::Size& thumbnail_max_size_pixels, ImageFormat image_format, std::vector<uint8_t>* out_thumbnail_data, gfx::Size* out_original_size) {
  base::RunLoop loop;
  proxy_->RequestThumbnailForContextNode(std::move(thumbnail_min_area_pixels),std::move(thumbnail_max_size_pixels),std::move(image_format),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::vector<uint8_t>* out_thumbnail_data
,
             gfx::Size* out_original_size
,
             const std::vector<uint8_t>& thumbnail_data,
             const gfx::Size& original_size) {*out_thumbnail_data = std::move(thumbnail_data);*out_original_size = std::move(original_size);
            loop->Quit();
          },
          &loop,
          out_thumbnail_data,
          out_original_size));
  loop.Run();
}
void ChromeRenderFrameAsyncWaiter::GetWebApplicationInfo(
    ::WebApplicationInfo* out_web_application_info) {
  base::RunLoop loop;
  proxy_->GetWebApplicationInfo(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::WebApplicationInfo* out_web_application_info
,
             const ::WebApplicationInfo& web_application_info) {*out_web_application_info = std::move(web_application_info);
            loop->Quit();
          },
          &loop,
          out_web_application_info));
  loop.Run();
}





}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif