// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CLIENT_HINTS_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_CLIENT_HINTS_MOJOM_TEST_UTILS_H_

#include "chrome/common/client_hints.mojom.h"


namespace client_hints {
namespace mojom {


class  ClientHintsInterceptorForTesting : public ClientHints {
  virtual ClientHints* GetForwardingInterface() = 0;
  void PersistClientHints(const url::Origin& primary_origin, const std::vector<::blink::mojom::WebClientHintsType>& client_hints, base::TimeDelta expiration_duration) override;
};
class  ClientHintsAsyncWaiter {
 public:
  explicit ClientHintsAsyncWaiter(ClientHints* proxy);
  ~ClientHintsAsyncWaiter();

 private:
  ClientHints* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ClientHintsAsyncWaiter);
};




}  // namespace mojom
}  // namespace client_hints

#endif  // CHROME_COMMON_CLIENT_HINTS_MOJOM_TEST_UTILS_H_