// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_CLOUD_PRINT_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_CLOUD_PRINT_MOJOM_TEST_UTILS_H_

#include "chrome/common/cloud_print.mojom.h"


namespace cloud_print {
namespace mojom {


class  CloudPrintInterceptorForTesting : public CloudPrint {
  virtual CloudPrint* GetForwardingInterface() = 0;
  void EnableCloudPrintProxyWithRobot(const std::string& robot_auth_code, const std::string& robot_email, const std::string& user_email, base::Value user_settings) override;
  void DisableCloudPrintProxy() override;
  void GetCloudPrintProxyInfo(GetCloudPrintProxyInfoCallback callback) override;
  void GetPrinters(GetPrintersCallback callback) override;
};
class  CloudPrintAsyncWaiter {
 public:
  explicit CloudPrintAsyncWaiter(CloudPrint* proxy);
  ~CloudPrintAsyncWaiter();
  void GetCloudPrintProxyInfo(
      bool* out_enabled, std::string* out_email, std::string* out_proxy_id);
  void GetPrinters(
      std::vector<std::string>* out_printers);

 private:
  CloudPrint* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(CloudPrintAsyncWaiter);
};




}  // namespace mojom
}  // namespace cloud_print

#endif  // CHROME_COMMON_CLOUD_PRINT_MOJOM_TEST_UTILS_H_