// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/media_router/mojo/media_controller.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "chrome/common/media_router/mojo/media_status.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"


#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_CONTROLLER_MOJOM_JUMBO_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_CONTROLLER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif


namespace media_router {
namespace mojom {


void MediaControllerInterceptorForTesting::Play() {
  GetForwardingInterface()->Play();
}
void MediaControllerInterceptorForTesting::Pause() {
  GetForwardingInterface()->Pause();
}
void MediaControllerInterceptorForTesting::SetMute(bool mute) {
  GetForwardingInterface()->SetMute(std::move(mute));
}
void MediaControllerInterceptorForTesting::SetVolume(float volume) {
  GetForwardingInterface()->SetVolume(std::move(volume));
}
void MediaControllerInterceptorForTesting::Seek(base::TimeDelta time) {
  GetForwardingInterface()->Seek(std::move(time));
}
void MediaControllerInterceptorForTesting::ConnectHangoutsMediaRouteController(HangoutsMediaRouteControllerRequest controller_request) {
  GetForwardingInterface()->ConnectHangoutsMediaRouteController(std::move(controller_request));
}
MediaControllerAsyncWaiter::MediaControllerAsyncWaiter(
    MediaController* proxy) : proxy_(proxy) {}

MediaControllerAsyncWaiter::~MediaControllerAsyncWaiter() = default;




void HangoutsMediaRouteControllerInterceptorForTesting::SetLocalPresent(bool local_present) {
  GetForwardingInterface()->SetLocalPresent(std::move(local_present));
}
HangoutsMediaRouteControllerAsyncWaiter::HangoutsMediaRouteControllerAsyncWaiter(
    HangoutsMediaRouteController* proxy) : proxy_(proxy) {}

HangoutsMediaRouteControllerAsyncWaiter::~HangoutsMediaRouteControllerAsyncWaiter() = default;






}  // namespace mojom
}  // namespace media_router

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif