// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_CONTROLLER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_CONTROLLER_MOJOM_TEST_UTILS_H_

#include "chrome/common/media_router/mojo/media_controller.mojom.h"


namespace media_router {
namespace mojom {


class  MediaControllerInterceptorForTesting : public MediaController {
  virtual MediaController* GetForwardingInterface() = 0;
  void Play() override;
  void Pause() override;
  void SetMute(bool mute) override;
  void SetVolume(float volume) override;
  void Seek(base::TimeDelta time) override;
  void ConnectHangoutsMediaRouteController(HangoutsMediaRouteControllerRequest controller_request) override;
};
class  MediaControllerAsyncWaiter {
 public:
  explicit MediaControllerAsyncWaiter(MediaController* proxy);
  ~MediaControllerAsyncWaiter();

 private:
  MediaController* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaControllerAsyncWaiter);
};


class  HangoutsMediaRouteControllerInterceptorForTesting : public HangoutsMediaRouteController {
  virtual HangoutsMediaRouteController* GetForwardingInterface() = 0;
  void SetLocalPresent(bool local_present) override;
};
class  HangoutsMediaRouteControllerAsyncWaiter {
 public:
  explicit HangoutsMediaRouteControllerAsyncWaiter(HangoutsMediaRouteController* proxy);
  ~HangoutsMediaRouteControllerAsyncWaiter();

 private:
  HangoutsMediaRouteController* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(HangoutsMediaRouteControllerAsyncWaiter);
};




}  // namespace mojom
}  // namespace media_router

#endif  // CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_CONTROLLER_MOJOM_TEST_UTILS_H_