// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/media_router/mojo/media_router.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "chrome/common/media_router/mojo/media_controller.mojom.h"
#include "chrome/common/media_router/mojo/media_status.mojom.h"
#include "components/mirroring/mojom/mirroring_service_host.mojom.h"
#include "media/mojo/interfaces/mirror_service_remoting.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "services/network/public/mojom/ip_address.mojom.h"
#include "services/network/public/mojom/ip_endpoint.mojom.h"
#include "third_party/blink/public/mojom/presentation/presentation.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_ROUTER_MOJOM_JUMBO_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_ROUTER_MOJOM_JUMBO_H_
#include "chrome/common/media_router/mojo/media_router_struct_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "services/network/public/cpp/ip_address_mojom_traits.h"
#include "services/network/public/cpp/ip_endpoint_mojom_traits.h"
#include "url/mojom/origin_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace media_router {
namespace mojom {


void MediaRouteProviderInterceptorForTesting::CreateRoute(const std::string& media_source, const std::string& sink_id, const std::string& original_presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, CreateRouteCallback callback) {
  GetForwardingInterface()->CreateRoute(std::move(media_source), std::move(sink_id), std::move(original_presentation_id), std::move(origin), std::move(tab_id), std::move(timeout), std::move(incognito), std::move(callback));
}
void MediaRouteProviderInterceptorForTesting::JoinRoute(const std::string& media_source, const std::string& presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, JoinRouteCallback callback) {
  GetForwardingInterface()->JoinRoute(std::move(media_source), std::move(presentation_id), std::move(origin), std::move(tab_id), std::move(timeout), std::move(incognito), std::move(callback));
}
void MediaRouteProviderInterceptorForTesting::ConnectRouteByRouteId(const std::string& media_source, const std::string& route_id, const std::string& presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, ConnectRouteByRouteIdCallback callback) {
  GetForwardingInterface()->ConnectRouteByRouteId(std::move(media_source), std::move(route_id), std::move(presentation_id), std::move(origin), std::move(tab_id), std::move(timeout), std::move(incognito), std::move(callback));
}
void MediaRouteProviderInterceptorForTesting::TerminateRoute(const std::string& route_id, TerminateRouteCallback callback) {
  GetForwardingInterface()->TerminateRoute(std::move(route_id), std::move(callback));
}
void MediaRouteProviderInterceptorForTesting::SendRouteMessage(const std::string& media_route_id, const std::string& message) {
  GetForwardingInterface()->SendRouteMessage(std::move(media_route_id), std::move(message));
}
void MediaRouteProviderInterceptorForTesting::SendRouteBinaryMessage(const std::string& media_route_id, const std::vector<uint8_t>& data) {
  GetForwardingInterface()->SendRouteBinaryMessage(std::move(media_route_id), std::move(data));
}
void MediaRouteProviderInterceptorForTesting::StartObservingMediaSinks(const std::string& media_source) {
  GetForwardingInterface()->StartObservingMediaSinks(std::move(media_source));
}
void MediaRouteProviderInterceptorForTesting::StopObservingMediaSinks(const std::string& media_source) {
  GetForwardingInterface()->StopObservingMediaSinks(std::move(media_source));
}
void MediaRouteProviderInterceptorForTesting::StartObservingMediaRoutes(const std::string& media_source) {
  GetForwardingInterface()->StartObservingMediaRoutes(std::move(media_source));
}
void MediaRouteProviderInterceptorForTesting::StopObservingMediaRoutes(const std::string& media_source) {
  GetForwardingInterface()->StopObservingMediaRoutes(std::move(media_source));
}
void MediaRouteProviderInterceptorForTesting::StartListeningForRouteMessages(const std::string& route_id) {
  GetForwardingInterface()->StartListeningForRouteMessages(std::move(route_id));
}
void MediaRouteProviderInterceptorForTesting::StopListeningForRouteMessages(const std::string& route_id) {
  GetForwardingInterface()->StopListeningForRouteMessages(std::move(route_id));
}
void MediaRouteProviderInterceptorForTesting::DetachRoute(const std::string& route_id) {
  GetForwardingInterface()->DetachRoute(std::move(route_id));
}
void MediaRouteProviderInterceptorForTesting::EnableMdnsDiscovery() {
  GetForwardingInterface()->EnableMdnsDiscovery();
}
void MediaRouteProviderInterceptorForTesting::UpdateMediaSinks(const std::string& media_source) {
  GetForwardingInterface()->UpdateMediaSinks(std::move(media_source));
}
void MediaRouteProviderInterceptorForTesting::SearchSinks(const std::string& sink_id, const std::string& media_source, SinkSearchCriteriaPtr search_criteria, SearchSinksCallback callback) {
  GetForwardingInterface()->SearchSinks(std::move(sink_id), std::move(media_source), std::move(search_criteria), std::move(callback));
}
void MediaRouteProviderInterceptorForTesting::ProvideSinks(const std::string& provider_name, const std::vector<media_router::MediaSinkInternal>& sinks) {
  GetForwardingInterface()->ProvideSinks(std::move(provider_name), std::move(sinks));
}
void MediaRouteProviderInterceptorForTesting::CreateMediaRouteController(const std::string& route_id, ::media_router::mojom::MediaControllerRequest media_controller, ::media_router::mojom::MediaStatusObserverPtr observer, CreateMediaRouteControllerCallback callback) {
  GetForwardingInterface()->CreateMediaRouteController(std::move(route_id), std::move(media_controller), std::move(observer), std::move(callback));
}
MediaRouteProviderAsyncWaiter::MediaRouteProviderAsyncWaiter(
    MediaRouteProvider* proxy) : proxy_(proxy) {}

MediaRouteProviderAsyncWaiter::~MediaRouteProviderAsyncWaiter() = default;

void MediaRouteProviderAsyncWaiter::CreateRoute(
    const std::string& media_source, const std::string& sink_id, const std::string& original_presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, base::Optional<media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, media_router::RouteRequestResult::ResultCode* out_result_code) {
  base::RunLoop loop;
  proxy_->CreateRoute(std::move(media_source),std::move(sink_id),std::move(original_presentation_id),std::move(origin),std::move(tab_id),std::move(timeout),std::move(incognito),
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<media_router::MediaRoute>* out_route
,
             RoutePresentationConnectionPtr* out_connection
,
             base::Optional<std::string>* out_error_text
,
             media_router::RouteRequestResult::ResultCode* out_result_code
,
             const base::Optional<media_router::MediaRoute>& route,
             RoutePresentationConnectionPtr connection,
             const base::Optional<std::string>& error_text,
             media_router::RouteRequestResult::ResultCode result_code) {*out_route = std::move(route);*out_connection = std::move(connection);*out_error_text = std::move(error_text);*out_result_code = std::move(result_code);
            loop->Quit();
          },
          &loop,
          out_route,
          out_connection,
          out_error_text,
          out_result_code));
  loop.Run();
}
void MediaRouteProviderAsyncWaiter::JoinRoute(
    const std::string& media_source, const std::string& presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, base::Optional<media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, media_router::RouteRequestResult::ResultCode* out_result_code) {
  base::RunLoop loop;
  proxy_->JoinRoute(std::move(media_source),std::move(presentation_id),std::move(origin),std::move(tab_id),std::move(timeout),std::move(incognito),
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<media_router::MediaRoute>* out_route
,
             RoutePresentationConnectionPtr* out_connection
,
             base::Optional<std::string>* out_error_text
,
             media_router::RouteRequestResult::ResultCode* out_result_code
,
             const base::Optional<media_router::MediaRoute>& route,
             RoutePresentationConnectionPtr connection,
             const base::Optional<std::string>& error_text,
             media_router::RouteRequestResult::ResultCode result_code) {*out_route = std::move(route);*out_connection = std::move(connection);*out_error_text = std::move(error_text);*out_result_code = std::move(result_code);
            loop->Quit();
          },
          &loop,
          out_route,
          out_connection,
          out_error_text,
          out_result_code));
  loop.Run();
}
void MediaRouteProviderAsyncWaiter::ConnectRouteByRouteId(
    const std::string& media_source, const std::string& route_id, const std::string& presentation_id, const url::Origin& origin, int32_t tab_id, base::TimeDelta timeout, bool incognito, base::Optional<media_router::MediaRoute>* out_route, RoutePresentationConnectionPtr* out_connection, base::Optional<std::string>* out_error_text, media_router::RouteRequestResult::ResultCode* out_result_code) {
  base::RunLoop loop;
  proxy_->ConnectRouteByRouteId(std::move(media_source),std::move(route_id),std::move(presentation_id),std::move(origin),std::move(tab_id),std::move(timeout),std::move(incognito),
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<media_router::MediaRoute>* out_route
,
             RoutePresentationConnectionPtr* out_connection
,
             base::Optional<std::string>* out_error_text
,
             media_router::RouteRequestResult::ResultCode* out_result_code
,
             const base::Optional<media_router::MediaRoute>& route,
             RoutePresentationConnectionPtr connection,
             const base::Optional<std::string>& error_text,
             media_router::RouteRequestResult::ResultCode result_code) {*out_route = std::move(route);*out_connection = std::move(connection);*out_error_text = std::move(error_text);*out_result_code = std::move(result_code);
            loop->Quit();
          },
          &loop,
          out_route,
          out_connection,
          out_error_text,
          out_result_code));
  loop.Run();
}
void MediaRouteProviderAsyncWaiter::TerminateRoute(
    const std::string& route_id, base::Optional<std::string>* out_error_text, media_router::RouteRequestResult::ResultCode* out_result_code) {
  base::RunLoop loop;
  proxy_->TerminateRoute(std::move(route_id),
      base::BindOnce(
          [](base::RunLoop* loop,
             base::Optional<std::string>* out_error_text
,
             media_router::RouteRequestResult::ResultCode* out_result_code
,
             const base::Optional<std::string>& error_text,
             media_router::RouteRequestResult::ResultCode result_code) {*out_error_text = std::move(error_text);*out_result_code = std::move(result_code);
            loop->Quit();
          },
          &loop,
          out_error_text,
          out_result_code));
  loop.Run();
}
void MediaRouteProviderAsyncWaiter::SearchSinks(
    const std::string& sink_id, const std::string& media_source, SinkSearchCriteriaPtr search_criteria, std::string* out_sink_id) {
  base::RunLoop loop;
  proxy_->SearchSinks(std::move(sink_id),std::move(media_source),std::move(search_criteria),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::string* out_sink_id
,
             const std::string& sink_id) {*out_sink_id = std::move(sink_id);
            loop->Quit();
          },
          &loop,
          out_sink_id));
  loop.Run();
}
void MediaRouteProviderAsyncWaiter::CreateMediaRouteController(
    const std::string& route_id, ::media_router::mojom::MediaControllerRequest media_controller, ::media_router::mojom::MediaStatusObserverPtr observer, bool* out_success) {
  base::RunLoop loop;
  proxy_->CreateMediaRouteController(std::move(route_id),std::move(media_controller),std::move(observer),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}



void MediaRouterInterceptorForTesting::RegisterMediaRouteProvider(media_router::MediaRouteProviderId provider_id, MediaRouteProviderPtr media_router_provider, RegisterMediaRouteProviderCallback callback) {
  GetForwardingInterface()->RegisterMediaRouteProvider(std::move(provider_id), std::move(media_router_provider), std::move(callback));
}
void MediaRouterInterceptorForTesting::OnSinksReceived(media_router::MediaRouteProviderId provider_id, const std::string& media_source, const std::vector<media_router::MediaSinkInternal>& sinks, const std::vector<url::Origin>& origins) {
  GetForwardingInterface()->OnSinksReceived(std::move(provider_id), std::move(media_source), std::move(sinks), std::move(origins));
}
void MediaRouterInterceptorForTesting::OnIssue(const media_router::IssueInfo& issue) {
  GetForwardingInterface()->OnIssue(std::move(issue));
}
void MediaRouterInterceptorForTesting::OnRoutesUpdated(media_router::MediaRouteProviderId provider_id, const std::vector<media_router::MediaRoute>& routes, const std::string& media_source, const std::vector<std::string>& joinable_route_ids) {
  GetForwardingInterface()->OnRoutesUpdated(std::move(provider_id), std::move(routes), std::move(media_source), std::move(joinable_route_ids));
}
void MediaRouterInterceptorForTesting::OnSinkAvailabilityUpdated(media_router::MediaRouteProviderId provider_id, MediaRouter::SinkAvailability availability) {
  GetForwardingInterface()->OnSinkAvailabilityUpdated(std::move(provider_id), std::move(availability));
}
void MediaRouterInterceptorForTesting::OnPresentationConnectionStateChanged(const std::string& route_id, MediaRouter::PresentationConnectionState state) {
  GetForwardingInterface()->OnPresentationConnectionStateChanged(std::move(route_id), std::move(state));
}
void MediaRouterInterceptorForTesting::OnPresentationConnectionClosed(const std::string& route_id, MediaRouter::PresentationConnectionCloseReason reason, const std::string& message) {
  GetForwardingInterface()->OnPresentationConnectionClosed(std::move(route_id), std::move(reason), std::move(message));
}
void MediaRouterInterceptorForTesting::OnRouteMessagesReceived(const std::string& route_id, std::vector<RouteMessagePtr> messages) {
  GetForwardingInterface()->OnRouteMessagesReceived(std::move(route_id), std::move(messages));
}
void MediaRouterInterceptorForTesting::OnMediaRemoterCreated(int32_t tab_id, ::media::mojom::MirrorServiceRemoterPtr remoter, ::media::mojom::MirrorServiceRemotingSourceRequest remoting_source) {
  GetForwardingInterface()->OnMediaRemoterCreated(std::move(tab_id), std::move(remoter), std::move(remoting_source));
}
void MediaRouterInterceptorForTesting::GetMediaSinkServiceStatus(GetMediaSinkServiceStatusCallback callback) {
  GetForwardingInterface()->GetMediaSinkServiceStatus(std::move(callback));
}
void MediaRouterInterceptorForTesting::GetMirroringServiceHostForTab(int32_t target_tab_id, ::mirroring::mojom::MirroringServiceHostRequest request) {
  GetForwardingInterface()->GetMirroringServiceHostForTab(std::move(target_tab_id), std::move(request));
}
void MediaRouterInterceptorForTesting::GetMirroringServiceHostForDesktop(int32_t initiator_tab_id, const std::string& desktop_stream_id, ::mirroring::mojom::MirroringServiceHostRequest request) {
  GetForwardingInterface()->GetMirroringServiceHostForDesktop(std::move(initiator_tab_id), std::move(desktop_stream_id), std::move(request));
}
void MediaRouterInterceptorForTesting::GetMirroringServiceHostForOffscreenTab(const GURL& presentation_url, const std::string& presentation_id, ::mirroring::mojom::MirroringServiceHostRequest request) {
  GetForwardingInterface()->GetMirroringServiceHostForOffscreenTab(std::move(presentation_url), std::move(presentation_id), std::move(request));
}
MediaRouterAsyncWaiter::MediaRouterAsyncWaiter(
    MediaRouter* proxy) : proxy_(proxy) {}

MediaRouterAsyncWaiter::~MediaRouterAsyncWaiter() = default;

void MediaRouterAsyncWaiter::RegisterMediaRouteProvider(
    media_router::MediaRouteProviderId provider_id, MediaRouteProviderPtr media_router_provider, std::string* out_instance_id, MediaRouteProviderConfigPtr* out_config) {
  base::RunLoop loop;
  proxy_->RegisterMediaRouteProvider(std::move(provider_id),std::move(media_router_provider),
      base::BindOnce(
          [](base::RunLoop* loop,
             std::string* out_instance_id
,
             MediaRouteProviderConfigPtr* out_config
,
             const std::string& instance_id,
             MediaRouteProviderConfigPtr config) {*out_instance_id = std::move(instance_id);*out_config = std::move(config);
            loop->Quit();
          },
          &loop,
          out_instance_id,
          out_config));
  loop.Run();
}
void MediaRouterAsyncWaiter::GetMediaSinkServiceStatus(
    std::string* out_status) {
  base::RunLoop loop;
  proxy_->GetMediaSinkServiceStatus(
      base::BindOnce(
          [](base::RunLoop* loop,
             std::string* out_status
,
             const std::string& status) {*out_status = std::move(status);
            loop->Quit();
          },
          &loop,
          out_status));
  loop.Run();
}





}  // namespace mojom
}  // namespace media_router

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif