// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_STATUS_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_STATUS_MOJOM_TEST_UTILS_H_

#include "chrome/common/media_router/mojo/media_status.mojom.h"


namespace media_router {
namespace mojom {


class  MediaStatusObserverInterceptorForTesting : public MediaStatusObserver {
  virtual MediaStatusObserver* GetForwardingInterface() = 0;
  void OnMediaStatusUpdated(const media_router::MediaStatus& status) override;
};
class  MediaStatusObserverAsyncWaiter {
 public:
  explicit MediaStatusObserverAsyncWaiter(MediaStatusObserver* proxy);
  ~MediaStatusObserverAsyncWaiter();

 private:
  MediaStatusObserver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MediaStatusObserverAsyncWaiter);
};




}  // namespace mojom
}  // namespace media_router

#endif  // CHROME_COMMON_MEDIA_ROUTER_MOJO_MEDIA_STATUS_MOJOM_TEST_UTILS_H_