// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_NETWORK_DIAGNOSTICS_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_NETWORK_DIAGNOSTICS_MOJOM_TEST_UTILS_H_

#include "chrome/common/network_diagnostics.mojom.h"


namespace chrome {
namespace mojom {


class  NetworkDiagnosticsInterceptorForTesting : public NetworkDiagnostics {
  virtual NetworkDiagnostics* GetForwardingInterface() = 0;
  void RunNetworkDiagnostics(const GURL& failed_url) override;
};
class  NetworkDiagnosticsAsyncWaiter {
 public:
  explicit NetworkDiagnosticsAsyncWaiter(NetworkDiagnostics* proxy);
  ~NetworkDiagnosticsAsyncWaiter();

 private:
  NetworkDiagnostics* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NetworkDiagnosticsAsyncWaiter);
};


class  NetworkDiagnosticsClientInterceptorForTesting : public NetworkDiagnosticsClient {
  virtual NetworkDiagnosticsClient* GetForwardingInterface() = 0;
  void SetCanShowNetworkDiagnosticsDialog(bool can_show) override;
  void DNSProbeStatus(int32_t status) override;
};
class  NetworkDiagnosticsClientAsyncWaiter {
 public:
  explicit NetworkDiagnosticsClientAsyncWaiter(NetworkDiagnosticsClient* proxy);
  ~NetworkDiagnosticsClientAsyncWaiter();

 private:
  NetworkDiagnosticsClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(NetworkDiagnosticsClientAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_NETWORK_DIAGNOSTICS_MOJOM_TEST_UTILS_H_