// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_PARAMS_DATA_H_
#define CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace chrome {
namespace mojom {
namespace internal {
class  OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data));
      new (data()) OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data>(index_);
    }
    OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> page_url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> osdd_url;

 private:
  OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data();
  ~OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data() = delete;
};
static_assert(sizeof(OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data) == 24,
              "Bad sizeof(OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data)");

}  // namespace internal
class OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_ParamsDataView {
 public:
  OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_ParamsDataView() {}

  OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_ParamsDataView(
      internal::OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageUrl(UserType* output) {
    auto* pointer = data_->page_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetOsddUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadOsddUrl(UserType* output) {
    auto* pointer = data_->osdd_url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_ParamsDataView::GetPageUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->page_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void OpenSearchDescriptionDocumentHandler_PageHasOpenSearchDescriptionDocument_ParamsDataView::GetOsddUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->osdd_url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_PARAMS_DATA_H_