// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_TEST_UTILS_H_
#define CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_TEST_UTILS_H_

#include "chrome/common/open_search_description_document_handler.mojom.h"


namespace chrome {
namespace mojom {


class  OpenSearchDescriptionDocumentHandlerInterceptorForTesting : public OpenSearchDescriptionDocumentHandler {
  virtual OpenSearchDescriptionDocumentHandler* GetForwardingInterface() = 0;
  void PageHasOpenSearchDescriptionDocument(const GURL& page_url, const GURL& osdd_url) override;
};
class  OpenSearchDescriptionDocumentHandlerAsyncWaiter {
 public:
  explicit OpenSearchDescriptionDocumentHandlerAsyncWaiter(OpenSearchDescriptionDocumentHandler* proxy);
  ~OpenSearchDescriptionDocumentHandlerAsyncWaiter();

 private:
  OpenSearchDescriptionDocumentHandler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(OpenSearchDescriptionDocumentHandlerAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_COMMON_OPEN_SEARCH_DESCRIPTION_DOCUMENT_HANDLER_MOJOM_TEST_UTILS_H_