// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/plugin.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "content/public/common/webplugininfo.mojom.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "url/mojom/origin.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_COMMON_PLUGIN_MOJOM_JUMBO_H_
#define CHROME_COMMON_PLUGIN_MOJOM_JUMBO_H_
#include "content/public/common/webplugininfo_param_traits.h"
#include "mojo/public/cpp/base/file_path_mojom_traits.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "url/mojom/origin_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace chrome {
namespace mojom {


void PluginHostInterceptorForTesting::ShowFlashPermissionBubble() {
  GetForwardingInterface()->ShowFlashPermissionBubble();
}
void PluginHostInterceptorForTesting::CouldNotLoadPlugin(const base::FilePath& file_path) {
  GetForwardingInterface()->CouldNotLoadPlugin(std::move(file_path));
}
void PluginHostInterceptorForTesting::BlockedOutdatedPlugin(PluginRendererPtr plugin_renderer, const std::string& group_id) {
  GetForwardingInterface()->BlockedOutdatedPlugin(std::move(plugin_renderer), std::move(group_id));
}
void PluginHostInterceptorForTesting::BlockedComponentUpdatedPlugin(PluginRendererPtr plugin_renderer, const std::string& group_id) {
  GetForwardingInterface()->BlockedComponentUpdatedPlugin(std::move(plugin_renderer), std::move(group_id));
}
PluginHostAsyncWaiter::PluginHostAsyncWaiter(
    PluginHost* proxy) : proxy_(proxy) {}

PluginHostAsyncWaiter::~PluginHostAsyncWaiter() = default;




void PluginAuthHostInterceptorForTesting::BlockedUnauthorizedPlugin(const base::string16& name, const std::string& group_id) {
  GetForwardingInterface()->BlockedUnauthorizedPlugin(std::move(name), std::move(group_id));
}
PluginAuthHostAsyncWaiter::PluginAuthHostAsyncWaiter(
    PluginAuthHost* proxy) : proxy_(proxy) {}

PluginAuthHostAsyncWaiter::~PluginAuthHostAsyncWaiter() = default;




void PluginInfoHostInterceptorForTesting::GetPluginInfo(int32_t render_frame_id, const GURL& url, const url::Origin& origin, const std::string& mime_type, GetPluginInfoCallback callback) {
  GetForwardingInterface()->GetPluginInfo(std::move(render_frame_id), std::move(url), std::move(origin), std::move(mime_type), std::move(callback));
}
PluginInfoHostAsyncWaiter::PluginInfoHostAsyncWaiter(
    PluginInfoHost* proxy) : proxy_(proxy) {}

PluginInfoHostAsyncWaiter::~PluginInfoHostAsyncWaiter() = default;

void PluginInfoHostAsyncWaiter::GetPluginInfo(
    int32_t render_frame_id, const GURL& url, const url::Origin& origin, const std::string& mime_type, PluginInfoPtr* out_plugin_info) {
  base::RunLoop loop;
  proxy_->GetPluginInfo(std::move(render_frame_id),std::move(url),std::move(origin),std::move(mime_type),
      base::BindOnce(
          [](base::RunLoop* loop,
             PluginInfoPtr* out_plugin_info
,
             PluginInfoPtr plugin_info) {*out_plugin_info = std::move(plugin_info);
            loop->Quit();
          },
          &loop,
          out_plugin_info));
  loop.Run();
}



void PluginRendererInterceptorForTesting::FinishedDownloading() {
  GetForwardingInterface()->FinishedDownloading();
}
void PluginRendererInterceptorForTesting::UpdateSuccess() {
  GetForwardingInterface()->UpdateSuccess();
}
void PluginRendererInterceptorForTesting::UpdateFailure() {
  GetForwardingInterface()->UpdateFailure();
}
void PluginRendererInterceptorForTesting::UpdateDownloading() {
  GetForwardingInterface()->UpdateDownloading();
}
PluginRendererAsyncWaiter::PluginRendererAsyncWaiter(
    PluginRenderer* proxy) : proxy_(proxy) {}

PluginRendererAsyncWaiter::~PluginRendererAsyncWaiter() = default;






}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif