// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_PRERENDER_MOJOM_PARAMS_DATA_H_
#define CHROME_COMMON_PRERENDER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace chrome {
namespace mojom {
namespace internal {
class  PrerenderCanceler_CancelPrerenderForPrinting_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderCanceler_CancelPrerenderForPrinting_Params_Data));
      new (data()) PrerenderCanceler_CancelPrerenderForPrinting_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderCanceler_CancelPrerenderForPrinting_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderCanceler_CancelPrerenderForPrinting_Params_Data>(index_);
    }
    PrerenderCanceler_CancelPrerenderForPrinting_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PrerenderCanceler_CancelPrerenderForPrinting_Params_Data();
  ~PrerenderCanceler_CancelPrerenderForPrinting_Params_Data() = delete;
};
static_assert(sizeof(PrerenderCanceler_CancelPrerenderForPrinting_Params_Data) == 8,
              "Bad sizeof(PrerenderCanceler_CancelPrerenderForPrinting_Params_Data)");
class  PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data));
      new (data()) PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data>(index_);
    }
    PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data();
  ~PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data() = delete;
};
static_assert(sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data) == 8,
              "Bad sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data)");
class  PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data));
      new (data()) PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data>(index_);
    }
    PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;

 private:
  PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data();
  ~PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data() = delete;
};
static_assert(sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data) == 16,
              "Bad sizeof(PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data)");
class  PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data));
      new (data()) PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data>(index_);
    }
    PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data();
  ~PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data() = delete;
};
static_assert(sizeof(PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data) == 8,
              "Bad sizeof(PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data)");
class  PrerenderDispatcher_PrerenderStart_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderStart_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderStart_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderStart_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderStart_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderStart_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t prerender_id;
  uint8_t padfinal_[4];

 private:
  PrerenderDispatcher_PrerenderStart_Params_Data();
  ~PrerenderDispatcher_PrerenderStart_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderStart_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderStart_Params_Data)");
class  PrerenderDispatcher_PrerenderStopLoading_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderStopLoading_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderStopLoading_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderStopLoading_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderStopLoading_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderStopLoading_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t prerender_id;
  uint8_t padfinal_[4];

 private:
  PrerenderDispatcher_PrerenderStopLoading_Params_Data();
  ~PrerenderDispatcher_PrerenderStopLoading_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderStopLoading_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderStopLoading_Params_Data)");
class  PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t prerender_id;
  uint8_t padfinal_[4];

 private:
  PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data();
  ~PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data)");
class  PrerenderDispatcher_PrerenderAddAlias_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderAddAlias_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderAddAlias_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderAddAlias_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderAddAlias_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderAddAlias_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> alias;

 private:
  PrerenderDispatcher_PrerenderAddAlias_Params_Data();
  ~PrerenderDispatcher_PrerenderAddAlias_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderAddAlias_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderAddAlias_Params_Data)");
class  PrerenderDispatcher_PrerenderRemoveAliases_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderRemoveAliases_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderRemoveAliases_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderRemoveAliases_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderRemoveAliases_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderRemoveAliases_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::url::mojom::internal::Url_Data>>> aliases;

 private:
  PrerenderDispatcher_PrerenderRemoveAliases_Params_Data();
  ~PrerenderDispatcher_PrerenderRemoveAliases_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderRemoveAliases_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderRemoveAliases_Params_Data)");
class  PrerenderDispatcher_PrerenderStop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrerenderDispatcher_PrerenderStop_Params_Data));
      new (data()) PrerenderDispatcher_PrerenderStop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrerenderDispatcher_PrerenderStop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrerenderDispatcher_PrerenderStop_Params_Data>(index_);
    }
    PrerenderDispatcher_PrerenderStop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t prerender_id;
  uint8_t padfinal_[4];

 private:
  PrerenderDispatcher_PrerenderStop_Params_Data();
  ~PrerenderDispatcher_PrerenderStop_Params_Data() = delete;
};
static_assert(sizeof(PrerenderDispatcher_PrerenderStop_Params_Data) == 16,
              "Bad sizeof(PrerenderDispatcher_PrerenderStop_Params_Data)");

}  // namespace internal
class PrerenderCanceler_CancelPrerenderForPrinting_ParamsDataView {
 public:
  PrerenderCanceler_CancelPrerenderForPrinting_ParamsDataView() {}

  PrerenderCanceler_CancelPrerenderForPrinting_ParamsDataView(
      internal::PrerenderCanceler_CancelPrerenderForPrinting_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PrerenderCanceler_CancelPrerenderForPrinting_Params_Data* data_ = nullptr;
};

class PrerenderCanceler_CancelPrerenderForUnsupportedMethod_ParamsDataView {
 public:
  PrerenderCanceler_CancelPrerenderForUnsupportedMethod_ParamsDataView() {}

  PrerenderCanceler_CancelPrerenderForUnsupportedMethod_ParamsDataView(
      internal::PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PrerenderCanceler_CancelPrerenderForUnsupportedMethod_Params_Data* data_ = nullptr;
};

class PrerenderCanceler_CancelPrerenderForUnsupportedScheme_ParamsDataView {
 public:
  PrerenderCanceler_CancelPrerenderForUnsupportedScheme_ParamsDataView() {}

  PrerenderCanceler_CancelPrerenderForUnsupportedScheme_ParamsDataView(
      internal::PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::PrerenderCanceler_CancelPrerenderForUnsupportedScheme_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_ParamsDataView {
 public:
  PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_ParamsDataView() {}

  PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_ParamsDataView(
      internal::PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PrerenderCanceler_CancelPrerenderForSyncDeferredRedirect_Params_Data* data_ = nullptr;
};

class PrerenderDispatcher_PrerenderStart_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderStart_ParamsDataView() {}

  PrerenderDispatcher_PrerenderStart_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderStart_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t prerender_id() const {
    return data_->prerender_id;
  }
 private:
  internal::PrerenderDispatcher_PrerenderStart_Params_Data* data_ = nullptr;
};

class PrerenderDispatcher_PrerenderStopLoading_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderStopLoading_ParamsDataView() {}

  PrerenderDispatcher_PrerenderStopLoading_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderStopLoading_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t prerender_id() const {
    return data_->prerender_id;
  }
 private:
  internal::PrerenderDispatcher_PrerenderStopLoading_Params_Data* data_ = nullptr;
};

class PrerenderDispatcher_PrerenderDomContentLoaded_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderDomContentLoaded_ParamsDataView() {}

  PrerenderDispatcher_PrerenderDomContentLoaded_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t prerender_id() const {
    return data_->prerender_id;
  }
 private:
  internal::PrerenderDispatcher_PrerenderDomContentLoaded_Params_Data* data_ = nullptr;
};

class PrerenderDispatcher_PrerenderAddAlias_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderAddAlias_ParamsDataView() {}

  PrerenderDispatcher_PrerenderAddAlias_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderAddAlias_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAliasDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAlias(UserType* output) {
    auto* pointer = data_->alias.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::PrerenderDispatcher_PrerenderAddAlias_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PrerenderDispatcher_PrerenderRemoveAliases_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderRemoveAliases_ParamsDataView() {}

  PrerenderDispatcher_PrerenderRemoveAliases_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderRemoveAliases_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAliasesDataView(
      mojo::ArrayDataView<::url::mojom::UrlDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAliases(UserType* output) {
    auto* pointer = data_->aliases.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::url::mojom::UrlDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PrerenderDispatcher_PrerenderRemoveAliases_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PrerenderDispatcher_PrerenderStop_ParamsDataView {
 public:
  PrerenderDispatcher_PrerenderStop_ParamsDataView() {}

  PrerenderDispatcher_PrerenderStop_ParamsDataView(
      internal::PrerenderDispatcher_PrerenderStop_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t prerender_id() const {
    return data_->prerender_id;
  }
 private:
  internal::PrerenderDispatcher_PrerenderStop_Params_Data* data_ = nullptr;
};






inline void PrerenderCanceler_CancelPrerenderForUnsupportedScheme_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}










inline void PrerenderDispatcher_PrerenderAddAlias_ParamsDataView::GetAliasDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->alias.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void PrerenderDispatcher_PrerenderRemoveAliases_ParamsDataView::GetAliasesDataView(
    mojo::ArrayDataView<::url::mojom::UrlDataView>* output) {
  auto pointer = data_->aliases.Get();
  *output = mojo::ArrayDataView<::url::mojom::UrlDataView>(pointer, context_);
}



}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_COMMON_PRERENDER_MOJOM_PARAMS_DATA_H_