// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/common/prerender.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_COMMON_PRERENDER_MOJOM_JUMBO_H_
#define CHROME_COMMON_PRERENDER_MOJOM_JUMBO_H_
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace chrome {
namespace mojom {


void PrerenderCancelerInterceptorForTesting::CancelPrerenderForPrinting() {
  GetForwardingInterface()->CancelPrerenderForPrinting();
}
void PrerenderCancelerInterceptorForTesting::CancelPrerenderForUnsupportedMethod() {
  GetForwardingInterface()->CancelPrerenderForUnsupportedMethod();
}
void PrerenderCancelerInterceptorForTesting::CancelPrerenderForUnsupportedScheme(const GURL& url) {
  GetForwardingInterface()->CancelPrerenderForUnsupportedScheme(std::move(url));
}
void PrerenderCancelerInterceptorForTesting::CancelPrerenderForSyncDeferredRedirect() {
  GetForwardingInterface()->CancelPrerenderForSyncDeferredRedirect();
}
PrerenderCancelerAsyncWaiter::PrerenderCancelerAsyncWaiter(
    PrerenderCanceler* proxy) : proxy_(proxy) {}

PrerenderCancelerAsyncWaiter::~PrerenderCancelerAsyncWaiter() = default;




void PrerenderDispatcherInterceptorForTesting::PrerenderStart(int32_t prerender_id) {
  GetForwardingInterface()->PrerenderStart(std::move(prerender_id));
}
void PrerenderDispatcherInterceptorForTesting::PrerenderStopLoading(int32_t prerender_id) {
  GetForwardingInterface()->PrerenderStopLoading(std::move(prerender_id));
}
void PrerenderDispatcherInterceptorForTesting::PrerenderDomContentLoaded(int32_t prerender_id) {
  GetForwardingInterface()->PrerenderDomContentLoaded(std::move(prerender_id));
}
void PrerenderDispatcherInterceptorForTesting::PrerenderAddAlias(const GURL& alias) {
  GetForwardingInterface()->PrerenderAddAlias(std::move(alias));
}
void PrerenderDispatcherInterceptorForTesting::PrerenderRemoveAliases(const std::vector<GURL>& aliases) {
  GetForwardingInterface()->PrerenderRemoveAliases(std::move(aliases));
}
void PrerenderDispatcherInterceptorForTesting::PrerenderStop(int32_t prerender_id) {
  GetForwardingInterface()->PrerenderStop(std::move(prerender_id));
}
PrerenderDispatcherAsyncWaiter::PrerenderDispatcherAsyncWaiter(
    PrerenderDispatcher* proxy) : proxy_(proxy) {}

PrerenderDispatcherAsyncWaiter::~PrerenderDispatcherAsyncWaiter() = default;






}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif