// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_PARAMS_DATA_H_
#define CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace chrome {
namespace mojom {
namespace internal {
class  RendererConfiguration_SetInitialConfiguration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data));
      new (data()) RendererConfiguration_SetInitialConfiguration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetInitialConfiguration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetInitialConfiguration_Params_Data>(index_);
    }
    RendererConfiguration_SetInitialConfiguration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t is_incognito_process : 1;
  uint8_t pad0_[3];
  mojo::internal::Handle_Data chromeos_listener;

 private:
  RendererConfiguration_SetInitialConfiguration_Params_Data();
  ~RendererConfiguration_SetInitialConfiguration_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetInitialConfiguration_Params_Data)");
class  RendererConfiguration_SetConfiguration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetConfiguration_Params_Data));
      new (data()) RendererConfiguration_SetConfiguration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetConfiguration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetConfiguration_Params_Data>(index_);
    }
    RendererConfiguration_SetConfiguration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::DynamicParams_Data> params;

 private:
  RendererConfiguration_SetConfiguration_Params_Data();
  ~RendererConfiguration_SetConfiguration_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetConfiguration_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetConfiguration_Params_Data)");
class  RendererConfiguration_SetContentSettingRules_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetContentSettingRules_Params_Data));
      new (data()) RendererConfiguration_SetContentSettingRules_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetContentSettingRules_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetContentSettingRules_Params_Data>(index_);
    }
    RendererConfiguration_SetContentSettingRules_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::content_settings::mojom::internal::RendererContentSettingRules_Data> rules;

 private:
  RendererConfiguration_SetContentSettingRules_Params_Data();
  ~RendererConfiguration_SetContentSettingRules_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetContentSettingRules_Params_Data) == 16,
              "Bad sizeof(RendererConfiguration_SetContentSettingRules_Params_Data)");
class  RendererConfiguration_SetFieldTrialGroup_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data));
      new (data()) RendererConfiguration_SetFieldTrialGroup_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RendererConfiguration_SetFieldTrialGroup_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RendererConfiguration_SetFieldTrialGroup_Params_Data>(index_);
    }
    RendererConfiguration_SetFieldTrialGroup_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> trial_name;
  mojo::internal::Pointer<mojo::internal::String_Data> group_name;

 private:
  RendererConfiguration_SetFieldTrialGroup_Params_Data();
  ~RendererConfiguration_SetFieldTrialGroup_Params_Data() = delete;
};
static_assert(sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data) == 24,
              "Bad sizeof(RendererConfiguration_SetFieldTrialGroup_Params_Data)");

}  // namespace internal
class RendererConfiguration_SetInitialConfiguration_ParamsDataView {
 public:
  RendererConfiguration_SetInitialConfiguration_ParamsDataView() {}

  RendererConfiguration_SetInitialConfiguration_ParamsDataView(
      internal::RendererConfiguration_SetInitialConfiguration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  bool is_incognito_process() const {
    return data_->is_incognito_process;
  }
  template <typename UserType>
  UserType TakeChromeosListener() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::chrome::mojom::ChromeOSListenerRequestDataView>(
            &data_->chromeos_listener, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::RendererConfiguration_SetInitialConfiguration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RendererConfiguration_SetConfiguration_ParamsDataView {
 public:
  RendererConfiguration_SetConfiguration_ParamsDataView() {}

  RendererConfiguration_SetConfiguration_ParamsDataView(
      internal::RendererConfiguration_SetConfiguration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetParamsDataView(
      DynamicParamsDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadParams(UserType* output) {
    auto* pointer = data_->params.Get();
    return mojo::internal::Deserialize<::chrome::mojom::DynamicParamsDataView>(
        pointer, output, context_);
  }
 private:
  internal::RendererConfiguration_SetConfiguration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RendererConfiguration_SetContentSettingRules_ParamsDataView {
 public:
  RendererConfiguration_SetContentSettingRules_ParamsDataView() {}

  RendererConfiguration_SetContentSettingRules_ParamsDataView(
      internal::RendererConfiguration_SetContentSettingRules_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRulesDataView(
      ::content_settings::mojom::RendererContentSettingRulesDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRules(UserType* output) {
    auto* pointer = data_->rules.Get();
    return mojo::internal::Deserialize<::content_settings::mojom::RendererContentSettingRulesDataView>(
        pointer, output, context_);
  }
 private:
  internal::RendererConfiguration_SetContentSettingRules_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RendererConfiguration_SetFieldTrialGroup_ParamsDataView {
 public:
  RendererConfiguration_SetFieldTrialGroup_ParamsDataView() {}

  RendererConfiguration_SetFieldTrialGroup_ParamsDataView(
      internal::RendererConfiguration_SetFieldTrialGroup_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTrialNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTrialName(UserType* output) {
    auto* pointer = data_->trial_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetGroupNameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGroupName(UserType* output) {
    auto* pointer = data_->group_name.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::RendererConfiguration_SetFieldTrialGroup_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void RendererConfiguration_SetConfiguration_ParamsDataView::GetParamsDataView(
    DynamicParamsDataView* output) {
  auto pointer = data_->params.Get();
  *output = DynamicParamsDataView(pointer, context_);
}


inline void RendererConfiguration_SetContentSettingRules_ParamsDataView::GetRulesDataView(
    ::content_settings::mojom::RendererContentSettingRulesDataView* output) {
  auto pointer = data_->rules.Get();
  *output = ::content_settings::mojom::RendererContentSettingRulesDataView(pointer, context_);
}


inline void RendererConfiguration_SetFieldTrialGroup_ParamsDataView::GetTrialNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->trial_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void RendererConfiguration_SetFieldTrialGroup_ParamsDataView::GetGroupNameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->group_name.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_COMMON_RENDERER_CONFIGURATION_MOJOM_PARAMS_DATA_H_