// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_SERVICE_PROCESS_MOJOM_PARAMS_DATA_H_
#define CHROME_COMMON_SERVICE_PROCESS_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace chrome {
namespace mojom {
namespace internal {
class  ServiceProcess_Hello_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_Hello_Params_Data));
      new (data()) ServiceProcess_Hello_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_Hello_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_Hello_Params_Data>(index_);
    }
    ServiceProcess_Hello_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceProcess_Hello_Params_Data();
  ~ServiceProcess_Hello_Params_Data() = delete;
};
static_assert(sizeof(ServiceProcess_Hello_Params_Data) == 8,
              "Bad sizeof(ServiceProcess_Hello_Params_Data)");
class  ServiceProcess_Hello_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_Hello_ResponseParams_Data));
      new (data()) ServiceProcess_Hello_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_Hello_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_Hello_ResponseParams_Data>(index_);
    }
    ServiceProcess_Hello_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceProcess_Hello_ResponseParams_Data();
  ~ServiceProcess_Hello_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceProcess_Hello_ResponseParams_Data) == 8,
              "Bad sizeof(ServiceProcess_Hello_ResponseParams_Data)");
class  ServiceProcess_GetHistograms_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_GetHistograms_Params_Data));
      new (data()) ServiceProcess_GetHistograms_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_GetHistograms_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_GetHistograms_Params_Data>(index_);
    }
    ServiceProcess_GetHistograms_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceProcess_GetHistograms_Params_Data();
  ~ServiceProcess_GetHistograms_Params_Data() = delete;
};
static_assert(sizeof(ServiceProcess_GetHistograms_Params_Data) == 8,
              "Bad sizeof(ServiceProcess_GetHistograms_Params_Data)");
class  ServiceProcess_GetHistograms_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_GetHistograms_ResponseParams_Data));
      new (data()) ServiceProcess_GetHistograms_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_GetHistograms_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_GetHistograms_ResponseParams_Data>(index_);
    }
    ServiceProcess_GetHistograms_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> histograms;

 private:
  ServiceProcess_GetHistograms_ResponseParams_Data();
  ~ServiceProcess_GetHistograms_ResponseParams_Data() = delete;
};
static_assert(sizeof(ServiceProcess_GetHistograms_ResponseParams_Data) == 16,
              "Bad sizeof(ServiceProcess_GetHistograms_ResponseParams_Data)");
class  ServiceProcess_UpdateAvailable_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_UpdateAvailable_Params_Data));
      new (data()) ServiceProcess_UpdateAvailable_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_UpdateAvailable_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_UpdateAvailable_Params_Data>(index_);
    }
    ServiceProcess_UpdateAvailable_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceProcess_UpdateAvailable_Params_Data();
  ~ServiceProcess_UpdateAvailable_Params_Data() = delete;
};
static_assert(sizeof(ServiceProcess_UpdateAvailable_Params_Data) == 8,
              "Bad sizeof(ServiceProcess_UpdateAvailable_Params_Data)");
class  ServiceProcess_ShutDown_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ServiceProcess_ShutDown_Params_Data));
      new (data()) ServiceProcess_ShutDown_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ServiceProcess_ShutDown_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ServiceProcess_ShutDown_Params_Data>(index_);
    }
    ServiceProcess_ShutDown_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ServiceProcess_ShutDown_Params_Data();
  ~ServiceProcess_ShutDown_Params_Data() = delete;
};
static_assert(sizeof(ServiceProcess_ShutDown_Params_Data) == 8,
              "Bad sizeof(ServiceProcess_ShutDown_Params_Data)");

}  // namespace internal
class ServiceProcess_Hello_ParamsDataView {
 public:
  ServiceProcess_Hello_ParamsDataView() {}

  ServiceProcess_Hello_ParamsDataView(
      internal::ServiceProcess_Hello_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceProcess_Hello_Params_Data* data_ = nullptr;
};

class ServiceProcess_Hello_ResponseParamsDataView {
 public:
  ServiceProcess_Hello_ResponseParamsDataView() {}

  ServiceProcess_Hello_ResponseParamsDataView(
      internal::ServiceProcess_Hello_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceProcess_Hello_ResponseParams_Data* data_ = nullptr;
};

class ServiceProcess_GetHistograms_ParamsDataView {
 public:
  ServiceProcess_GetHistograms_ParamsDataView() {}

  ServiceProcess_GetHistograms_ParamsDataView(
      internal::ServiceProcess_GetHistograms_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceProcess_GetHistograms_Params_Data* data_ = nullptr;
};

class ServiceProcess_GetHistograms_ResponseParamsDataView {
 public:
  ServiceProcess_GetHistograms_ResponseParamsDataView() {}

  ServiceProcess_GetHistograms_ResponseParamsDataView(
      internal::ServiceProcess_GetHistograms_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetHistogramsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHistograms(UserType* output) {
    auto* pointer = data_->histograms.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ServiceProcess_GetHistograms_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ServiceProcess_UpdateAvailable_ParamsDataView {
 public:
  ServiceProcess_UpdateAvailable_ParamsDataView() {}

  ServiceProcess_UpdateAvailable_ParamsDataView(
      internal::ServiceProcess_UpdateAvailable_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceProcess_UpdateAvailable_Params_Data* data_ = nullptr;
};

class ServiceProcess_ShutDown_ParamsDataView {
 public:
  ServiceProcess_ShutDown_ParamsDataView() {}

  ServiceProcess_ShutDown_ParamsDataView(
      internal::ServiceProcess_ShutDown_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ServiceProcess_ShutDown_Params_Data* data_ = nullptr;
};








inline void ServiceProcess_GetHistograms_ResponseParamsDataView::GetHistogramsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->histograms.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}





}  // namespace mojom
}  // namespace chrome

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CHROME_COMMON_SERVICE_PROCESS_MOJOM_PARAMS_DATA_H_