// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/shared_memory.mojom.h"
#include "ui/gfx/geometry/mojo/geometry.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_JUMBO_H_
#define CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/shared_memory_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace printing {
namespace mojom {


void PdfNupConverterInterceptorForTesting::NupPageConvert(uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, std::vector<base::ReadOnlySharedMemoryRegion> pdf_page_regions, NupPageConvertCallback callback) {
  GetForwardingInterface()->NupPageConvert(std::move(pages_per_sheet), std::move(page_size), std::move(printable_area), std::move(pdf_page_regions), std::move(callback));
}
void PdfNupConverterInterceptorForTesting::NupDocumentConvert(uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, base::ReadOnlySharedMemoryRegion src_pdf_region, NupDocumentConvertCallback callback) {
  GetForwardingInterface()->NupDocumentConvert(std::move(pages_per_sheet), std::move(page_size), std::move(printable_area), std::move(src_pdf_region), std::move(callback));
}
void PdfNupConverterInterceptorForTesting::SetWebContentsURL(const GURL& url) {
  GetForwardingInterface()->SetWebContentsURL(std::move(url));
}
PdfNupConverterAsyncWaiter::PdfNupConverterAsyncWaiter(
    PdfNupConverter* proxy) : proxy_(proxy) {}

PdfNupConverterAsyncWaiter::~PdfNupConverterAsyncWaiter() = default;

void PdfNupConverterAsyncWaiter::NupPageConvert(
    uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, std::vector<base::ReadOnlySharedMemoryRegion> pdf_page_regions, PdfNupConverter::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region) {
  base::RunLoop loop;
  proxy_->NupPageConvert(std::move(pages_per_sheet),std::move(page_size),std::move(printable_area),std::move(pdf_page_regions),
      base::BindOnce(
          [](base::RunLoop* loop,
             PdfNupConverter::Status* out_status
,
             base::ReadOnlySharedMemoryRegion* out_pdf_region
,
             PdfNupConverter::Status status,
             base::ReadOnlySharedMemoryRegion pdf_region) {*out_status = std::move(status);*out_pdf_region = std::move(pdf_region);
            loop->Quit();
          },
          &loop,
          out_status,
          out_pdf_region));
  loop.Run();
}
void PdfNupConverterAsyncWaiter::NupDocumentConvert(
    uint32_t pages_per_sheet, const gfx::Size& page_size, const gfx::Rect& printable_area, base::ReadOnlySharedMemoryRegion src_pdf_region, PdfNupConverter::Status* out_status, base::ReadOnlySharedMemoryRegion* out_pdf_region) {
  base::RunLoop loop;
  proxy_->NupDocumentConvert(std::move(pages_per_sheet),std::move(page_size),std::move(printable_area),std::move(src_pdf_region),
      base::BindOnce(
          [](base::RunLoop* loop,
             PdfNupConverter::Status* out_status
,
             base::ReadOnlySharedMemoryRegion* out_pdf_region
,
             PdfNupConverter::Status status,
             base::ReadOnlySharedMemoryRegion pdf_region) {*out_status = std::move(status);*out_pdf_region = std::move(pdf_region);
            loop->Quit();
          },
          &loop,
          out_status,
          out_pdf_region));
  loop.Run();
}





}  // namespace mojom
}  // namespace printing

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif