// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom-params-data.h"
#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom-shared-message-ids.h"

#include "chrome/services/printing/public/mojom/pdf_nup_converter.mojom-import-headers.h"


#ifndef CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_JUMBO_H_
#define CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_NUP_CONVERTER_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/shared_memory_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif
namespace printing {
namespace mojom {
const char PdfNupConverter::Name_[] = "printing.mojom.PdfNupConverter";

class PdfNupConverter_NupPageConvert_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PdfNupConverter_NupPageConvert_ForwardToCallback(
      PdfNupConverter::NupPageConvertCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PdfNupConverter::NupPageConvertCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PdfNupConverter_NupPageConvert_ForwardToCallback);
};

class PdfNupConverter_NupDocumentConvert_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  PdfNupConverter_NupDocumentConvert_ForwardToCallback(
      PdfNupConverter::NupDocumentConvertCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  PdfNupConverter::NupDocumentConvertCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(PdfNupConverter_NupDocumentConvert_ForwardToCallback);
};

PdfNupConverterProxy::PdfNupConverterProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void PdfNupConverterProxy::NupPageConvert(
    uint32_t in_pages_per_sheet, const gfx::Size& in_page_size, const gfx::Rect& in_printable_area, std::vector<base::ReadOnlySharedMemoryRegion> in_pdf_page_regions, NupPageConvertCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupPageConvert");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfNupConverter_NupPageConvert_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfNupConverter_NupPageConvert_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->pages_per_sheet = in_pages_per_sheet;
  typename decltype(params->page_size)::BaseType::BufferWriter
      page_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_page_size, buffer, &page_size_writer, &serialization_context);
  params->page_size.Set(
      page_size_writer.is_null() ? nullptr : page_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->page_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null page_size in PdfNupConverter.NupPageConvert request");
  typename decltype(params->printable_area)::BaseType::BufferWriter
      printable_area_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_printable_area, buffer, &printable_area_writer, &serialization_context);
  params->printable_area.Set(
      printable_area_writer.is_null() ? nullptr : printable_area_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->printable_area.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null printable_area in PdfNupConverter.NupPageConvert request");
  typename decltype(params->pdf_page_regions)::BaseType::BufferWriter
      pdf_page_regions_writer;
  const mojo::internal::ContainerValidateParams pdf_page_regions_validate_params(
      0, false, nullptr);
  mojo::internal::Serialize<mojo::ArrayDataView<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>>(
      in_pdf_page_regions, buffer, &pdf_page_regions_writer, &pdf_page_regions_validate_params,
      &serialization_context);
  params->pdf_page_regions.Set(
      pdf_page_regions_writer.is_null() ? nullptr : pdf_page_regions_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->pdf_page_regions.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null pdf_page_regions in PdfNupConverter.NupPageConvert request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PdfNupConverter::Name_);
  message.set_method_name("NupPageConvert");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PdfNupConverter_NupPageConvert_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PdfNupConverterProxy::NupDocumentConvert(
    uint32_t in_pages_per_sheet, const gfx::Size& in_page_size, const gfx::Rect& in_printable_area, base::ReadOnlySharedMemoryRegion in_src_pdf_region, NupDocumentConvertCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupDocumentConvert");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfNupConverter_NupDocumentConvert_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfNupConverter_NupDocumentConvert_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  params->pages_per_sheet = in_pages_per_sheet;
  typename decltype(params->page_size)::BaseType::BufferWriter
      page_size_writer;
  mojo::internal::Serialize<::gfx::mojom::SizeDataView>(
      in_page_size, buffer, &page_size_writer, &serialization_context);
  params->page_size.Set(
      page_size_writer.is_null() ? nullptr : page_size_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->page_size.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null page_size in PdfNupConverter.NupDocumentConvert request");
  typename decltype(params->printable_area)::BaseType::BufferWriter
      printable_area_writer;
  mojo::internal::Serialize<::gfx::mojom::RectDataView>(
      in_printable_area, buffer, &printable_area_writer, &serialization_context);
  params->printable_area.Set(
      printable_area_writer.is_null() ? nullptr : printable_area_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->printable_area.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null printable_area in PdfNupConverter.NupDocumentConvert request");
  typename decltype(params->src_pdf_region)::BaseType::BufferWriter
      src_pdf_region_writer;
  mojo::internal::Serialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
      in_src_pdf_region, buffer, &src_pdf_region_writer, &serialization_context);
  params->src_pdf_region.Set(
      src_pdf_region_writer.is_null() ? nullptr : src_pdf_region_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->src_pdf_region.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null src_pdf_region in PdfNupConverter.NupDocumentConvert request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PdfNupConverter::Name_);
  message.set_method_name("NupDocumentConvert");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new PdfNupConverter_NupDocumentConvert_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void PdfNupConverterProxy::SetWebContentsURL(
    const GURL& in_url) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::PdfNupConverter::SetWebContentsURL");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfNupConverter_SetWebContentsURL_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfNupConverter_SetWebContentsURL_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->url)::BaseType::BufferWriter
      url_writer;
  mojo::internal::Serialize<::url::mojom::UrlDataView>(
      in_url, buffer, &url_writer, &serialization_context);
  params->url.Set(
      url_writer.is_null() ? nullptr : url_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->url.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null url in PdfNupConverter.SetWebContentsURL request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PdfNupConverter::Name_);
  message.set_method_name("SetWebContentsURL");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}
class PdfNupConverter_NupPageConvert_ProxyToResponder {
 public:
  static PdfNupConverter::NupPageConvertCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PdfNupConverter_NupPageConvert_ProxyToResponder> proxy(
        new PdfNupConverter_NupPageConvert_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&PdfNupConverter_NupPageConvert_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PdfNupConverter_NupPageConvert_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PdfNupConverter_NupPageConvert_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PdfNupConverter::NupPageConvertCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      PdfNupConverter::Status in_status, base::ReadOnlySharedMemoryRegion in_pdf_region);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PdfNupConverter_NupPageConvert_ProxyToResponder);
};

bool PdfNupConverter_NupPageConvert_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupPageConvertCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PdfNupConverter_NupPageConvert_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PdfNupConverter_NupPageConvert_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  PdfNupConverter::Status p_status{};
  base::ReadOnlySharedMemoryRegion p_pdf_region{};
  PdfNupConverter_NupPageConvert_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadPdfRegion(&p_pdf_region))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "PdfNupConverter::NupPageConvert response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_pdf_region));
  return true;
}

void PdfNupConverter_NupPageConvert_ProxyToResponder::Run(
    PdfNupConverter::Status in_status, base::ReadOnlySharedMemoryRegion in_pdf_region) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfNupConverter_NupPageConvert_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfNupConverter_NupPageConvert_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::printing::mojom::PdfNupConverter_Status>(
      in_status, &params->status);
  typename decltype(params->pdf_region)::BaseType::BufferWriter
      pdf_region_writer;
  mojo::internal::Serialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
      in_pdf_region, buffer, &pdf_region_writer, &serialization_context);
  params->pdf_region.Set(
      pdf_region_writer.is_null() ? nullptr : pdf_region_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupPageConvertCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PdfNupConverter::Name_);
  message.set_method_name("NupPageConvert");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class PdfNupConverter_NupDocumentConvert_ProxyToResponder {
 public:
  static PdfNupConverter::NupDocumentConvertCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<PdfNupConverter_NupDocumentConvert_ProxyToResponder> proxy(
        new PdfNupConverter_NupDocumentConvert_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&PdfNupConverter_NupDocumentConvert_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~PdfNupConverter_NupDocumentConvert_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  PdfNupConverter_NupDocumentConvert_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "PdfNupConverter::NupDocumentConvertCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      PdfNupConverter::Status in_status, base::ReadOnlySharedMemoryRegion in_pdf_region);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(PdfNupConverter_NupDocumentConvert_ProxyToResponder);
};

bool PdfNupConverter_NupDocumentConvert_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupDocumentConvertCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::PdfNupConverter_NupDocumentConvert_ResponseParams_Data* params =
      reinterpret_cast<
          internal::PdfNupConverter_NupDocumentConvert_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  PdfNupConverter::Status p_status{};
  base::ReadOnlySharedMemoryRegion p_pdf_region{};
  PdfNupConverter_NupDocumentConvert_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadStatus(&p_status))
    success = false;
  if (!input_data_view.ReadPdfRegion(&p_pdf_region))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "PdfNupConverter::NupDocumentConvert response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_status), 
std::move(p_pdf_region));
  return true;
}

void PdfNupConverter_NupDocumentConvert_ProxyToResponder::Run(
    PdfNupConverter::Status in_status, base::ReadOnlySharedMemoryRegion in_pdf_region) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kPdfNupConverter_NupDocumentConvert_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::printing::mojom::internal::PdfNupConverter_NupDocumentConvert_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::printing::mojom::PdfNupConverter_Status>(
      in_status, &params->status);
  typename decltype(params->pdf_region)::BaseType::BufferWriter
      pdf_region_writer;
  mojo::internal::Serialize<::mojo_base::mojom::ReadOnlySharedMemoryRegionDataView>(
      in_pdf_region, buffer, &pdf_region_writer, &serialization_context);
  params->pdf_region.Set(
      pdf_region_writer.is_null() ? nullptr : pdf_region_writer.data());
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupDocumentConvertCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(PdfNupConverter::Name_);
  message.set_method_name("NupDocumentConvert");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool PdfNupConverterStubDispatch::Accept(
    PdfNupConverter* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kPdfNupConverter_NupPageConvert_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupPageConvert",
               "message", message->name());
#endif
      break;
    }
    case internal::kPdfNupConverter_NupDocumentConvert_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupDocumentConvert",
               "message", message->name());
#endif
      break;
    }
    case internal::kPdfNupConverter_SetWebContentsURL_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::SetWebContentsURL",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::PdfNupConverter_SetWebContentsURL_Params_Data* params =
          reinterpret_cast<internal::PdfNupConverter_SetWebContentsURL_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      GURL p_url{};
      PdfNupConverter_SetWebContentsURL_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadUrl(&p_url))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "PdfNupConverter::SetWebContentsURL deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->SetWebContentsURL(
std::move(p_url));
      return true;
    }
  }
  return false;
}

// static
bool PdfNupConverterStubDispatch::AcceptWithResponder(
    PdfNupConverter* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kPdfNupConverter_NupPageConvert_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupPageConvert",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::PdfNupConverter_NupPageConvert_Params_Data* params =
          reinterpret_cast<
              internal::PdfNupConverter_NupPageConvert_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      uint32_t p_pages_per_sheet{};
      gfx::Size p_page_size{};
      gfx::Rect p_printable_area{};
      std::vector<base::ReadOnlySharedMemoryRegion> p_pdf_page_regions{};
      PdfNupConverter_NupPageConvert_ParamsDataView input_data_view(params, &serialization_context);
      
      p_pages_per_sheet = input_data_view.pages_per_sheet();
      if (!input_data_view.ReadPageSize(&p_page_size))
        success = false;
      if (!input_data_view.ReadPrintableArea(&p_printable_area))
        success = false;
      if (!input_data_view.ReadPdfPageRegions(&p_pdf_page_regions))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "PdfNupConverter::NupPageConvert deserializer");
        return false;
      }
      PdfNupConverter::NupPageConvertCallback callback =
          PdfNupConverter_NupPageConvert_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->NupPageConvert(
std::move(p_pages_per_sheet), 
std::move(p_page_size), 
std::move(p_printable_area), 
std::move(p_pdf_page_regions), std::move(callback));
      return true;
    }
    case internal::kPdfNupConverter_NupDocumentConvert_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::NupDocumentConvert",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::PdfNupConverter_NupDocumentConvert_Params_Data* params =
          reinterpret_cast<
              internal::PdfNupConverter_NupDocumentConvert_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      uint32_t p_pages_per_sheet{};
      gfx::Size p_page_size{};
      gfx::Rect p_printable_area{};
      base::ReadOnlySharedMemoryRegion p_src_pdf_region{};
      PdfNupConverter_NupDocumentConvert_ParamsDataView input_data_view(params, &serialization_context);
      
      p_pages_per_sheet = input_data_view.pages_per_sheet();
      if (!input_data_view.ReadPageSize(&p_page_size))
        success = false;
      if (!input_data_view.ReadPrintableArea(&p_printable_area))
        success = false;
      if (!input_data_view.ReadSrcPdfRegion(&p_src_pdf_region))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "PdfNupConverter::NupDocumentConvert deserializer");
        return false;
      }
      PdfNupConverter::NupDocumentConvertCallback callback =
          PdfNupConverter_NupDocumentConvert_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->NupDocumentConvert(
std::move(p_pages_per_sheet), 
std::move(p_page_size), 
std::move(p_printable_area), 
std::move(p_src_pdf_region), std::move(callback));
      return true;
    }
    case internal::kPdfNupConverter_SetWebContentsURL_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::PdfNupConverter::SetWebContentsURL",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool PdfNupConverterRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "PdfNupConverter RequestValidator");

  switch (message->header()->name) {
    case internal::kPdfNupConverter_NupPageConvert_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfNupConverter_NupPageConvert_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPdfNupConverter_NupDocumentConvert_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfNupConverter_NupDocumentConvert_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPdfNupConverter_SetWebContentsURL_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfNupConverter_SetWebContentsURL_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool PdfNupConverterResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "PdfNupConverter ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kPdfNupConverter_NupPageConvert_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfNupConverter_NupPageConvert_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kPdfNupConverter_NupDocumentConvert_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::PdfNupConverter_NupDocumentConvert_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace printing

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif