// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_TO_PWG_RASTER_CONVERTER_MOJOM_TEST_UTILS_H_
#define CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_TO_PWG_RASTER_CONVERTER_MOJOM_TEST_UTILS_H_

#include "chrome/services/printing/public/mojom/pdf_to_pwg_raster_converter.mojom.h"


namespace printing {
namespace mojom {


class  PdfToPwgRasterConverterInterceptorForTesting : public PdfToPwgRasterConverter {
  virtual PdfToPwgRasterConverter* GetForwardingInterface() = 0;
  void Convert(base::ReadOnlySharedMemoryRegion pdf_region, const printing::PdfRenderSettings& pdf_settings, const printing::PwgRasterSettings& pwg_raster_settings, ConvertCallback callback) override;
};
class  PdfToPwgRasterConverterAsyncWaiter {
 public:
  explicit PdfToPwgRasterConverterAsyncWaiter(PdfToPwgRasterConverter* proxy);
  ~PdfToPwgRasterConverterAsyncWaiter();
  void Convert(
      base::ReadOnlySharedMemoryRegion pdf_region, const printing::PdfRenderSettings& pdf_settings, const printing::PwgRasterSettings& pwg_raster_settings, base::ReadOnlySharedMemoryRegion* out_pwg_raster_region, uint32_t* out_page_count);

 private:
  PdfToPwgRasterConverter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PdfToPwgRasterConverterAsyncWaiter);
};




}  // namespace mojom
}  // namespace printing

#endif  // CHROME_SERVICES_PRINTING_PUBLIC_MOJOM_PDF_TO_PWG_RASTER_CONVERTER_MOJOM_TEST_UTILS_H_