// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_SERVICES_REMOVABLE_STORAGE_WRITER_PUBLIC_MOJOM_REMOVABLE_STORAGE_WRITER_MOJOM_TEST_UTILS_H_
#define CHROME_SERVICES_REMOVABLE_STORAGE_WRITER_PUBLIC_MOJOM_REMOVABLE_STORAGE_WRITER_MOJOM_TEST_UTILS_H_

#include "chrome/services/removable_storage_writer/public/mojom/removable_storage_writer.mojom.h"


namespace chrome {
namespace mojom {


class  RemovableStorageWriterInterceptorForTesting : public RemovableStorageWriter {
  virtual RemovableStorageWriter* GetForwardingInterface() = 0;
  void Write(const base::FilePath& source, const base::FilePath& target, RemovableStorageWriterClientPtr client) override;
  void Verify(const base::FilePath& source, const base::FilePath& target, RemovableStorageWriterClientPtr client) override;
};
class  RemovableStorageWriterAsyncWaiter {
 public:
  explicit RemovableStorageWriterAsyncWaiter(RemovableStorageWriter* proxy);
  ~RemovableStorageWriterAsyncWaiter();

 private:
  RemovableStorageWriter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemovableStorageWriterAsyncWaiter);
};


class  RemovableStorageWriterClientInterceptorForTesting : public RemovableStorageWriterClient {
  virtual RemovableStorageWriterClient* GetForwardingInterface() = 0;
  void Progress(int64_t progress) override;
  void Complete(const base::Optional<std::string>& error) override;
};
class  RemovableStorageWriterClientAsyncWaiter {
 public:
  explicit RemovableStorageWriterClientAsyncWaiter(RemovableStorageWriterClient* proxy);
  ~RemovableStorageWriterClientAsyncWaiter();

 private:
  RemovableStorageWriterClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RemovableStorageWriterClientAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome

#endif  // CHROME_SERVICES_REMOVABLE_STORAGE_WRITER_PUBLIC_MOJOM_REMOVABLE_STORAGE_WRITER_MOJOM_TEST_UTILS_H_