// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_TEST_UTILS_H_
#define CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_TEST_UTILS_H_

#include "chrome/test/data/webui/web_ui_test.mojom.h"


namespace web_ui_test {
namespace mojom {


class  TestRunnerInterceptorForTesting : public TestRunner {
  virtual TestRunner* GetForwardingInterface() = 0;
  void TestComplete(const base::Optional<std::string>& failureMessage) override;
};
class  TestRunnerAsyncWaiter {
 public:
  explicit TestRunnerAsyncWaiter(TestRunner* proxy);
  ~TestRunnerAsyncWaiter();

 private:
  TestRunner* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(TestRunnerAsyncWaiter);
};




}  // namespace mojom
}  // namespace web_ui_test

#endif  // CHROME_TEST_DATA_WEBUI_WEB_UI_TEST_MOJOM_TEST_UTILS_H_