// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_PARAMS_DATA_H_
#define COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace chrome_cleaner {
namespace mojom {
namespace internal {
class  ChromePrompt_PromptUser_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChromePrompt_PromptUser_Params_Data));
      new (data()) ChromePrompt_PromptUser_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChromePrompt_PromptUser_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChromePrompt_PromptUser_Params_Data>(index_);
    }
    ChromePrompt_PromptUser_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::FilePath_Data>>> files_to_delete;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::RegistryKey_Data>>> registry_keys;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ExtensionId_Data>>> extension_ids;

 private:
  ChromePrompt_PromptUser_Params_Data();
  ~ChromePrompt_PromptUser_Params_Data() = delete;
};
static_assert(sizeof(ChromePrompt_PromptUser_Params_Data) == 32,
              "Bad sizeof(ChromePrompt_PromptUser_Params_Data)");
class  ChromePrompt_PromptUser_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChromePrompt_PromptUser_ResponseParams_Data));
      new (data()) ChromePrompt_PromptUser_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChromePrompt_PromptUser_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChromePrompt_PromptUser_ResponseParams_Data>(index_);
    }
    ChromePrompt_PromptUser_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t prompt_acceptance;
  uint8_t padfinal_[4];

 private:
  ChromePrompt_PromptUser_ResponseParams_Data();
  ~ChromePrompt_PromptUser_ResponseParams_Data() = delete;
};
static_assert(sizeof(ChromePrompt_PromptUser_ResponseParams_Data) == 16,
              "Bad sizeof(ChromePrompt_PromptUser_ResponseParams_Data)");
class  ChromePrompt_DisableExtensions_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChromePrompt_DisableExtensions_Params_Data));
      new (data()) ChromePrompt_DisableExtensions_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChromePrompt_DisableExtensions_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChromePrompt_DisableExtensions_Params_Data>(index_);
    }
    ChromePrompt_DisableExtensions_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::ExtensionId_Data>>> extension_ids;

 private:
  ChromePrompt_DisableExtensions_Params_Data();
  ~ChromePrompt_DisableExtensions_Params_Data() = delete;
};
static_assert(sizeof(ChromePrompt_DisableExtensions_Params_Data) == 16,
              "Bad sizeof(ChromePrompt_DisableExtensions_Params_Data)");
class  ChromePrompt_DisableExtensions_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ChromePrompt_DisableExtensions_ResponseParams_Data));
      new (data()) ChromePrompt_DisableExtensions_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ChromePrompt_DisableExtensions_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ChromePrompt_DisableExtensions_ResponseParams_Data>(index_);
    }
    ChromePrompt_DisableExtensions_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  ChromePrompt_DisableExtensions_ResponseParams_Data();
  ~ChromePrompt_DisableExtensions_ResponseParams_Data() = delete;
};
static_assert(sizeof(ChromePrompt_DisableExtensions_ResponseParams_Data) == 16,
              "Bad sizeof(ChromePrompt_DisableExtensions_ResponseParams_Data)");

}  // namespace internal
class ChromePrompt_PromptUser_ParamsDataView {
 public:
  ChromePrompt_PromptUser_ParamsDataView() {}

  ChromePrompt_PromptUser_ParamsDataView(
      internal::ChromePrompt_PromptUser_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetFilesToDeleteDataView(
      mojo::ArrayDataView<FilePathDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFilesToDelete(UserType* output) {
    auto* pointer = data_->files_to_delete.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::chrome_cleaner::mojom::FilePathDataView>>(
        pointer, output, context_);
  }
  inline void GetRegistryKeysDataView(
      mojo::ArrayDataView<RegistryKeyDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistryKeys(UserType* output) {
    auto* pointer = data_->header_.version >= 1
                    ? data_->registry_keys.Get() : nullptr;
    return mojo::internal::Deserialize<mojo::ArrayDataView<::chrome_cleaner::mojom::RegistryKeyDataView>>(
        pointer, output, context_);
  }
  inline void GetExtensionIdsDataView(
      mojo::ArrayDataView<ExtensionIdDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExtensionIds(UserType* output) {
    auto* pointer = data_->header_.version >= 2
                    ? data_->extension_ids.Get() : nullptr;
    return mojo::internal::Deserialize<mojo::ArrayDataView<::chrome_cleaner::mojom::ExtensionIdDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ChromePrompt_PromptUser_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ChromePrompt_PromptUser_ResponseParamsDataView {
 public:
  ChromePrompt_PromptUser_ResponseParamsDataView() {}

  ChromePrompt_PromptUser_ResponseParamsDataView(
      internal::ChromePrompt_PromptUser_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPromptAcceptance(UserType* output) const {
    auto data_value = data_->prompt_acceptance;
    return mojo::internal::Deserialize<::chrome_cleaner::mojom::PromptAcceptance>(
        data_value, output);
  }

  PromptAcceptance prompt_acceptance() const {
    return static_cast<PromptAcceptance>(data_->prompt_acceptance);
  }
 private:
  internal::ChromePrompt_PromptUser_ResponseParams_Data* data_ = nullptr;
};

class ChromePrompt_DisableExtensions_ParamsDataView {
 public:
  ChromePrompt_DisableExtensions_ParamsDataView() {}

  ChromePrompt_DisableExtensions_ParamsDataView(
      internal::ChromePrompt_DisableExtensions_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetExtensionIdsDataView(
      mojo::ArrayDataView<ExtensionIdDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadExtensionIds(UserType* output) {
    auto* pointer = data_->extension_ids.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::chrome_cleaner::mojom::ExtensionIdDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ChromePrompt_DisableExtensions_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ChromePrompt_DisableExtensions_ResponseParamsDataView {
 public:
  ChromePrompt_DisableExtensions_ResponseParamsDataView() {}

  ChromePrompt_DisableExtensions_ResponseParamsDataView(
      internal::ChromePrompt_DisableExtensions_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::ChromePrompt_DisableExtensions_ResponseParams_Data* data_ = nullptr;
};


inline void ChromePrompt_PromptUser_ParamsDataView::GetFilesToDeleteDataView(
    mojo::ArrayDataView<FilePathDataView>* output) {
  auto pointer = data_->files_to_delete.Get();
  *output = mojo::ArrayDataView<FilePathDataView>(pointer, context_);
}
inline void ChromePrompt_PromptUser_ParamsDataView::GetRegistryKeysDataView(
    mojo::ArrayDataView<RegistryKeyDataView>* output) {
  auto pointer = data_->header_.version >= 1
                 ? data_->registry_keys.Get() : nullptr;
  *output = mojo::ArrayDataView<RegistryKeyDataView>(pointer, context_);
}
inline void ChromePrompt_PromptUser_ParamsDataView::GetExtensionIdsDataView(
    mojo::ArrayDataView<ExtensionIdDataView>* output) {
  auto pointer = data_->header_.version >= 2
                 ? data_->extension_ids.Get() : nullptr;
  *output = mojo::ArrayDataView<ExtensionIdDataView>(pointer, context_);
}




inline void ChromePrompt_DisableExtensions_ParamsDataView::GetExtensionIdsDataView(
    mojo::ArrayDataView<ExtensionIdDataView>* output) {
  auto pointer = data_->extension_ids.Get();
  *output = mojo::ArrayDataView<ExtensionIdDataView>(pointer, context_);
}



}  // namespace mojom
}  // namespace chrome_cleaner

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_PARAMS_DATA_H_