// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "components/chrome_cleaner/public/interfaces/chrome_prompt.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"


#ifndef COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_JUMBO_H_
#define COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_JUMBO_H_
#include "components/chrome_cleaner/public/typemaps/chrome_prompt_struct_traits.h"
#endif


namespace chrome_cleaner {
namespace mojom {


void ChromePromptInterceptorForTesting::PromptUser(const std::vector<base::FilePath>& files_to_delete, const base::Optional<std::vector<base::string16>>& registry_keys, const base::Optional<std::vector<base::string16>>& extension_ids, PromptUserCallback callback) {
  GetForwardingInterface()->PromptUser(std::move(files_to_delete), std::move(registry_keys), std::move(extension_ids), std::move(callback));
}
void ChromePromptInterceptorForTesting::DisableExtensions(const std::vector<base::string16>& extension_ids, DisableExtensionsCallback callback) {
  GetForwardingInterface()->DisableExtensions(std::move(extension_ids), std::move(callback));
}
ChromePromptAsyncWaiter::ChromePromptAsyncWaiter(
    ChromePrompt* proxy) : proxy_(proxy) {}

ChromePromptAsyncWaiter::~ChromePromptAsyncWaiter() = default;

void ChromePromptAsyncWaiter::PromptUser(
    const std::vector<base::FilePath>& files_to_delete, const base::Optional<std::vector<base::string16>>& registry_keys, const base::Optional<std::vector<base::string16>>& extension_ids, PromptAcceptance* out_prompt_acceptance) {
  base::RunLoop loop;
  proxy_->PromptUser(std::move(files_to_delete),std::move(registry_keys),std::move(extension_ids),
      base::BindOnce(
          [](base::RunLoop* loop,
             PromptAcceptance* out_prompt_acceptance
,
             PromptAcceptance prompt_acceptance) {*out_prompt_acceptance = std::move(prompt_acceptance);
            loop->Quit();
          },
          &loop,
          out_prompt_acceptance));
  loop.Run();
}
void ChromePromptAsyncWaiter::DisableExtensions(
    const std::vector<base::string16>& extension_ids, bool* out_success) {
  base::RunLoop loop;
  proxy_->DisableExtensions(std::move(extension_ids),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}





}  // namespace mojom
}  // namespace chrome_cleaner

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif