// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_TEST_UTILS_H_
#define COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_TEST_UTILS_H_

#include "components/chrome_cleaner/public/interfaces/chrome_prompt.mojom.h"


namespace chrome_cleaner {
namespace mojom {


class  ChromePromptInterceptorForTesting : public ChromePrompt {
  virtual ChromePrompt* GetForwardingInterface() = 0;
  void PromptUser(const std::vector<base::FilePath>& files_to_delete, const base::Optional<std::vector<base::string16>>& registry_keys, const base::Optional<std::vector<base::string16>>& extension_ids, PromptUserCallback callback) override;
  void DisableExtensions(const std::vector<base::string16>& extension_ids, DisableExtensionsCallback callback) override;
};
class  ChromePromptAsyncWaiter {
 public:
  explicit ChromePromptAsyncWaiter(ChromePrompt* proxy);
  ~ChromePromptAsyncWaiter();
  void PromptUser(
      const std::vector<base::FilePath>& files_to_delete, const base::Optional<std::vector<base::string16>>& registry_keys, const base::Optional<std::vector<base::string16>>& extension_ids, PromptAcceptance* out_prompt_acceptance);
  void DisableExtensions(
      const std::vector<base::string16>& extension_ids, bool* out_success);

 private:
  ChromePrompt* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ChromePromptAsyncWaiter);
};




}  // namespace mojom
}  // namespace chrome_cleaner

#endif  // COMPONENTS_CHROME_CLEANER_PUBLIC_INTERFACES_CHROME_PROMPT_MOJOM_TEST_UTILS_H_