// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "components/metrics/public/interfaces/call_stack_profile_collector.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "components/metrics/public/interfaces/call_stack_profile_collector.mojom-params-data.h"
#include "components/metrics/public/interfaces/call_stack_profile_collector.mojom-shared-message-ids.h"

#include "components/metrics/public/interfaces/call_stack_profile_collector.mojom-import-headers.h"


#ifndef COMPONENTS_METRICS_PUBLIC_INTERFACES_CALL_STACK_PROFILE_COLLECTOR_MOJOM_JUMBO_H_
#define COMPONENTS_METRICS_PUBLIC_INTERFACES_CALL_STACK_PROFILE_COLLECTOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#endif
namespace metrics {
namespace mojom {
SampledProfile::SampledProfile()
    : contents() {}

SampledProfile::SampledProfile(
    const std::string& contents_in)
    : contents(std::move(contents_in)) {}

SampledProfile::~SampledProfile() = default;
size_t SampledProfile::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->contents);
  return seed;
}

bool SampledProfile::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char CallStackProfileCollector::Name_[] = "metrics.mojom.CallStackProfileCollector";

CallStackProfileCollectorProxy::CallStackProfileCollectorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void CallStackProfileCollectorProxy::Collect(
    base::TimeTicks in_start_timestamp, SampledProfilePtr in_profile) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::CallStackProfileCollector::Collect");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kCallStackProfileCollector_Collect_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::metrics::mojom::internal::CallStackProfileCollector_Collect_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->start_timestamp)::BaseType::BufferWriter
      start_timestamp_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeTicksDataView>(
      in_start_timestamp, buffer, &start_timestamp_writer, &serialization_context);
  params->start_timestamp.Set(
      start_timestamp_writer.is_null() ? nullptr : start_timestamp_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->start_timestamp.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null start_timestamp in CallStackProfileCollector.Collect request");
  typename decltype(params->profile)::BaseType::BufferWriter
      profile_writer;
  mojo::internal::Serialize<::metrics::mojom::SampledProfileDataView>(
      in_profile, buffer, &profile_writer, &serialization_context);
  params->profile.Set(
      profile_writer.is_null() ? nullptr : profile_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->profile.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null profile in CallStackProfileCollector.Collect request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(CallStackProfileCollector::Name_);
  message.set_method_name("Collect");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool CallStackProfileCollectorStubDispatch::Accept(
    CallStackProfileCollector* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kCallStackProfileCollector_Collect_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::CallStackProfileCollector::Collect",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::CallStackProfileCollector_Collect_Params_Data* params =
          reinterpret_cast<internal::CallStackProfileCollector_Collect_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      base::TimeTicks p_start_timestamp{};
      SampledProfilePtr p_profile{};
      CallStackProfileCollector_Collect_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadStartTimestamp(&p_start_timestamp))
        success = false;
      if (!input_data_view.ReadProfile(&p_profile))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "CallStackProfileCollector::Collect deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Collect(
std::move(p_start_timestamp), 
std::move(p_profile));
      return true;
    }
  }
  return false;
}

// static
bool CallStackProfileCollectorStubDispatch::AcceptWithResponder(
    CallStackProfileCollector* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kCallStackProfileCollector_Collect_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::CallStackProfileCollector::Collect",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool CallStackProfileCollectorRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "CallStackProfileCollector RequestValidator");

  switch (message->header()->name) {
    case internal::kCallStackProfileCollector_Collect_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::CallStackProfileCollector_Collect_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace metrics

namespace mojo {


// static
bool StructTraits<::metrics::mojom::SampledProfile::DataView, ::metrics::mojom::SampledProfilePtr>::Read(
    ::metrics::mojom::SampledProfile::DataView input,
    ::metrics::mojom::SampledProfilePtr* output) {
  bool success = true;
  ::metrics::mojom::SampledProfilePtr result(::metrics::mojom::SampledProfile::New());
  
      if (!input.ReadContents(&result->contents))
        success = false;
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif