// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "components/mirroring/mojom/mirroring_service.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "components/mirroring/mojom/cast_message_channel.mojom.h"
#include "components/mirroring/mojom/resource_provider.mojom.h"
#include "components/mirroring/mojom/session_observer.mojom.h"
#include "components/mirroring/mojom/session_parameters.mojom.h"
#include "ui/gfx/geometry/mojo/geometry.mojom.h"


#ifndef COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_JUMBO_H_
#define COMPONENTS_MIRRORING_MOJOM_MIRRORING_SERVICE_MOJOM_JUMBO_H_
#include "services/network/public/cpp/ip_address_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace mirroring {
namespace mojom {


void MirroringServiceInterceptorForTesting::Start(::mirroring::mojom::SessionParametersPtr params, const gfx::Size& max_resolution, ::mirroring::mojom::SessionObserverPtr observer, ::mirroring::mojom::ResourceProviderPtr resource_provider, ::mirroring::mojom::CastMessageChannelPtr outbound_channel, ::mirroring::mojom::CastMessageChannelRequest inbound_channel) {
  GetForwardingInterface()->Start(std::move(params), std::move(max_resolution), std::move(observer), std::move(resource_provider), std::move(outbound_channel), std::move(inbound_channel));
}
MirroringServiceAsyncWaiter::MirroringServiceAsyncWaiter(
    MirroringService* proxy) : proxy_(proxy) {}

MirroringServiceAsyncWaiter::~MirroringServiceAsyncWaiter() = default;






}  // namespace mojom
}  // namespace mirroring

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif