// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_PARAMS_DATA_H_
#define COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace mirroring {
namespace mojom {
namespace internal {
class  SessionObserver_OnError_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SessionObserver_OnError_Params_Data));
      new (data()) SessionObserver_OnError_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SessionObserver_OnError_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SessionObserver_OnError_Params_Data>(index_);
    }
    SessionObserver_OnError_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t error;
  uint8_t padfinal_[4];

 private:
  SessionObserver_OnError_Params_Data();
  ~SessionObserver_OnError_Params_Data() = delete;
};
static_assert(sizeof(SessionObserver_OnError_Params_Data) == 16,
              "Bad sizeof(SessionObserver_OnError_Params_Data)");
class  SessionObserver_DidStart_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SessionObserver_DidStart_Params_Data));
      new (data()) SessionObserver_DidStart_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SessionObserver_DidStart_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SessionObserver_DidStart_Params_Data>(index_);
    }
    SessionObserver_DidStart_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SessionObserver_DidStart_Params_Data();
  ~SessionObserver_DidStart_Params_Data() = delete;
};
static_assert(sizeof(SessionObserver_DidStart_Params_Data) == 8,
              "Bad sizeof(SessionObserver_DidStart_Params_Data)");
class  SessionObserver_DidStop_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SessionObserver_DidStop_Params_Data));
      new (data()) SessionObserver_DidStop_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SessionObserver_DidStop_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SessionObserver_DidStop_Params_Data>(index_);
    }
    SessionObserver_DidStop_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  SessionObserver_DidStop_Params_Data();
  ~SessionObserver_DidStop_Params_Data() = delete;
};
static_assert(sizeof(SessionObserver_DidStop_Params_Data) == 8,
              "Bad sizeof(SessionObserver_DidStop_Params_Data)");

}  // namespace internal
class SessionObserver_OnError_ParamsDataView {
 public:
  SessionObserver_OnError_ParamsDataView() {}

  SessionObserver_OnError_ParamsDataView(
      internal::SessionObserver_OnError_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) const {
    auto data_value = data_->error;
    return mojo::internal::Deserialize<::mirroring::mojom::SessionError>(
        data_value, output);
  }

  SessionError error() const {
    return static_cast<SessionError>(data_->error);
  }
 private:
  internal::SessionObserver_OnError_Params_Data* data_ = nullptr;
};

class SessionObserver_DidStart_ParamsDataView {
 public:
  SessionObserver_DidStart_ParamsDataView() {}

  SessionObserver_DidStart_ParamsDataView(
      internal::SessionObserver_DidStart_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::SessionObserver_DidStart_Params_Data* data_ = nullptr;
};

class SessionObserver_DidStop_ParamsDataView {
 public:
  SessionObserver_DidStop_ParamsDataView() {}

  SessionObserver_DidStop_ParamsDataView(
      internal::SessionObserver_DidStop_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::SessionObserver_DidStop_Params_Data* data_ = nullptr;
};







}  // namespace mojom
}  // namespace mirroring

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // COMPONENTS_MIRRORING_MOJOM_SESSION_OBSERVER_MOJOM_PARAMS_DATA_H_