// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_TEST_UTILS_H_
#define COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_TEST_UTILS_H_

#include "components/rappor/public/interfaces/rappor_recorder.mojom.h"


namespace rappor {
namespace mojom {


class  RapporRecorderInterceptorForTesting : public RapporRecorder {
  virtual RapporRecorder* GetForwardingInterface() = 0;
  void RecordRappor(const std::string& metric, const std::string& sample) override;
  void RecordRapporURL(const std::string& metric, const GURL& url) override;
};
class  RapporRecorderAsyncWaiter {
 public:
  explicit RapporRecorderAsyncWaiter(RapporRecorder* proxy);
  ~RapporRecorderAsyncWaiter();

 private:
  RapporRecorder* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RapporRecorderAsyncWaiter);
};




}  // namespace mojom
}  // namespace rappor

#endif  // COMPONENTS_RAPPOR_PUBLIC_INTERFACES_RAPPOR_RECORDER_MOJOM_TEST_UTILS_H_