// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SECURITY_INTERSTITIALS_CORE_COMMON_INTERFACES_INTERSTITIAL_COMMANDS_MOJOM_TEST_UTILS_H_
#define COMPONENTS_SECURITY_INTERSTITIALS_CORE_COMMON_INTERFACES_INTERSTITIAL_COMMANDS_MOJOM_TEST_UTILS_H_

#include "components/security_interstitials/core/common/interfaces/interstitial_commands.mojom.h"


namespace security_interstitials {
namespace mojom {


class  InterstitialCommandsInterceptorForTesting : public InterstitialCommands {
  virtual InterstitialCommands* GetForwardingInterface() = 0;
  void DontProceed() override;
  void Proceed() override;
  void ShowMoreSection() override;
  void OpenHelpCenter() override;
  void OpenDiagnostic() override;
  void Reload() override;
  void OpenDateSettings() override;
  void OpenLogin() override;
  void DoReport() override;
  void DontReport() override;
  void OpenReportingPrivacy() override;
  void OpenWhitepaper() override;
  void ReportPhishingError() override;
};
class  InterstitialCommandsAsyncWaiter {
 public:
  explicit InterstitialCommandsAsyncWaiter(InterstitialCommands* proxy);
  ~InterstitialCommandsAsyncWaiter();

 private:
  InterstitialCommands* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(InterstitialCommandsAsyncWaiter);
};




}  // namespace mojom
}  // namespace security_interstitials

#endif  // COMPONENTS_SECURITY_INTERSTITIALS_CORE_COMMON_INTERFACES_INTERSTITIAL_COMMANDS_MOJOM_TEST_UTILS_H_