// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_STARTUP_METRIC_UTILS_COMMON_STARTUP_METRIC_MOJOM_TEST_UTILS_H_
#define COMPONENTS_STARTUP_METRIC_UTILS_COMMON_STARTUP_METRIC_MOJOM_TEST_UTILS_H_

#include "components/startup_metric_utils/common/startup_metric.mojom.h"


namespace startup_metric_utils {
namespace mojom {


class  StartupMetricHostInterceptorForTesting : public StartupMetricHost {
  virtual StartupMetricHost* GetForwardingInterface() = 0;
  void RecordRendererMainEntryTime(base::TimeTicks renderer_main_entry_time) override;
};
class  StartupMetricHostAsyncWaiter {
 public:
  explicit StartupMetricHostAsyncWaiter(StartupMetricHost* proxy);
  ~StartupMetricHostAsyncWaiter();

 private:
  StartupMetricHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(StartupMetricHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace startup_metric_utils

#endif  // COMPONENTS_STARTUP_METRIC_UTILS_COMMON_STARTUP_METRIC_MOJOM_TEST_UTILS_H_