// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SUBRESOURCE_FILTER_CONTENT_MOJOM_SUBRESOURCE_FILTER_AGENT_MOJOM_PARAMS_DATA_H_
#define COMPONENTS_SUBRESOURCE_FILTER_CONTENT_MOJOM_SUBRESOURCE_FILTER_AGENT_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace subresource_filter {
namespace mojom {
namespace internal {
class  SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data));
      new (data()) SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data>(index_);
    }
    SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::subresource_filter::mojom::internal::ActivationState_Data> activation_state;
  int32_t ad_type;
  uint8_t padfinal_[4];

 private:
  SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data();
  ~SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data() = delete;
};
static_assert(sizeof(SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data) == 24,
              "Bad sizeof(SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data)");

}  // namespace internal
class SubresourceFilterAgent_ActivateForNextCommittedLoad_ParamsDataView {
 public:
  SubresourceFilterAgent_ActivateForNextCommittedLoad_ParamsDataView() {}

  SubresourceFilterAgent_ActivateForNextCommittedLoad_ParamsDataView(
      internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetActivationStateDataView(
      ::subresource_filter::mojom::ActivationStateDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadActivationState(UserType* output) {
    auto* pointer = data_->activation_state.Get();
    return mojo::internal::Deserialize<::subresource_filter::mojom::ActivationStateDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAdType(UserType* output) const {
    auto data_value = data_->ad_type;
    return mojo::internal::Deserialize<::blink::mojom::AdFrameType>(
        data_value, output);
  }

  ::blink::mojom::AdFrameType ad_type() const {
    return static_cast<::blink::mojom::AdFrameType>(data_->ad_type);
  }
 private:
  internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void SubresourceFilterAgent_ActivateForNextCommittedLoad_ParamsDataView::GetActivationStateDataView(
    ::subresource_filter::mojom::ActivationStateDataView* output) {
  auto pointer = data_->activation_state.Get();
  *output = ::subresource_filter::mojom::ActivationStateDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace subresource_filter

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // COMPONENTS_SUBRESOURCE_FILTER_CONTENT_MOJOM_SUBRESOURCE_FILTER_AGENT_MOJOM_PARAMS_DATA_H_