// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "components/subresource_filter/content/mojom/subresource_filter_agent.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "components/subresource_filter/content/mojom/subresource_filter_agent.mojom-params-data.h"
#include "components/subresource_filter/content/mojom/subresource_filter_agent.mojom-shared-message-ids.h"

#include "components/subresource_filter/content/mojom/subresource_filter_agent.mojom-import-headers.h"


#ifndef COMPONENTS_SUBRESOURCE_FILTER_CONTENT_MOJOM_SUBRESOURCE_FILTER_AGENT_MOJOM_JUMBO_H_
#define COMPONENTS_SUBRESOURCE_FILTER_CONTENT_MOJOM_SUBRESOURCE_FILTER_AGENT_MOJOM_JUMBO_H_
#endif
namespace subresource_filter {
namespace mojom {
const char SubresourceFilterAgent::Name_[] = "subresource_filter.mojom.SubresourceFilterAgent";

SubresourceFilterAgentProxy::SubresourceFilterAgentProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void SubresourceFilterAgentProxy::ActivateForNextCommittedLoad(
    ::subresource_filter::mojom::ActivationStatePtr in_activation_state, ::blink::mojom::AdFrameType in_ad_type) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::SubresourceFilterAgent::ActivateForNextCommittedLoad");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kSubresourceFilterAgent_ActivateForNextCommittedLoad_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::subresource_filter::mojom::internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->activation_state)::BaseType::BufferWriter
      activation_state_writer;
  mojo::internal::Serialize<::subresource_filter::mojom::ActivationStateDataView>(
      in_activation_state, buffer, &activation_state_writer, &serialization_context);
  params->activation_state.Set(
      activation_state_writer.is_null() ? nullptr : activation_state_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->activation_state.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null activation_state in SubresourceFilterAgent.ActivateForNextCommittedLoad request");
  mojo::internal::Serialize<::blink::mojom::AdFrameType>(
      in_ad_type, &params->ad_type);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(SubresourceFilterAgent::Name_);
  message.set_method_name("ActivateForNextCommittedLoad");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool SubresourceFilterAgentStubDispatch::Accept(
    SubresourceFilterAgent* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kSubresourceFilterAgent_ActivateForNextCommittedLoad_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::SubresourceFilterAgent::ActivateForNextCommittedLoad",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      DCHECK(message->is_serialized());
      internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data* params =
          reinterpret_cast<internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::subresource_filter::mojom::ActivationStatePtr p_activation_state{};
      ::blink::mojom::AdFrameType p_ad_type{};
      SubresourceFilterAgent_ActivateForNextCommittedLoad_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadActivationState(&p_activation_state))
        success = false;
      if (!input_data_view.ReadAdType(&p_ad_type))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "SubresourceFilterAgent::ActivateForNextCommittedLoad deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->ActivateForNextCommittedLoad(
std::move(p_activation_state), 
std::move(p_ad_type));
      return true;
    }
  }
  return false;
}

// static
bool SubresourceFilterAgentStubDispatch::AcceptWithResponder(
    SubresourceFilterAgent* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kSubresourceFilterAgent_ActivateForNextCommittedLoad_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::SubresourceFilterAgent::ActivateForNextCommittedLoad",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool SubresourceFilterAgentRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "SubresourceFilterAgent RequestValidator");

  switch (message->header()->name) {
    case internal::kSubresourceFilterAgent_ActivateForNextCommittedLoad_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::SubresourceFilterAgent_ActivateForNextCommittedLoad_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

}  // namespace mojom
}  // namespace subresource_filter

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif