// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SUBRESOURCE_FILTER_CORE_MOJOM_SUBRESOURCE_FILTER_MOJOM_TEST_UTILS_H_
#define COMPONENTS_SUBRESOURCE_FILTER_CORE_MOJOM_SUBRESOURCE_FILTER_MOJOM_TEST_UTILS_H_

#include "components/subresource_filter/core/mojom/subresource_filter.mojom.h"


namespace subresource_filter {
namespace mojom {


class  SubresourceFilterHostInterceptorForTesting : public SubresourceFilterHost {
  virtual SubresourceFilterHost* GetForwardingInterface() = 0;
  void DidDisallowFirstSubresource() override;
  void FrameIsAdSubframe() override;
  void SetDocumentLoadStatistics(DocumentLoadStatisticsPtr statistics) override;
};
class  SubresourceFilterHostAsyncWaiter {
 public:
  explicit SubresourceFilterHostAsyncWaiter(SubresourceFilterHost* proxy);
  ~SubresourceFilterHostAsyncWaiter();

 private:
  SubresourceFilterHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(SubresourceFilterHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace subresource_filter

#endif  // COMPONENTS_SUBRESOURCE_FILTER_CORE_MOJOM_SUBRESOURCE_FILTER_MOJOM_TEST_UTILS_H_