// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "components/translate/content/common/translate.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "services/network/public/mojom/url_loader_factory.mojom.h"
#include "url/mojom/url.mojom.h"


#ifndef COMPONENTS_TRANSLATE_CONTENT_COMMON_TRANSLATE_MOJOM_JUMBO_H_
#define COMPONENTS_TRANSLATE_CONTENT_COMMON_TRANSLATE_MOJOM_JUMBO_H_
#include "components/translate/content/common/translate_struct_traits.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif


namespace translate {
namespace mojom {


void PageInterceptorForTesting::Translate(const std::string& translate_script, ::network::mojom::URLLoaderFactoryPtr loader_factory_for_translate_script, const std::string& source_lang, const std::string& target_lang, TranslateCallback callback) {
  GetForwardingInterface()->Translate(std::move(translate_script), std::move(loader_factory_for_translate_script), std::move(source_lang), std::move(target_lang), std::move(callback));
}
void PageInterceptorForTesting::RevertTranslation() {
  GetForwardingInterface()->RevertTranslation();
}
PageAsyncWaiter::PageAsyncWaiter(
    Page* proxy) : proxy_(proxy) {}

PageAsyncWaiter::~PageAsyncWaiter() = default;

void PageAsyncWaiter::Translate(
    const std::string& translate_script, ::network::mojom::URLLoaderFactoryPtr loader_factory_for_translate_script, const std::string& source_lang, const std::string& target_lang, bool* out_cancelled, std::string* out_original_lang, std::string* out_translated_lang, translate::TranslateErrors::Type* out_error) {
  base::RunLoop loop;
  proxy_->Translate(std::move(translate_script),std::move(loader_factory_for_translate_script),std::move(source_lang),std::move(target_lang),
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_cancelled
,
             std::string* out_original_lang
,
             std::string* out_translated_lang
,
             translate::TranslateErrors::Type* out_error
,
             bool cancelled,
             const std::string& original_lang,
             const std::string& translated_lang,
             translate::TranslateErrors::Type error) {*out_cancelled = std::move(cancelled);*out_original_lang = std::move(original_lang);*out_translated_lang = std::move(translated_lang);*out_error = std::move(error);
            loop->Quit();
          },
          &loop,
          out_cancelled,
          out_original_lang,
          out_translated_lang,
          out_error));
  loop.Run();
}



void ContentTranslateDriverInterceptorForTesting::RegisterPage(PagePtr page, const translate::LanguageDetectionDetails& details, bool page_needs_translation) {
  GetForwardingInterface()->RegisterPage(std::move(page), std::move(details), std::move(page_needs_translation));
}
ContentTranslateDriverAsyncWaiter::ContentTranslateDriverAsyncWaiter(
    ContentTranslateDriver* proxy) : proxy_(proxy) {}

ContentTranslateDriverAsyncWaiter::~ContentTranslateDriverAsyncWaiter() = default;






}  // namespace mojom
}  // namespace translate

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif