// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_WEB_CACHE_PUBLIC_MOJOM_WEB_CACHE_MOJOM_TEST_UTILS_H_
#define COMPONENTS_WEB_CACHE_PUBLIC_MOJOM_WEB_CACHE_MOJOM_TEST_UTILS_H_

#include "components/web_cache/public/mojom/web_cache.mojom.h"


namespace web_cache {
namespace mojom {


class  WebCacheInterceptorForTesting : public WebCache {
  virtual WebCache* GetForwardingInterface() = 0;
  void SetCacheCapacity(uint64_t capacity) override;
  void ClearCache(bool on_navigation) override;
};
class  WebCacheAsyncWaiter {
 public:
  explicit WebCacheAsyncWaiter(WebCache* proxy);
  ~WebCacheAsyncWaiter();

 private:
  WebCache* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebCacheAsyncWaiter);
};




}  // namespace mojom
}  // namespace web_cache

#endif  // COMPONENTS_WEB_CACHE_PUBLIC_MOJOM_WEB_CACHE_MOJOM_TEST_UTILS_H_