// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_PARAMS_DATA_H_
#define CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace mojom {
namespace internal {
class  ProcessInternalsHandler_GetIsolationMode_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data));
      new (data()) ProcessInternalsHandler_GetIsolationMode_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolationMode_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolationMode_Params_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolationMode_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessInternalsHandler_GetIsolationMode_Params_Data();
  ~ProcessInternalsHandler_GetIsolationMode_Params_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data) == 8,
              "Bad sizeof(ProcessInternalsHandler_GetIsolationMode_Params_Data)");
class  ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data));
      new (data()) ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> mode;

 private:
  ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data();
  ~ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data)");
class  ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data));
      new (data()) ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data();
  ~ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data) == 8,
              "Bad sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data)");
class  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data));
      new (data()) ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data>(index_);
    }
    ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t size;
  uint8_t padfinal_[4];

 private:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data();
  ~ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data)");
class  ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data));
      new (data()) ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data>(index_);
    }
    ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data();
  ~ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data) == 8,
              "Bad sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data)");
class  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data));
      new (data()) ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data>(index_);
    }
    ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::WebContentsInfo_Data>>> infos;

 private:
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data();
  ~ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data) == 16,
              "Bad sizeof(ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data)");

}  // namespace internal
class ProcessInternalsHandler_GetIsolationMode_ParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolationMode_ParamsDataView() {}

  ProcessInternalsHandler_GetIsolationMode_ParamsDataView(
      internal::ProcessInternalsHandler_GetIsolationMode_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessInternalsHandler_GetIsolationMode_Params_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView() {}

  ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView(
      internal::ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetModeDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadMode(UserType* output) {
    auto* pointer = data_->mode.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProcessInternalsHandler_GetIsolationMode_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView() {}

  ProcessInternalsHandler_GetIsolatedOriginsSize_ParamsDataView(
      internal::ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessInternalsHandler_GetIsolatedOriginsSize_Params_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView {
 public:
  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView() {}

  ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParamsDataView(
      internal::ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t size() const {
    return data_->size;
  }
 private:
  internal::ProcessInternalsHandler_GetIsolatedOriginsSize_ResponseParams_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetAllWebContentsInfo_ParamsDataView {
 public:
  ProcessInternalsHandler_GetAllWebContentsInfo_ParamsDataView() {}

  ProcessInternalsHandler_GetAllWebContentsInfo_ParamsDataView(
      internal::ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProcessInternalsHandler_GetAllWebContentsInfo_Params_Data* data_ = nullptr;
};

class ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParamsDataView {
 public:
  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParamsDataView() {}

  ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParamsDataView(
      internal::ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInfosDataView(
      mojo::ArrayDataView<WebContentsInfoDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInfos(UserType* output) {
    auto* pointer = data_->infos.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::mojom::WebContentsInfoDataView>>(
        pointer, output, context_);
  }
 private:
  internal::ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void ProcessInternalsHandler_GetIsolationMode_ResponseParamsDataView::GetModeDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->mode.Get();
  *output = mojo::StringDataView(pointer, context_);
}








inline void ProcessInternalsHandler_GetAllWebContentsInfo_ResponseParamsDataView::GetInfosDataView(
    mojo::ArrayDataView<WebContentsInfoDataView>* output) {
  auto pointer = data_->infos.Get();
  *output = mojo::ArrayDataView<WebContentsInfoDataView>(pointer, context_);
}

}  // namespace mojom

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_PARAMS_DATA_H_