// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_TEST_UTILS_H_
#define CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_TEST_UTILS_H_

#include "content/browser/process_internals/process_internals.mojom.h"


namespace mojom {


class  ProcessInternalsHandlerInterceptorForTesting : public ProcessInternalsHandler {
  virtual ProcessInternalsHandler* GetForwardingInterface() = 0;
  void GetIsolationMode(GetIsolationModeCallback callback) override;
  void GetIsolatedOriginsSize(GetIsolatedOriginsSizeCallback callback) override;
  void GetAllWebContentsInfo(GetAllWebContentsInfoCallback callback) override;
};
class  ProcessInternalsHandlerAsyncWaiter {
 public:
  explicit ProcessInternalsHandlerAsyncWaiter(ProcessInternalsHandler* proxy);
  ~ProcessInternalsHandlerAsyncWaiter();
  void GetIsolationMode(
      std::string* out_mode);
  void GetIsolatedOriginsSize(
      uint32_t* out_size);
  void GetAllWebContentsInfo(
      std::vector<WebContentsInfoPtr>* out_infos);

 private:
  ProcessInternalsHandler* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProcessInternalsHandlerAsyncWaiter);
};




}  // namespace mojom

#endif  // CONTENT_BROWSER_PROCESS_INTERNALS_PROCESS_INTERNALS_MOJOM_TEST_UTILS_H_