// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "content/common/document_scoped_interface_bundle.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "content/common/document_scoped_interface_bundle.mojom-params-data.h"
#include "content/common/document_scoped_interface_bundle.mojom-shared-message-ids.h"

#include "content/common/document_scoped_interface_bundle.mojom-import-headers.h"


#ifndef CONTENT_COMMON_DOCUMENT_SCOPED_INTERFACE_BUNDLE_MOJOM_JUMBO_H_
#define CONTENT_COMMON_DOCUMENT_SCOPED_INTERFACE_BUNDLE_MOJOM_JUMBO_H_
#endif
namespace content {
namespace mojom {
DocumentScopedInterfaceBundle::DocumentScopedInterfaceBundle()
    : interface_provider(),
      document_interface_broker_content(),
      document_interface_broker_blink() {}

DocumentScopedInterfaceBundle::DocumentScopedInterfaceBundle(
    ::service_manager::mojom::InterfaceProviderPtrInfo interface_provider_in,
    ::blink::mojom::DocumentInterfaceBrokerPtrInfo document_interface_broker_content_in,
    ::blink::mojom::DocumentInterfaceBrokerPtrInfo document_interface_broker_blink_in)
    : interface_provider(std::move(interface_provider_in)),
      document_interface_broker_content(std::move(document_interface_broker_content_in)),
      document_interface_broker_blink(std::move(document_interface_broker_blink_in)) {}

DocumentScopedInterfaceBundle::~DocumentScopedInterfaceBundle() = default;

bool DocumentScopedInterfaceBundle::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
}  // namespace mojom
}  // namespace content

namespace mojo {


// static
bool StructTraits<::content::mojom::DocumentScopedInterfaceBundle::DataView, ::content::mojom::DocumentScopedInterfaceBundlePtr>::Read(
    ::content::mojom::DocumentScopedInterfaceBundle::DataView input,
    ::content::mojom::DocumentScopedInterfaceBundlePtr* output) {
  bool success = true;
  ::content::mojom::DocumentScopedInterfaceBundlePtr result(::content::mojom::DocumentScopedInterfaceBundle::New());
  
      result->interface_provider =
          input.TakeInterfaceProvider<decltype(result->interface_provider)>();
      result->document_interface_broker_content =
          input.TakeDocumentInterfaceBrokerContent<decltype(result->document_interface_broker_content)>();
      result->document_interface_broker_blink =
          input.TakeDocumentInterfaceBrokerBlink<decltype(result->document_interface_broker_blink)>();
  *output = std::move(result);
  return success;
}

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif