// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_DOWNLOAD_MHTML_FILE_WRITER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_DOWNLOAD_MHTML_FILE_WRITER_MOJOM_TEST_UTILS_H_

#include "content/common/download/mhtml_file_writer.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT MhtmlFileWriterInterceptorForTesting : public MhtmlFileWriter {
  virtual MhtmlFileWriter* GetForwardingInterface() = 0;
  void SerializeAsMHTML(SerializeAsMHTMLParamsPtr params, SerializeAsMHTMLCallback callback) override;
};
class CONTENT_EXPORT MhtmlFileWriterAsyncWaiter {
 public:
  explicit MhtmlFileWriterAsyncWaiter(MhtmlFileWriter* proxy);
  ~MhtmlFileWriterAsyncWaiter();
  void SerializeAsMHTML(
      SerializeAsMHTMLParamsPtr params, MhtmlSaveStatus* out_status, std::vector<std::string>* out_digests_of_uris_to_skip, base::TimeDelta* out_renderer_main_thread_time);

 private:
  MhtmlFileWriter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MhtmlFileWriterAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_DOWNLOAD_MHTML_FILE_WRITER_MOJOM_TEST_UTILS_H_