// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/frame_sink_provider.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "content/common/render_frame_metadata.mojom.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom.h"


#ifndef CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_JUMBO_H_
#define CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_JUMBO_H_
#endif


namespace content {
namespace mojom {


void FrameSinkProviderInterceptorForTesting::CreateForWidget(int32_t widget_id, ::viz::mojom::CompositorFrameSinkRequest compositor_frame_sink_request, ::viz::mojom::CompositorFrameSinkClientPtr compositor_frame_sink_client) {
  GetForwardingInterface()->CreateForWidget(std::move(widget_id), std::move(compositor_frame_sink_request), std::move(compositor_frame_sink_client));
}
void FrameSinkProviderInterceptorForTesting::RegisterRenderFrameMetadataObserver(int32_t widget_id, ::content::mojom::RenderFrameMetadataObserverClientRequest render_frame_metadata_observer_client_request, ::content::mojom::RenderFrameMetadataObserverPtr render_frame_metadata_observer) {
  GetForwardingInterface()->RegisterRenderFrameMetadataObserver(std::move(widget_id), std::move(render_frame_metadata_observer_client_request), std::move(render_frame_metadata_observer));
}
FrameSinkProviderAsyncWaiter::FrameSinkProviderAsyncWaiter(
    FrameSinkProvider* proxy) : proxy_(proxy) {}

FrameSinkProviderAsyncWaiter::~FrameSinkProviderAsyncWaiter() = default;






}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif