// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_TEST_UTILS_H_

#include "content/common/frame_sink_provider.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT FrameSinkProviderInterceptorForTesting : public FrameSinkProvider {
  virtual FrameSinkProvider* GetForwardingInterface() = 0;
  void CreateForWidget(int32_t widget_id, ::viz::mojom::CompositorFrameSinkRequest compositor_frame_sink_request, ::viz::mojom::CompositorFrameSinkClientPtr compositor_frame_sink_client) override;
  void RegisterRenderFrameMetadataObserver(int32_t widget_id, ::content::mojom::RenderFrameMetadataObserverClientRequest render_frame_metadata_observer_client_request, ::content::mojom::RenderFrameMetadataObserverPtr render_frame_metadata_observer) override;
};
class CONTENT_EXPORT FrameSinkProviderAsyncWaiter {
 public:
  explicit FrameSinkProviderAsyncWaiter(FrameSinkProvider* proxy);
  ~FrameSinkProviderAsyncWaiter();

 private:
  FrameSinkProvider* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameSinkProviderAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_FRAME_SINK_PROVIDER_MOJOM_TEST_UTILS_H_