// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_HOST_ZOOM_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_HOST_ZOOM_MOJOM_TEST_UTILS_H_

#include "content/common/host_zoom.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT HostZoomInterceptorForTesting : public HostZoom {
  virtual HostZoom* GetForwardingInterface() = 0;
  void SetHostZoomLevel(const GURL& url, double zoom_level) override;
};
class CONTENT_EXPORT HostZoomAsyncWaiter {
 public:
  explicit HostZoomAsyncWaiter(HostZoom* proxy);
  ~HostZoomAsyncWaiter();

 private:
  HostZoom* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(HostZoomAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_HOST_ZOOM_MOJOM_TEST_UTILS_H_