// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_MANIFEST_OBSERVER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_MANIFEST_OBSERVER_MOJOM_TEST_UTILS_H_

#include "content/common/manifest_observer.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT ManifestUrlChangeObserverInterceptorForTesting : public ManifestUrlChangeObserver {
  virtual ManifestUrlChangeObserver* GetForwardingInterface() = 0;
  void ManifestUrlChanged(const base::Optional<GURL>& manifest_url) override;
};
class CONTENT_EXPORT ManifestUrlChangeObserverAsyncWaiter {
 public:
  explicit ManifestUrlChangeObserverAsyncWaiter(ManifestUrlChangeObserver* proxy);
  ~ManifestUrlChangeObserverAsyncWaiter();

 private:
  ManifestUrlChangeObserver* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ManifestUrlChangeObserverAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_MANIFEST_OBSERVER_MOJOM_TEST_UTILS_H_