// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_MEDIA_PEER_CONNECTION_TRACKER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_MEDIA_PEER_CONNECTION_TRACKER_MOJOM_TEST_UTILS_H_

#include "content/common/media/peer_connection_tracker.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT PeerConnectionTrackerHostInterceptorForTesting : public PeerConnectionTrackerHost {
  virtual PeerConnectionTrackerHost* GetForwardingInterface() = 0;
  void RemovePeerConnection(int32_t lid) override;
  void UpdatePeerConnection(int32_t lid, const std::string& type, const std::string& value) override;
  void OnPeerConnectionSessionIdSet(int32_t lid, const std::string& session_id) override;
  void GetUserMedia(const std::string& origin, bool audio, bool video, const std::string& audio_constraints, const std::string& video_constraints) override;
  void WebRtcEventLogWrite(int32_t lid, const std::string& output) override;
};
class CONTENT_EXPORT PeerConnectionTrackerHostAsyncWaiter {
 public:
  explicit PeerConnectionTrackerHostAsyncWaiter(PeerConnectionTrackerHost* proxy);
  ~PeerConnectionTrackerHostAsyncWaiter();

 private:
  PeerConnectionTrackerHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(PeerConnectionTrackerHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_MEDIA_PEER_CONNECTION_TRACKER_MOJOM_TEST_UTILS_H_