// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_PARAMS_DATA_H_
#define CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace content {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderFrameMessageFilter_SetCookie_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderFrameMessageFilter_SetCookie_Params_Data));
      new (data()) RenderFrameMessageFilter_SetCookie_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderFrameMessageFilter_SetCookie_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderFrameMessageFilter_SetCookie_Params_Data>(index_);
    }
    RenderFrameMessageFilter_SetCookie_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t render_frame_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> first_party_for_cookies;
  mojo::internal::Pointer<mojo::internal::String_Data> cookie;

 private:
  RenderFrameMessageFilter_SetCookie_Params_Data();
  ~RenderFrameMessageFilter_SetCookie_Params_Data() = delete;
};
static_assert(sizeof(RenderFrameMessageFilter_SetCookie_Params_Data) == 40,
              "Bad sizeof(RenderFrameMessageFilter_SetCookie_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderFrameMessageFilter_SetCookie_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderFrameMessageFilter_SetCookie_ResponseParams_Data));
      new (data()) RenderFrameMessageFilter_SetCookie_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderFrameMessageFilter_SetCookie_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderFrameMessageFilter_SetCookie_ResponseParams_Data>(index_);
    }
    RenderFrameMessageFilter_SetCookie_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  RenderFrameMessageFilter_SetCookie_ResponseParams_Data();
  ~RenderFrameMessageFilter_SetCookie_ResponseParams_Data() = delete;
};
static_assert(sizeof(RenderFrameMessageFilter_SetCookie_ResponseParams_Data) == 8,
              "Bad sizeof(RenderFrameMessageFilter_SetCookie_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderFrameMessageFilter_GetCookies_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderFrameMessageFilter_GetCookies_Params_Data));
      new (data()) RenderFrameMessageFilter_GetCookies_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderFrameMessageFilter_GetCookies_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderFrameMessageFilter_GetCookies_Params_Data>(index_);
    }
    RenderFrameMessageFilter_GetCookies_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t render_frame_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> first_party_for_cookies;

 private:
  RenderFrameMessageFilter_GetCookies_Params_Data();
  ~RenderFrameMessageFilter_GetCookies_Params_Data() = delete;
};
static_assert(sizeof(RenderFrameMessageFilter_GetCookies_Params_Data) == 32,
              "Bad sizeof(RenderFrameMessageFilter_GetCookies_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderFrameMessageFilter_GetCookies_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderFrameMessageFilter_GetCookies_ResponseParams_Data));
      new (data()) RenderFrameMessageFilter_GetCookies_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderFrameMessageFilter_GetCookies_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderFrameMessageFilter_GetCookies_ResponseParams_Data>(index_);
    }
    RenderFrameMessageFilter_GetCookies_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> cookies;

 private:
  RenderFrameMessageFilter_GetCookies_ResponseParams_Data();
  ~RenderFrameMessageFilter_GetCookies_ResponseParams_Data() = delete;
};
static_assert(sizeof(RenderFrameMessageFilter_GetCookies_ResponseParams_Data) == 16,
              "Bad sizeof(RenderFrameMessageFilter_GetCookies_ResponseParams_Data)");

}  // namespace internal
class RenderFrameMessageFilter_SetCookie_ParamsDataView {
 public:
  RenderFrameMessageFilter_SetCookie_ParamsDataView() {}

  RenderFrameMessageFilter_SetCookie_ParamsDataView(
      internal::RenderFrameMessageFilter_SetCookie_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t render_frame_id() const {
    return data_->render_frame_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetFirstPartyForCookiesDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFirstPartyForCookies(UserType* output) {
    auto* pointer = data_->first_party_for_cookies.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetCookieDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCookie(UserType* output) {
    auto* pointer = data_->cookie.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::RenderFrameMessageFilter_SetCookie_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RenderFrameMessageFilter_SetCookie_ResponseParamsDataView {
 public:
  RenderFrameMessageFilter_SetCookie_ResponseParamsDataView() {}

  RenderFrameMessageFilter_SetCookie_ResponseParamsDataView(
      internal::RenderFrameMessageFilter_SetCookie_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::RenderFrameMessageFilter_SetCookie_ResponseParams_Data* data_ = nullptr;
};

class RenderFrameMessageFilter_GetCookies_ParamsDataView {
 public:
  RenderFrameMessageFilter_GetCookies_ParamsDataView() {}

  RenderFrameMessageFilter_GetCookies_ParamsDataView(
      internal::RenderFrameMessageFilter_GetCookies_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t render_frame_id() const {
    return data_->render_frame_id;
  }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  inline void GetFirstPartyForCookiesDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFirstPartyForCookies(UserType* output) {
    auto* pointer = data_->first_party_for_cookies.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
 private:
  internal::RenderFrameMessageFilter_GetCookies_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RenderFrameMessageFilter_GetCookies_ResponseParamsDataView {
 public:
  RenderFrameMessageFilter_GetCookies_ResponseParamsDataView() {}

  RenderFrameMessageFilter_GetCookies_ResponseParamsDataView(
      internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetCookiesDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCookies(UserType* output) {
    auto* pointer = data_->cookies.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::RenderFrameMessageFilter_GetCookies_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void RenderFrameMessageFilter_SetCookie_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void RenderFrameMessageFilter_SetCookie_ParamsDataView::GetFirstPartyForCookiesDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->first_party_for_cookies.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void RenderFrameMessageFilter_SetCookie_ParamsDataView::GetCookieDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->cookie.Get();
  *output = mojo::StringDataView(pointer, context_);
}




inline void RenderFrameMessageFilter_GetCookies_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void RenderFrameMessageFilter_GetCookies_ParamsDataView::GetFirstPartyForCookiesDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->first_party_for_cookies.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}


inline void RenderFrameMessageFilter_GetCookies_ResponseParamsDataView::GetCookiesDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->cookies.Get();
  *output = mojo::StringDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_PARAMS_DATA_H_