// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_TEST_UTILS_H_

#include "content/common/render_frame_message_filter.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT RenderFrameMessageFilterInterceptorForTesting : public RenderFrameMessageFilter {
  virtual RenderFrameMessageFilter* GetForwardingInterface() = 0;
  void SetCookie(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie, SetCookieCallback callback) override;
  void GetCookies(int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, GetCookiesCallback callback) override;
};
class CONTENT_EXPORT RenderFrameMessageFilterAsyncWaiter {
 public:
  explicit RenderFrameMessageFilterAsyncWaiter(RenderFrameMessageFilter* proxy);
  ~RenderFrameMessageFilterAsyncWaiter();
  void SetCookie(
      int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, const std::string& cookie);
  void GetCookies(
      int32_t render_frame_id, const GURL& url, const GURL& first_party_for_cookies, std::string* out_cookies);

 private:
  RenderFrameMessageFilter* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(RenderFrameMessageFilterAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_RENDER_FRAME_MESSAGE_FILTER_MOJOM_TEST_UTILS_H_