// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_PARAMS_DATA_H_
#define CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace content {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderWidgetWindowTreeClient_Embed_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderWidgetWindowTreeClient_Embed_Params_Data));
      new (data()) RenderWidgetWindowTreeClient_Embed_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderWidgetWindowTreeClient_Embed_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderWidgetWindowTreeClient_Embed_Params_Data>(index_);
    }
    RenderWidgetWindowTreeClient_Embed_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t frame_routing_id;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> token;

 private:
  RenderWidgetWindowTreeClient_Embed_Params_Data();
  ~RenderWidgetWindowTreeClient_Embed_Params_Data() = delete;
};
static_assert(sizeof(RenderWidgetWindowTreeClient_Embed_Params_Data) == 24,
              "Bad sizeof(RenderWidgetWindowTreeClient_Embed_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderWidgetWindowTreeClient_DestroyFrame_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderWidgetWindowTreeClient_DestroyFrame_Params_Data));
      new (data()) RenderWidgetWindowTreeClient_DestroyFrame_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderWidgetWindowTreeClient_DestroyFrame_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderWidgetWindowTreeClient_DestroyFrame_Params_Data>(index_);
    }
    RenderWidgetWindowTreeClient_DestroyFrame_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t frame_routing_id;
  uint8_t padfinal_[4];

 private:
  RenderWidgetWindowTreeClient_DestroyFrame_Params_Data();
  ~RenderWidgetWindowTreeClient_DestroyFrame_Params_Data() = delete;
};
static_assert(sizeof(RenderWidgetWindowTreeClient_DestroyFrame_Params_Data) == 16,
              "Bad sizeof(RenderWidgetWindowTreeClient_DestroyFrame_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data));
      new (data()) RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data>(index_);
    }
    RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t render_widget_host_routing_id;
  mojo::internal::Handle_Data window_tree_client;
  mojo::internal::Handle_Data render_widget_window_tree_client_request;
  uint8_t padfinal_[4];

 private:
  RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data();
  ~RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data() = delete;
};
static_assert(sizeof(RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data) == 24,
              "Bad sizeof(RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data)");

}  // namespace internal
class RenderWidgetWindowTreeClient_Embed_ParamsDataView {
 public:
  RenderWidgetWindowTreeClient_Embed_ParamsDataView() {}

  RenderWidgetWindowTreeClient_Embed_ParamsDataView(
      internal::RenderWidgetWindowTreeClient_Embed_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t frame_routing_id() const {
    return data_->frame_routing_id;
  }
  inline void GetTokenDataView(
      ::mojo_base::mojom::UnguessableTokenDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadToken(UserType* output) {
    auto* pointer = data_->token.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::UnguessableTokenDataView>(
        pointer, output, context_);
  }
 private:
  internal::RenderWidgetWindowTreeClient_Embed_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class RenderWidgetWindowTreeClient_DestroyFrame_ParamsDataView {
 public:
  RenderWidgetWindowTreeClient_DestroyFrame_ParamsDataView() {}

  RenderWidgetWindowTreeClient_DestroyFrame_ParamsDataView(
      internal::RenderWidgetWindowTreeClient_DestroyFrame_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t frame_routing_id() const {
    return data_->frame_routing_id;
  }
 private:
  internal::RenderWidgetWindowTreeClient_DestroyFrame_Params_Data* data_ = nullptr;
};

class RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_ParamsDataView {
 public:
  RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_ParamsDataView() {}

  RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_ParamsDataView(
      internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint32_t render_widget_host_routing_id() const {
    return data_->render_widget_host_routing_id;
  }
  template <typename UserType>
  UserType TakeWindowTreeClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ws::mojom::WindowTreeClientRequestDataView>(
            &data_->window_tree_client, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeRenderWidgetWindowTreeClientRequest() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::content::mojom::RenderWidgetWindowTreeClientRequestDataView>(
            &data_->render_widget_window_tree_client_request, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::RenderWidgetWindowTreeClientFactory_CreateWindowTreeClientForRenderWidget_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void RenderWidgetWindowTreeClient_Embed_ParamsDataView::GetTokenDataView(
    ::mojo_base::mojom::UnguessableTokenDataView* output) {
  auto pointer = data_->token.Get();
  *output = ::mojo_base::mojom::UnguessableTokenDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_PARAMS_DATA_H_