// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "content/common/render_widget_window_tree_client_factory.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/unguessable_token.mojom.h"
#include "services/ws/public/mojom/window_tree.mojom.h"


#ifndef CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_JUMBO_H_
#define CONTENT_COMMON_RENDER_WIDGET_WINDOW_TREE_CLIENT_FACTORY_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#endif


namespace content {
namespace mojom {


void RenderWidgetWindowTreeClientInterceptorForTesting::Embed(uint32_t frame_routing_id, const base::UnguessableToken& token) {
  GetForwardingInterface()->Embed(std::move(frame_routing_id), std::move(token));
}
void RenderWidgetWindowTreeClientInterceptorForTesting::DestroyFrame(uint32_t frame_routing_id) {
  GetForwardingInterface()->DestroyFrame(std::move(frame_routing_id));
}
RenderWidgetWindowTreeClientAsyncWaiter::RenderWidgetWindowTreeClientAsyncWaiter(
    RenderWidgetWindowTreeClient* proxy) : proxy_(proxy) {}

RenderWidgetWindowTreeClientAsyncWaiter::~RenderWidgetWindowTreeClientAsyncWaiter() = default;




void RenderWidgetWindowTreeClientFactoryInterceptorForTesting::CreateWindowTreeClientForRenderWidget(uint32_t render_widget_host_routing_id, ::ws::mojom::WindowTreeClientRequest window_tree_client, RenderWidgetWindowTreeClientRequest render_widget_window_tree_client_request) {
  GetForwardingInterface()->CreateWindowTreeClientForRenderWidget(std::move(render_widget_host_routing_id), std::move(window_tree_client), std::move(render_widget_window_tree_client_request));
}
RenderWidgetWindowTreeClientFactoryAsyncWaiter::RenderWidgetWindowTreeClientFactoryAsyncWaiter(
    RenderWidgetWindowTreeClientFactory* proxy) : proxy_(proxy) {}

RenderWidgetWindowTreeClientFactoryAsyncWaiter::~RenderWidgetWindowTreeClientFactoryAsyncWaiter() = default;






}  // namespace mojom
}  // namespace content

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif