// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_WIDGET_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_WIDGET_MOJOM_TEST_UTILS_H_

#include "content/common/widget.mojom.h"
#include "content/common/content_export.h"


namespace content {
namespace mojom {


class CONTENT_EXPORT WidgetInterceptorForTesting : public Widget {
  virtual Widget* GetForwardingInterface() = 0;
  void SetupWidgetInputHandler(::content::mojom::WidgetInputHandlerRequest request, ::content::mojom::WidgetInputHandlerHostPtr host) override;
};
class CONTENT_EXPORT WidgetAsyncWaiter {
 public:
  explicit WidgetAsyncWaiter(Widget* proxy);
  ~WidgetAsyncWaiter();

 private:
  Widget* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WidgetAsyncWaiter);
};




}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_WIDGET_MOJOM_TEST_UTILS_H_