// automatically generated by the FlatBuffers compiler, do not modify


#ifndef FLATBUFFERS_GENERATED_EXTENSIONRULESET_EXTENSIONS_DECLARATIVE_NET_REQUEST_FLAT_H_
#define FLATBUFFERS_GENERATED_EXTENSIONRULESET_EXTENSIONS_DECLARATIVE_NET_REQUEST_FLAT_H_

#include "flatbuffers/flatbuffers.h"

#include "components/url_pattern_index/flat/url_pattern_index_generated.h"

namespace extensions {
namespace declarative_net_request {
namespace flat {

struct UrlRuleMetadata;

struct ExtensionIndexedRuleset;

/// This provides a mapping from an action to its index within the |index_list|
/// vector.
enum ActionIndex {
  ActionIndex_block = 0,
  ActionIndex_allow = 1,
  ActionIndex_redirect = 2,
  ActionIndex_remove_cookie_header = 3,
  ActionIndex_remove_referer_header = 4,
  ActionIndex_remove_set_cookie_header = 5  /// Number of actions. Must be the last entry.
,
  ActionIndex_count = 6,
  ActionIndex_MIN = ActionIndex_block,
  ActionIndex_MAX = ActionIndex_count
};

inline const ActionIndex (&EnumValuesActionIndex())[7] {
  static const ActionIndex values[] = {
    ActionIndex_block,
    ActionIndex_allow,
    ActionIndex_redirect,
    ActionIndex_remove_cookie_header,
    ActionIndex_remove_referer_header,
    ActionIndex_remove_set_cookie_header,
    ActionIndex_count
  };
  return values;
}

inline const char * const *EnumNamesActionIndex() {
  static const char * const names[] = {
    "block",
    "allow",
    "redirect",
    "remove_cookie_header",
    "remove_referer_header",
    "remove_set_cookie_header",
    "count",
    nullptr
  };
  return names;
}

inline const char *EnumNameActionIndex(ActionIndex e) {
  if (e < ActionIndex_block || e > ActionIndex_count) return "";
  const size_t index = static_cast<int>(e);
  return EnumNamesActionIndex()[index];
}

/// Additional extension related metadata for a url_pattern_index UrlRule.
struct UrlRuleMetadata FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_ID = 4,
    VT_REDIRECT_URL = 6
  };
  /// ID of the UrlRule for which this metadata is stored.
  uint32_t id() const {
    return GetField<uint32_t>(VT_ID, 0);
  }
  bool KeyCompareLessThan(const UrlRuleMetadata *o) const {
    return id() < o->id();
  }
  int KeyCompareWithValue(uint32_t val) const {
    return static_cast<int>(id() > val) - static_cast<int>(id() < val);
  }
  /// Redirect url for this rule. Should represent a valid GURL.
  const flatbuffers::String *redirect_url() const {
    return GetPointer<const flatbuffers::String *>(VT_REDIRECT_URL);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyField<uint32_t>(verifier, VT_ID) &&
           VerifyOffset(verifier, VT_REDIRECT_URL) &&
           verifier.VerifyString(redirect_url()) &&
           verifier.EndTable();
  }
};

struct UrlRuleMetadataBuilder {
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_id(uint32_t id) {
    fbb_.AddElement<uint32_t>(UrlRuleMetadata::VT_ID, id, 0);
  }
  void add_redirect_url(flatbuffers::Offset<flatbuffers::String> redirect_url) {
    fbb_.AddOffset(UrlRuleMetadata::VT_REDIRECT_URL, redirect_url);
  }
  explicit UrlRuleMetadataBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  UrlRuleMetadataBuilder &operator=(const UrlRuleMetadataBuilder &);
  flatbuffers::Offset<UrlRuleMetadata> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<UrlRuleMetadata>(end);
    return o;
  }
};

inline flatbuffers::Offset<UrlRuleMetadata> CreateUrlRuleMetadata(
    flatbuffers::FlatBufferBuilder &_fbb,
    uint32_t id = 0,
    flatbuffers::Offset<flatbuffers::String> redirect_url = 0) {
  UrlRuleMetadataBuilder builder_(_fbb);
  builder_.add_redirect_url(redirect_url);
  builder_.add_id(id);
  return builder_.Finish();
}

inline flatbuffers::Offset<UrlRuleMetadata> CreateUrlRuleMetadataDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    uint32_t id = 0,
    const char *redirect_url = nullptr) {
  auto redirect_url__ = redirect_url ? _fbb.CreateString(redirect_url) : 0;
  return extensions::declarative_net_request::flat::CreateUrlRuleMetadata(
      _fbb,
      id,
      redirect_url__);
}

/// The top-level data structure used to store extensions URL rules for the
/// Declarative Net Request API.
struct ExtensionIndexedRuleset FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_INDEX_LIST = 4,
    VT_EXTENSION_METADATA = 6
  };
  /// Vector of UrlPatternIndex for different action types. This will consist
  /// of ActionIndex_count indices.
  const flatbuffers::Vector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>> *index_list() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>> *>(VT_INDEX_LIST);
  }
  /// Extension related metadata. Sorted by id, to support fast lookup.
  /// Currently this is only used for redirect rules.
  const flatbuffers::Vector<flatbuffers::Offset<UrlRuleMetadata>> *extension_metadata() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<UrlRuleMetadata>> *>(VT_EXTENSION_METADATA);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_INDEX_LIST) &&
           verifier.VerifyVector(index_list()) &&
           verifier.VerifyVectorOfTables(index_list()) &&
           VerifyOffset(verifier, VT_EXTENSION_METADATA) &&
           verifier.VerifyVector(extension_metadata()) &&
           verifier.VerifyVectorOfTables(extension_metadata()) &&
           verifier.EndTable();
  }
};

struct ExtensionIndexedRulesetBuilder {
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_index_list(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>>> index_list) {
    fbb_.AddOffset(ExtensionIndexedRuleset::VT_INDEX_LIST, index_list);
  }
  void add_extension_metadata(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<UrlRuleMetadata>>> extension_metadata) {
    fbb_.AddOffset(ExtensionIndexedRuleset::VT_EXTENSION_METADATA, extension_metadata);
  }
  explicit ExtensionIndexedRulesetBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  ExtensionIndexedRulesetBuilder &operator=(const ExtensionIndexedRulesetBuilder &);
  flatbuffers::Offset<ExtensionIndexedRuleset> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<ExtensionIndexedRuleset>(end);
    return o;
  }
};

inline flatbuffers::Offset<ExtensionIndexedRuleset> CreateExtensionIndexedRuleset(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>>> index_list = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<UrlRuleMetadata>>> extension_metadata = 0) {
  ExtensionIndexedRulesetBuilder builder_(_fbb);
  builder_.add_extension_metadata(extension_metadata);
  builder_.add_index_list(index_list);
  return builder_.Finish();
}

inline flatbuffers::Offset<ExtensionIndexedRuleset> CreateExtensionIndexedRulesetDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>> *index_list = nullptr,
    const std::vector<flatbuffers::Offset<UrlRuleMetadata>> *extension_metadata = nullptr) {
  auto index_list__ = index_list ? _fbb.CreateVector<flatbuffers::Offset<url_pattern_index::flat::UrlPatternIndex>>(*index_list) : 0;
  auto extension_metadata__ = extension_metadata ? _fbb.CreateVector<flatbuffers::Offset<UrlRuleMetadata>>(*extension_metadata) : 0;
  return extensions::declarative_net_request::flat::CreateExtensionIndexedRuleset(
      _fbb,
      index_list__,
      extension_metadata__);
}

inline const extensions::declarative_net_request::flat::ExtensionIndexedRuleset *GetExtensionIndexedRuleset(const void *buf) {
  return flatbuffers::GetRoot<extensions::declarative_net_request::flat::ExtensionIndexedRuleset>(buf);
}

inline const extensions::declarative_net_request::flat::ExtensionIndexedRuleset *GetSizePrefixedExtensionIndexedRuleset(const void *buf) {
  return flatbuffers::GetSizePrefixedRoot<extensions::declarative_net_request::flat::ExtensionIndexedRuleset>(buf);
}

inline const char *ExtensionIndexedRulesetIdentifier() {
  return "EXTR";
}

inline bool ExtensionIndexedRulesetBufferHasIdentifier(const void *buf) {
  return flatbuffers::BufferHasIdentifier(
      buf, ExtensionIndexedRulesetIdentifier());
}

inline bool VerifyExtensionIndexedRulesetBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifyBuffer<extensions::declarative_net_request::flat::ExtensionIndexedRuleset>(ExtensionIndexedRulesetIdentifier());
}

inline bool VerifySizePrefixedExtensionIndexedRulesetBuffer(
    flatbuffers::Verifier &verifier) {
  return verifier.VerifySizePrefixedBuffer<extensions::declarative_net_request::flat::ExtensionIndexedRuleset>(ExtensionIndexedRulesetIdentifier());
}

inline void FinishExtensionIndexedRulesetBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<extensions::declarative_net_request::flat::ExtensionIndexedRuleset> root) {
  fbb.Finish(root, ExtensionIndexedRulesetIdentifier());
}

inline void FinishSizePrefixedExtensionIndexedRulesetBuffer(
    flatbuffers::FlatBufferBuilder &fbb,
    flatbuffers::Offset<extensions::declarative_net_request::flat::ExtensionIndexedRuleset> root) {
  fbb.FinishSizePrefixed(root, ExtensionIndexedRulesetIdentifier());
}

}  // namespace flat
}  // namespace declarative_net_request
}  // namespace extensions

#endif  // FLATBUFFERS_GENERATED_EXTENSIONRULESET_EXTENSIONS_DECLARATIVE_NET_REQUEST_FLAT_H_
