// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_
#define MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_

#include "media/mojo/interfaces/mjpeg_decode_accelerator.mojom-blink.h"


namespace media {
namespace mojom {
namespace blink {


class  MjpegDecodeAcceleratorInterceptorForTesting : public MjpegDecodeAccelerator {
  virtual MjpegDecodeAccelerator* GetForwardingInterface() = 0;
  void Initialize(InitializeCallback callback) override;
  void Decode(BitstreamBufferPtr input_buffer, const ::blink::WebSize& coded_size, mojo::ScopedSharedBufferHandle output_handle, uint32_t output_buffer_size, DecodeCallback callback) override;
  void DecodeWithFD(int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, DecodeWithFDCallback callback) override;
  void Uninitialize() override;
};
class  MjpegDecodeAcceleratorAsyncWaiter {
 public:
  explicit MjpegDecodeAcceleratorAsyncWaiter(MjpegDecodeAccelerator* proxy);
  ~MjpegDecodeAcceleratorAsyncWaiter();
  void Initialize(
      bool* out_success);
  void Decode(
      BitstreamBufferPtr input_buffer, const ::blink::WebSize& coded_size, mojo::ScopedSharedBufferHandle output_handle, uint32_t output_buffer_size, int32_t* out_bitstream_buffer_id, DecodeError* out_error);
  void DecodeWithFD(
      int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, int32_t* out_buffer_id, DecodeError* out_error);

 private:
  MjpegDecodeAccelerator* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(MjpegDecodeAcceleratorAsyncWaiter);
};




}  // namespace blink
}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_BLINK_TEST_UTILS_H_