// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_
#define MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace media {
namespace mojom {
namespace internal {
class  MjpegDecodeAccelerator_Initialize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_Initialize_Params_Data));
      new (data()) MjpegDecodeAccelerator_Initialize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_Initialize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_Initialize_Params_Data>(index_);
    }
    MjpegDecodeAccelerator_Initialize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MjpegDecodeAccelerator_Initialize_Params_Data();
  ~MjpegDecodeAccelerator_Initialize_Params_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_Initialize_Params_Data) == 8,
              "Bad sizeof(MjpegDecodeAccelerator_Initialize_Params_Data)");
class  MjpegDecodeAccelerator_Initialize_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_Initialize_ResponseParams_Data));
      new (data()) MjpegDecodeAccelerator_Initialize_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_Initialize_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_Initialize_ResponseParams_Data>(index_);
    }
    MjpegDecodeAccelerator_Initialize_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  MjpegDecodeAccelerator_Initialize_ResponseParams_Data();
  ~MjpegDecodeAccelerator_Initialize_ResponseParams_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_Initialize_ResponseParams_Data) == 16,
              "Bad sizeof(MjpegDecodeAccelerator_Initialize_ResponseParams_Data)");
class  MjpegDecodeAccelerator_Decode_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_Decode_Params_Data));
      new (data()) MjpegDecodeAccelerator_Decode_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_Decode_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_Decode_Params_Data>(index_);
    }
    MjpegDecodeAccelerator_Decode_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::BitstreamBuffer_Data> input_buffer;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> coded_size;
  mojo::internal::Handle_Data output_handle;
  uint32_t output_buffer_size;

 private:
  MjpegDecodeAccelerator_Decode_Params_Data();
  ~MjpegDecodeAccelerator_Decode_Params_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_Decode_Params_Data) == 32,
              "Bad sizeof(MjpegDecodeAccelerator_Decode_Params_Data)");
class  MjpegDecodeAccelerator_Decode_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_Decode_ResponseParams_Data));
      new (data()) MjpegDecodeAccelerator_Decode_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_Decode_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_Decode_ResponseParams_Data>(index_);
    }
    MjpegDecodeAccelerator_Decode_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t bitstream_buffer_id;
  int32_t error;

 private:
  MjpegDecodeAccelerator_Decode_ResponseParams_Data();
  ~MjpegDecodeAccelerator_Decode_ResponseParams_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_Decode_ResponseParams_Data) == 16,
              "Bad sizeof(MjpegDecodeAccelerator_Decode_ResponseParams_Data)");
class  MjpegDecodeAccelerator_DecodeWithFD_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_DecodeWithFD_Params_Data));
      new (data()) MjpegDecodeAccelerator_DecodeWithFD_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_DecodeWithFD_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_DecodeWithFD_Params_Data>(index_);
    }
    MjpegDecodeAccelerator_DecodeWithFD_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  mojo::internal::Handle_Data input_fd;
  uint32_t input_buffer_size;
  int32_t coded_size_width;
  int32_t coded_size_height;
  mojo::internal::Handle_Data output_fd;
  uint32_t output_buffer_size;
  uint8_t padfinal_[4];

 private:
  MjpegDecodeAccelerator_DecodeWithFD_Params_Data();
  ~MjpegDecodeAccelerator_DecodeWithFD_Params_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_DecodeWithFD_Params_Data) == 40,
              "Bad sizeof(MjpegDecodeAccelerator_DecodeWithFD_Params_Data)");
class  MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data));
      new (data()) MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data>(index_);
    }
    MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t buffer_id;
  int32_t error;

 private:
  MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data();
  ~MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data) == 16,
              "Bad sizeof(MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data)");
class  MjpegDecodeAccelerator_Uninitialize_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(MjpegDecodeAccelerator_Uninitialize_Params_Data));
      new (data()) MjpegDecodeAccelerator_Uninitialize_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    MjpegDecodeAccelerator_Uninitialize_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<MjpegDecodeAccelerator_Uninitialize_Params_Data>(index_);
    }
    MjpegDecodeAccelerator_Uninitialize_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  MjpegDecodeAccelerator_Uninitialize_Params_Data();
  ~MjpegDecodeAccelerator_Uninitialize_Params_Data() = delete;
};
static_assert(sizeof(MjpegDecodeAccelerator_Uninitialize_Params_Data) == 8,
              "Bad sizeof(MjpegDecodeAccelerator_Uninitialize_Params_Data)");

}  // namespace internal
class MjpegDecodeAccelerator_Initialize_ParamsDataView {
 public:
  MjpegDecodeAccelerator_Initialize_ParamsDataView() {}

  MjpegDecodeAccelerator_Initialize_ParamsDataView(
      internal::MjpegDecodeAccelerator_Initialize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MjpegDecodeAccelerator_Initialize_Params_Data* data_ = nullptr;
};

class MjpegDecodeAccelerator_Initialize_ResponseParamsDataView {
 public:
  MjpegDecodeAccelerator_Initialize_ResponseParamsDataView() {}

  MjpegDecodeAccelerator_Initialize_ResponseParamsDataView(
      internal::MjpegDecodeAccelerator_Initialize_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::MjpegDecodeAccelerator_Initialize_ResponseParams_Data* data_ = nullptr;
};

class MjpegDecodeAccelerator_Decode_ParamsDataView {
 public:
  MjpegDecodeAccelerator_Decode_ParamsDataView() {}

  MjpegDecodeAccelerator_Decode_ParamsDataView(
      internal::MjpegDecodeAccelerator_Decode_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetInputBufferDataView(
      BitstreamBufferDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadInputBuffer(UserType* output) {
    auto* pointer = data_->input_buffer.Get();
    return mojo::internal::Deserialize<::media::mojom::BitstreamBufferDataView>(
        pointer, output, context_);
  }
  inline void GetCodedSizeDataView(
      ::gfx::mojom::SizeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCodedSize(UserType* output) {
    auto* pointer = data_->coded_size.Get();
    return mojo::internal::Deserialize<::gfx::mojom::SizeDataView>(
        pointer, output, context_);
  }
  mojo::ScopedSharedBufferHandle TakeOutputHandle() {
    mojo::ScopedSharedBufferHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedSharedBufferHandle>(
            &data_->output_handle, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t output_buffer_size() const {
    return data_->output_buffer_size;
  }
 private:
  internal::MjpegDecodeAccelerator_Decode_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MjpegDecodeAccelerator_Decode_ResponseParamsDataView {
 public:
  MjpegDecodeAccelerator_Decode_ResponseParamsDataView() {}

  MjpegDecodeAccelerator_Decode_ResponseParamsDataView(
      internal::MjpegDecodeAccelerator_Decode_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t bitstream_buffer_id() const {
    return data_->bitstream_buffer_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) const {
    auto data_value = data_->error;
    return mojo::internal::Deserialize<::media::mojom::DecodeError>(
        data_value, output);
  }

  DecodeError error() const {
    return static_cast<DecodeError>(data_->error);
  }
 private:
  internal::MjpegDecodeAccelerator_Decode_ResponseParams_Data* data_ = nullptr;
};

class MjpegDecodeAccelerator_DecodeWithFD_ParamsDataView {
 public:
  MjpegDecodeAccelerator_DecodeWithFD_ParamsDataView() {}

  MjpegDecodeAccelerator_DecodeWithFD_ParamsDataView(
      internal::MjpegDecodeAccelerator_DecodeWithFD_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  mojo::ScopedHandle TakeInputFd() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->input_fd, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t input_buffer_size() const {
    return data_->input_buffer_size;
  }
  int32_t coded_size_width() const {
    return data_->coded_size_width;
  }
  int32_t coded_size_height() const {
    return data_->coded_size_height;
  }
  mojo::ScopedHandle TakeOutputFd() {
    mojo::ScopedHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedHandle>(
            &data_->output_fd, &result, context_);
    DCHECK(ret);
    return result;
  }
  uint32_t output_buffer_size() const {
    return data_->output_buffer_size;
  }
 private:
  internal::MjpegDecodeAccelerator_DecodeWithFD_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class MjpegDecodeAccelerator_DecodeWithFD_ResponseParamsDataView {
 public:
  MjpegDecodeAccelerator_DecodeWithFD_ResponseParamsDataView() {}

  MjpegDecodeAccelerator_DecodeWithFD_ResponseParamsDataView(
      internal::MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int32_t buffer_id() const {
    return data_->buffer_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadError(UserType* output) const {
    auto data_value = data_->error;
    return mojo::internal::Deserialize<::media::mojom::DecodeError>(
        data_value, output);
  }

  DecodeError error() const {
    return static_cast<DecodeError>(data_->error);
  }
 private:
  internal::MjpegDecodeAccelerator_DecodeWithFD_ResponseParams_Data* data_ = nullptr;
};

class MjpegDecodeAccelerator_Uninitialize_ParamsDataView {
 public:
  MjpegDecodeAccelerator_Uninitialize_ParamsDataView() {}

  MjpegDecodeAccelerator_Uninitialize_ParamsDataView(
      internal::MjpegDecodeAccelerator_Uninitialize_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::MjpegDecodeAccelerator_Uninitialize_Params_Data* data_ = nullptr;
};






inline void MjpegDecodeAccelerator_Decode_ParamsDataView::GetInputBufferDataView(
    BitstreamBufferDataView* output) {
  auto pointer = data_->input_buffer.Get();
  *output = BitstreamBufferDataView(pointer, context_);
}
inline void MjpegDecodeAccelerator_Decode_ParamsDataView::GetCodedSizeDataView(
    ::gfx::mojom::SizeDataView* output) {
  auto pointer = data_->coded_size.Get();
  *output = ::gfx::mojom::SizeDataView(pointer, context_);
}









}  // namespace mojom
}  // namespace media

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_PARAMS_DATA_H_