// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "media/mojo/interfaces/mjpeg_decode_accelerator.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "media/mojo/interfaces/media_types.mojom.h"
#include "mojo/public/mojom/base/time.mojom.h"
#include "ui/gfx/geometry/mojo/geometry.mojom.h"


#ifndef MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_JUMBO_H_
#define MEDIA_MOJO_INTERFACES_MJPEG_DECODE_ACCELERATOR_MOJOM_JUMBO_H_
#include "media/base/ipc/media_param_traits_macros.h"
#include "media/mojo/interfaces/mjpeg_decode_accelerator_mojom_traits.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#endif


namespace media {
namespace mojom {


void MjpegDecodeAcceleratorInterceptorForTesting::Initialize(InitializeCallback callback) {
  GetForwardingInterface()->Initialize(std::move(callback));
}
void MjpegDecodeAcceleratorInterceptorForTesting::Decode(const media::BitstreamBuffer& input_buffer, const gfx::Size& coded_size, mojo::ScopedSharedBufferHandle output_handle, uint32_t output_buffer_size, DecodeCallback callback) {
  GetForwardingInterface()->Decode(std::move(input_buffer), std::move(coded_size), std::move(output_handle), std::move(output_buffer_size), std::move(callback));
}
void MjpegDecodeAcceleratorInterceptorForTesting::DecodeWithFD(int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, DecodeWithFDCallback callback) {
  GetForwardingInterface()->DecodeWithFD(std::move(buffer_id), std::move(input_fd), std::move(input_buffer_size), std::move(coded_size_width), std::move(coded_size_height), std::move(output_fd), std::move(output_buffer_size), std::move(callback));
}
void MjpegDecodeAcceleratorInterceptorForTesting::Uninitialize() {
  GetForwardingInterface()->Uninitialize();
}
MjpegDecodeAcceleratorAsyncWaiter::MjpegDecodeAcceleratorAsyncWaiter(
    MjpegDecodeAccelerator* proxy) : proxy_(proxy) {}

MjpegDecodeAcceleratorAsyncWaiter::~MjpegDecodeAcceleratorAsyncWaiter() = default;

void MjpegDecodeAcceleratorAsyncWaiter::Initialize(
    bool* out_success) {
  base::RunLoop loop;
  proxy_->Initialize(
      base::BindOnce(
          [](base::RunLoop* loop,
             bool* out_success
,
             bool success) {*out_success = std::move(success);
            loop->Quit();
          },
          &loop,
          out_success));
  loop.Run();
}
void MjpegDecodeAcceleratorAsyncWaiter::Decode(
    const media::BitstreamBuffer& input_buffer, const gfx::Size& coded_size, mojo::ScopedSharedBufferHandle output_handle, uint32_t output_buffer_size, int32_t* out_bitstream_buffer_id, media::MjpegDecodeAccelerator::Error* out_error) {
  base::RunLoop loop;
  proxy_->Decode(std::move(input_buffer),std::move(coded_size),std::move(output_handle),std::move(output_buffer_size),
      base::BindOnce(
          [](base::RunLoop* loop,
             int32_t* out_bitstream_buffer_id
,
             media::MjpegDecodeAccelerator::Error* out_error
,
             int32_t bitstream_buffer_id,
             media::MjpegDecodeAccelerator::Error error) {*out_bitstream_buffer_id = std::move(bitstream_buffer_id);*out_error = std::move(error);
            loop->Quit();
          },
          &loop,
          out_bitstream_buffer_id,
          out_error));
  loop.Run();
}
void MjpegDecodeAcceleratorAsyncWaiter::DecodeWithFD(
    int32_t buffer_id, mojo::ScopedHandle input_fd, uint32_t input_buffer_size, int32_t coded_size_width, int32_t coded_size_height, mojo::ScopedHandle output_fd, uint32_t output_buffer_size, int32_t* out_buffer_id, media::MjpegDecodeAccelerator::Error* out_error) {
  base::RunLoop loop;
  proxy_->DecodeWithFD(std::move(buffer_id),std::move(input_fd),std::move(input_buffer_size),std::move(coded_size_width),std::move(coded_size_height),std::move(output_fd),std::move(output_buffer_size),
      base::BindOnce(
          [](base::RunLoop* loop,
             int32_t* out_buffer_id
,
             media::MjpegDecodeAccelerator::Error* out_error
,
             int32_t buffer_id,
             media::MjpegDecodeAccelerator::Error error) {*out_buffer_id = std::move(buffer_id);*out_error = std::move(error);
            loop->Quit();
          },
          &loop,
          out_buffer_id,
          out_error));
  loop.Run();
}





}  // namespace mojom
}  // namespace media

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif