// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_AUDIO_PUBLIC_MOJOM_AUDIO_PROCESSING_MOJOM_TEST_UTILS_H_
#define SERVICES_AUDIO_PUBLIC_MOJOM_AUDIO_PROCESSING_MOJOM_TEST_UTILS_H_

#include "services/audio/public/mojom/audio_processing.mojom.h"


namespace audio {
namespace mojom {


class  AudioProcessorControlsInterceptorForTesting : public AudioProcessorControls {
  virtual AudioProcessorControls* GetForwardingInterface() = 0;
  void GetStats(GetStatsCallback callback) override;
  void StartEchoCancellationDump(base::File file) override;
  void StopEchoCancellationDump() override;
};
class  AudioProcessorControlsAsyncWaiter {
 public:
  explicit AudioProcessorControlsAsyncWaiter(AudioProcessorControls* proxy);
  ~AudioProcessorControlsAsyncWaiter();
  void GetStats(
      webrtc::AudioProcessorInterface::AudioProcessorStatistics* out_stats);

 private:
  AudioProcessorControls* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AudioProcessorControlsAsyncWaiter);
};




}  // namespace mojom
}  // namespace audio

#endif  // SERVICES_AUDIO_PUBLIC_MOJOM_AUDIO_PROCESSING_MOJOM_TEST_UTILS_H_