// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DATA_DECODER_PUBLIC_MOJOM_JSON_PARSER_MOJOM_TEST_UTILS_H_
#define SERVICES_DATA_DECODER_PUBLIC_MOJOM_JSON_PARSER_MOJOM_TEST_UTILS_H_

#include "services/data_decoder/public/mojom/json_parser.mojom.h"


namespace data_decoder {
namespace mojom {


class  JsonParserInterceptorForTesting : public JsonParser {
  virtual JsonParser* GetForwardingInterface() = 0;
  void Parse(const std::string& json, ParseCallback callback) override;
};
class  JsonParserAsyncWaiter {
 public:
  explicit JsonParserAsyncWaiter(JsonParser* proxy);
  ~JsonParserAsyncWaiter();
  void Parse(
      const std::string& json, base::Optional<base::Value>* out_result, base::Optional<std::string>* out_error);

 private:
  JsonParser* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(JsonParserAsyncWaiter);
};




}  // namespace mojom
}  // namespace data_decoder

#endif  // SERVICES_DATA_DECODER_PUBLIC_MOJOM_JSON_PARSER_MOJOM_TEST_UTILS_H_