// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DATA_DECODER_PUBLIC_MOJOM_XML_PARSER_MOJOM_TEST_UTILS_H_
#define SERVICES_DATA_DECODER_PUBLIC_MOJOM_XML_PARSER_MOJOM_TEST_UTILS_H_

#include "services/data_decoder/public/mojom/xml_parser.mojom.h"


namespace data_decoder {
namespace mojom {


class  XmlParserInterceptorForTesting : public XmlParser {
  virtual XmlParser* GetForwardingInterface() = 0;
  void Parse(const std::string& xml, ParseCallback callback) override;
};
class  XmlParserAsyncWaiter {
 public:
  explicit XmlParserAsyncWaiter(XmlParser* proxy);
  ~XmlParserAsyncWaiter();
  void Parse(
      const std::string& xml, base::Optional<base::Value>* out_result, base::Optional<std::string>* out_error);

 private:
  XmlParser* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(XmlParserAsyncWaiter);
};




}  // namespace mojom
}  // namespace data_decoder

#endif  // SERVICES_DATA_DECODER_PUBLIC_MOJOM_XML_PARSER_MOJOM_TEST_UTILS_H_