// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_TEST_UTILS_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_TEST_UTILS_H_

#include "services/identity/public/mojom/identity_accessor.mojom.h"


namespace identity {
namespace mojom {


class  IdentityAccessorInterceptorForTesting : public IdentityAccessor {
  virtual IdentityAccessor* GetForwardingInterface() = 0;
  void GetPrimaryAccountInfo(GetPrimaryAccountInfoCallback callback) override;
  void GetPrimaryAccountWhenAvailable(GetPrimaryAccountWhenAvailableCallback callback) override;
  void GetAccessToken(const std::string& account_id, const ::identity::ScopeSet& scopes, const std::string& consumer_id, GetAccessTokenCallback callback) override;
};
class  IdentityAccessorAsyncWaiter {
 public:
  explicit IdentityAccessorAsyncWaiter(IdentityAccessor* proxy);
  ~IdentityAccessorAsyncWaiter();
  void GetPrimaryAccountInfo(
      base::Optional<::AccountInfo>* out_account_info, identity::AccountState* out_account_state);
  void GetPrimaryAccountWhenAvailable(
      ::AccountInfo* out_account_info, identity::AccountState* out_account_state);
  void GetAccessToken(
      const std::string& account_id, const ::identity::ScopeSet& scopes, const std::string& consumer_id, base::Optional<std::string>* out_token, base::Time* out_expiration_time, ::GoogleServiceAuthError* out_error);

 private:
  IdentityAccessor* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(IdentityAccessorAsyncWaiter);
};




}  // namespace mojom
}  // namespace identity

#endif  // SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_TEST_UTILS_H_