// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/identity/public/mojom/identity_accessor.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/identity/public/mojom/identity_accessor.mojom-params-data.h"
#include "services/identity/public/mojom/identity_accessor.mojom-shared-message-ids.h"

#include "services/identity/public/mojom/identity_accessor.mojom-import-headers.h"


#ifndef SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_JUMBO_H_
#define SERVICES_IDENTITY_PUBLIC_MOJOM_IDENTITY_ACCESSOR_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/time_mojom_traits.h"
#include "services/identity/public/cpp/account_info_mojom_traits.h"
#include "services/identity/public/cpp/account_state_mojom_traits.h"
#include "services/identity/public/cpp/google_service_auth_error_mojom_traits.h"
#include "services/identity/public/cpp/scope_set_mojom_traits.h"
#include "url/mojom/url_gurl_mojom_traits.h"
#endif
namespace identity {
namespace mojom {
const char IdentityAccessor::Name_[] = "identity.mojom.IdentityAccessor";

class IdentityAccessor_GetPrimaryAccountInfo_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  IdentityAccessor_GetPrimaryAccountInfo_ForwardToCallback(
      IdentityAccessor::GetPrimaryAccountInfoCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  IdentityAccessor::GetPrimaryAccountInfoCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetPrimaryAccountInfo_ForwardToCallback);
};

class IdentityAccessor_GetPrimaryAccountWhenAvailable_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ForwardToCallback(
      IdentityAccessor::GetPrimaryAccountWhenAvailableCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  IdentityAccessor::GetPrimaryAccountWhenAvailableCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetPrimaryAccountWhenAvailable_ForwardToCallback);
};

class IdentityAccessor_GetAccessToken_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  IdentityAccessor_GetAccessToken_ForwardToCallback(
      IdentityAccessor::GetAccessTokenCallback callback
      ) : callback_(std::move(callback)) {
  }
  bool Accept(mojo::Message* message) override;
 private:
  IdentityAccessor::GetAccessTokenCallback callback_;
  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetAccessToken_ForwardToCallback);
};

IdentityAccessorProxy::IdentityAccessorProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void IdentityAccessorProxy::GetPrimaryAccountInfo(
    GetPrimaryAccountInfoCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountInfo");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetPrimaryAccountInfo_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetPrimaryAccountInfo");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new IdentityAccessor_GetPrimaryAccountInfo_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IdentityAccessorProxy::GetPrimaryAccountWhenAvailable(
    GetPrimaryAccountWhenAvailableCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountWhenAvailable");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetPrimaryAccountWhenAvailable");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new IdentityAccessor_GetPrimaryAccountWhenAvailable_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}

void IdentityAccessorProxy::GetAccessToken(
    const std::string& in_account_id, const ::identity::ScopeSet& in_scopes, const std::string& in_consumer_id, GetAccessTokenCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetAccessToken");
#endif
  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetAccessToken_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetAccessToken_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->account_id)::BaseType::BufferWriter
      account_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_account_id, buffer, &account_id_writer, &serialization_context);
  params->account_id.Set(
      account_id_writer.is_null() ? nullptr : account_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->account_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null account_id in IdentityAccessor.GetAccessToken request");
  typename decltype(params->scopes)::BaseType::BufferWriter
      scopes_writer;
  mojo::internal::Serialize<::identity::mojom::ScopeSetDataView>(
      in_scopes, buffer, &scopes_writer, &serialization_context);
  params->scopes.Set(
      scopes_writer.is_null() ? nullptr : scopes_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->scopes.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null scopes in IdentityAccessor.GetAccessToken request");
  typename decltype(params->consumer_id)::BaseType::BufferWriter
      consumer_id_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_consumer_id, buffer, &consumer_id_writer, &serialization_context);
  params->consumer_id.Set(
      consumer_id_writer.is_null() ? nullptr : consumer_id_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->consumer_id.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null consumer_id in IdentityAccessor.GetAccessToken request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetAccessToken");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new IdentityAccessor_GetAccessToken_ForwardToCallback(
          std::move(callback)));
  ignore_result(receiver_->AcceptWithResponder(&message, std::move(responder)));
}
class IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder {
 public:
  static IdentityAccessor::GetPrimaryAccountInfoCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder> proxy(
        new IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "IdentityAccessor::GetPrimaryAccountInfoCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const base::Optional<::AccountInfo>& in_account_info, const identity::AccountState& in_account_state);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder);
};

bool IdentityAccessor_GetPrimaryAccountInfo_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountInfoCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data* params =
      reinterpret_cast<
          internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  base::Optional<::AccountInfo> p_account_info{};
  identity::AccountState p_account_state{};
  IdentityAccessor_GetPrimaryAccountInfo_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadAccountInfo(&p_account_info))
    success = false;
  if (!input_data_view.ReadAccountState(&p_account_state))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "IdentityAccessor::GetPrimaryAccountInfo response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_account_info), 
std::move(p_account_state));
  return true;
}

void IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder::Run(
    const base::Optional<::AccountInfo>& in_account_info, const identity::AccountState& in_account_state) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetPrimaryAccountInfo_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->account_info)::BaseType::BufferWriter
      account_info_writer;
  mojo::internal::Serialize<::identity::mojom::AccountInfoDataView>(
      in_account_info, buffer, &account_info_writer, &serialization_context);
  params->account_info.Set(
      account_info_writer.is_null() ? nullptr : account_info_writer.data());
  typename decltype(params->account_state)::BaseType::BufferWriter
      account_state_writer;
  mojo::internal::Serialize<::identity::mojom::AccountStateDataView>(
      in_account_state, buffer, &account_state_writer, &serialization_context);
  params->account_state.Set(
      account_state_writer.is_null() ? nullptr : account_state_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->account_state.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null account_state in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountInfoCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetPrimaryAccountInfo");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder {
 public:
  static IdentityAccessor::GetPrimaryAccountWhenAvailableCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder> proxy(
        new IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "IdentityAccessor::GetPrimaryAccountWhenAvailableCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const ::AccountInfo& in_account_info, const identity::AccountState& in_account_state);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder);
};

bool IdentityAccessor_GetPrimaryAccountWhenAvailable_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountWhenAvailableCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data* params =
      reinterpret_cast<
          internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  ::AccountInfo p_account_info{};
  identity::AccountState p_account_state{};
  IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadAccountInfo(&p_account_info))
    success = false;
  if (!input_data_view.ReadAccountState(&p_account_state))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "IdentityAccessor::GetPrimaryAccountWhenAvailable response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_account_info), 
std::move(p_account_state));
  return true;
}

void IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder::Run(
    const ::AccountInfo& in_account_info, const identity::AccountState& in_account_state) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->account_info)::BaseType::BufferWriter
      account_info_writer;
  mojo::internal::Serialize<::identity::mojom::AccountInfoDataView>(
      in_account_info, buffer, &account_info_writer, &serialization_context);
  params->account_info.Set(
      account_info_writer.is_null() ? nullptr : account_info_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->account_info.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null account_info in ");
  typename decltype(params->account_state)::BaseType::BufferWriter
      account_state_writer;
  mojo::internal::Serialize<::identity::mojom::AccountStateDataView>(
      in_account_state, buffer, &account_state_writer, &serialization_context);
  params->account_state.Set(
      account_state_writer.is_null() ? nullptr : account_state_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->account_state.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null account_state in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountWhenAvailableCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetPrimaryAccountWhenAvailable");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class IdentityAccessor_GetAccessToken_ProxyToResponder {
 public:
  static IdentityAccessor::GetAccessTokenCallback CreateCallback(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<IdentityAccessor_GetAccessToken_ProxyToResponder> proxy(
        new IdentityAccessor_GetAccessToken_ProxyToResponder(
            request_id, is_sync, std::move(responder)));
    return base::BindOnce(&IdentityAccessor_GetAccessToken_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~IdentityAccessor_GetAccessToken_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
    // If the Callback was dropped then deleting the responder will close
    // the pipe so the calling application knows to stop waiting for a reply.
    responder_ = nullptr;
  }

 private:
  IdentityAccessor_GetAccessToken_ProxyToResponder(
      uint64_t request_id,
      bool is_sync,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : request_id_(request_id),
        is_sync_(is_sync),
        responder_(std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "IdentityAccessor::GetAccessTokenCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      const base::Optional<std::string>& in_token, base::Time in_expiration_time, const ::GoogleServiceAuthError& in_error);

  uint64_t request_id_;
  bool is_sync_;
  std::unique_ptr<mojo::MessageReceiverWithStatus> responder_;

  DISALLOW_COPY_AND_ASSIGN(IdentityAccessor_GetAccessToken_ProxyToResponder);
};

bool IdentityAccessor_GetAccessToken_ForwardToCallback::Accept(
    mojo::Message* message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetAccessTokenCallback",
               "message", message->name());
#endif
  mojo::internal::MessageDispatchContext dispatch_context(message);

  DCHECK(message->is_serialized());
  internal::IdentityAccessor_GetAccessToken_ResponseParams_Data* params =
      reinterpret_cast<
          internal::IdentityAccessor_GetAccessToken_ResponseParams_Data*>(
              message->mutable_payload());
  
  mojo::internal::SerializationContext serialization_context;
  serialization_context.TakeHandlesFromMessage(message);
  bool success = true;
  base::Optional<std::string> p_token{};
  base::Time p_expiration_time{};
  ::GoogleServiceAuthError p_error{};
  IdentityAccessor_GetAccessToken_ResponseParamsDataView input_data_view(params, &serialization_context);
  
  if (!input_data_view.ReadToken(&p_token))
    success = false;
  if (!input_data_view.ReadExpirationTime(&p_expiration_time))
    success = false;
  if (!input_data_view.ReadError(&p_error))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        "IdentityAccessor::GetAccessToken response deserializer");
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_token), 
std::move(p_expiration_time), 
std::move(p_error));
  return true;
}

void IdentityAccessor_GetAccessToken_ProxyToResponder::Run(
    const base::Optional<std::string>& in_token, base::Time in_expiration_time, const ::GoogleServiceAuthError& in_error) {
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0);
  
  mojo::Message message(
      internal::kIdentityAccessor_GetAccessToken_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::identity::mojom::internal::IdentityAccessor_GetAccessToken_ResponseParams_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  typename decltype(params->token)::BaseType::BufferWriter
      token_writer;
  mojo::internal::Serialize<mojo::StringDataView>(
      in_token, buffer, &token_writer, &serialization_context);
  params->token.Set(
      token_writer.is_null() ? nullptr : token_writer.data());
  typename decltype(params->expiration_time)::BaseType::BufferWriter
      expiration_time_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDataView>(
      in_expiration_time, buffer, &expiration_time_writer, &serialization_context);
  params->expiration_time.Set(
      expiration_time_writer.is_null() ? nullptr : expiration_time_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->expiration_time.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null expiration_time in ");
  typename decltype(params->error)::BaseType::BufferWriter
      error_writer;
  mojo::internal::Serialize<::identity::mojom::GoogleServiceAuthErrorDataView>(
      in_error, buffer, &error_writer, &serialization_context);
  params->error.Set(
      error_writer.is_null() ? nullptr : error_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->error.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null error in ");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);

#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetAccessTokenCallback",
               "message", message.name());
#endif

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(IdentityAccessor::Name_);
  message.set_method_name("GetAccessToken");
#endif

  message.set_request_id(request_id_);
  ignore_result(responder_->Accept(&message));
  // TODO(darin): Accept() returning false indicates a malformed message, and
  // that may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool IdentityAccessorStubDispatch::Accept(
    IdentityAccessor* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kIdentityAccessor_GetPrimaryAccountInfo_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountInfo",
               "message", message->name());
#endif
      break;
    }
    case internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountWhenAvailable",
               "message", message->name());
#endif
      break;
    }
    case internal::kIdentityAccessor_GetAccessToken_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetAccessToken",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

// static
bool IdentityAccessorStubDispatch::AcceptWithResponder(
    IdentityAccessor* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kIdentityAccessor_GetPrimaryAccountInfo_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountInfo",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data* params =
          reinterpret_cast<
              internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      IdentityAccessor_GetPrimaryAccountInfo_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "IdentityAccessor::GetPrimaryAccountInfo deserializer");
        return false;
      }
      IdentityAccessor::GetPrimaryAccountInfoCallback callback =
          IdentityAccessor_GetPrimaryAccountInfo_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetPrimaryAccountInfo(std::move(callback));
      return true;
    }
    case internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetPrimaryAccountWhenAvailable",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data* params =
          reinterpret_cast<
              internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      IdentityAccessor_GetPrimaryAccountWhenAvailable_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "IdentityAccessor::GetPrimaryAccountWhenAvailable deserializer");
        return false;
      }
      IdentityAccessor::GetPrimaryAccountWhenAvailableCallback callback =
          IdentityAccessor_GetPrimaryAccountWhenAvailable_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetPrimaryAccountWhenAvailable(std::move(callback));
      return true;
    }
    case internal::kIdentityAccessor_GetAccessToken_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)<class 'jinja2::utils::Namespace'>::IdentityAccessor::GetAccessToken",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);

      internal::IdentityAccessor_GetAccessToken_Params_Data* params =
          reinterpret_cast<
              internal::IdentityAccessor_GetAccessToken_Params_Data*>(
                  message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      std::string p_account_id{};
      ::identity::ScopeSet p_scopes{};
      std::string p_consumer_id{};
      IdentityAccessor_GetAccessToken_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadAccountId(&p_account_id))
        success = false;
      if (!input_data_view.ReadScopes(&p_scopes))
        success = false;
      if (!input_data_view.ReadConsumerId(&p_consumer_id))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "IdentityAccessor::GetAccessToken deserializer");
        return false;
      }
      IdentityAccessor::GetAccessTokenCallback callback =
          IdentityAccessor_GetAccessToken_ProxyToResponder::CreateCallback(
              message->request_id(),
              message->has_flag(mojo::Message::kFlagIsSync),
              std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetAccessToken(
std::move(p_account_id), 
std::move(p_scopes), 
std::move(p_consumer_id), std::move(callback));
      return true;
    }
  }
  return false;
}

bool IdentityAccessorRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "IdentityAccessor RequestValidator");

  switch (message->header()->name) {
    case internal::kIdentityAccessor_GetPrimaryAccountInfo_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetPrimaryAccountInfo_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kIdentityAccessor_GetAccessToken_Name: {
      if (!mojo::internal::ValidateMessageIsRequestExpectingResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetAccessToken_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

bool IdentityAccessorResponseValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "IdentityAccessor ResponseValidator");

  if (!mojo::internal::ValidateMessageIsResponse(message, &validation_context))
    return false;
  switch (message->header()->name) {
    case internal::kIdentityAccessor_GetPrimaryAccountInfo_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetPrimaryAccountInfo_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kIdentityAccessor_GetPrimaryAccountWhenAvailable_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetPrimaryAccountWhenAvailable_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    case internal::kIdentityAccessor_GetAccessToken_Name: {
      if (!mojo::internal::ValidateMessagePayload<
               internal::IdentityAccessor_GetAccessToken_ResponseParams_Data>(
                    message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}
}  // namespace mojom
}  // namespace identity

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif