// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_HTTP_REQUEST_HEADERS_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_HTTP_REQUEST_HEADERS_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {
class HttpRequestHeaderKeyValuePair_Data;
class HttpRequestHeaders_Data;

#pragma pack(push, 1)
class  HttpRequestHeaderKeyValuePair_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(HttpRequestHeaderKeyValuePair_Data));
      new (data()) HttpRequestHeaderKeyValuePair_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    HttpRequestHeaderKeyValuePair_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<HttpRequestHeaderKeyValuePair_Data>(index_);
    }
    HttpRequestHeaderKeyValuePair_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> key;
  mojo::internal::Pointer<mojo::internal::String_Data> value;

 private:
  HttpRequestHeaderKeyValuePair_Data();
  ~HttpRequestHeaderKeyValuePair_Data() = delete;
};
static_assert(sizeof(HttpRequestHeaderKeyValuePair_Data) == 24,
              "Bad sizeof(HttpRequestHeaderKeyValuePair_Data)");
// Used by HttpRequestHeaderKeyValuePair::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct HttpRequestHeaderKeyValuePair_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  HttpRequestHeaderKeyValuePair_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~HttpRequestHeaderKeyValuePair_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    HttpRequestHeaderKeyValuePair_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    HttpRequestHeaderKeyValuePair_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  HttpRequestHeaders_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(HttpRequestHeaders_Data));
      new (data()) HttpRequestHeaders_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    HttpRequestHeaders_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<HttpRequestHeaders_Data>(index_);
    }
    HttpRequestHeaders_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::HttpRequestHeaderKeyValuePair_Data>>> headers;

 private:
  HttpRequestHeaders_Data();
  ~HttpRequestHeaders_Data() = delete;
};
static_assert(sizeof(HttpRequestHeaders_Data) == 16,
              "Bad sizeof(HttpRequestHeaders_Data)");
// Used by HttpRequestHeaders::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct HttpRequestHeaders_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  HttpRequestHeaders_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~HttpRequestHeaders_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    HttpRequestHeaders_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    HttpRequestHeaders_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_HTTP_REQUEST_HEADERS_MOJOM_SHARED_INTERNAL_H_