// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_PREFERENCES_PUBLIC_MOJOM_PREFERENCES_MOJOM_PARAMS_DATA_H_
#define SERVICES_PREFERENCES_PUBLIC_MOJOM_PREFERENCES_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace prefs {
namespace mojom {
namespace internal {
class  PrefStoreObserver_OnPrefsChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrefStoreObserver_OnPrefsChanged_Params_Data));
      new (data()) PrefStoreObserver_OnPrefsChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrefStoreObserver_OnPrefsChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrefStoreObserver_OnPrefsChanged_Params_Data>(index_);
    }
    PrefStoreObserver_OnPrefsChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::PrefUpdate_Data>>> updates;

 private:
  PrefStoreObserver_OnPrefsChanged_Params_Data();
  ~PrefStoreObserver_OnPrefsChanged_Params_Data() = delete;
};
static_assert(sizeof(PrefStoreObserver_OnPrefsChanged_Params_Data) == 16,
              "Bad sizeof(PrefStoreObserver_OnPrefsChanged_Params_Data)");
class  PrefStoreObserver_OnInitializationCompleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrefStoreObserver_OnInitializationCompleted_Params_Data));
      new (data()) PrefStoreObserver_OnInitializationCompleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrefStoreObserver_OnInitializationCompleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrefStoreObserver_OnInitializationCompleted_Params_Data>(index_);
    }
    PrefStoreObserver_OnInitializationCompleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t succeeded : 1;
  uint8_t padfinal_[7];

 private:
  PrefStoreObserver_OnInitializationCompleted_Params_Data();
  ~PrefStoreObserver_OnInitializationCompleted_Params_Data() = delete;
};
static_assert(sizeof(PrefStoreObserver_OnInitializationCompleted_Params_Data) == 16,
              "Bad sizeof(PrefStoreObserver_OnInitializationCompleted_Params_Data)");
class  PrefStoreObserver_OnPrefChangeAck_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrefStoreObserver_OnPrefChangeAck_Params_Data));
      new (data()) PrefStoreObserver_OnPrefChangeAck_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrefStoreObserver_OnPrefChangeAck_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrefStoreObserver_OnPrefChangeAck_Params_Data>(index_);
    }
    PrefStoreObserver_OnPrefChangeAck_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PrefStoreObserver_OnPrefChangeAck_Params_Data();
  ~PrefStoreObserver_OnPrefChangeAck_Params_Data() = delete;
};
static_assert(sizeof(PrefStoreObserver_OnPrefChangeAck_Params_Data) == 8,
              "Bad sizeof(PrefStoreObserver_OnPrefChangeAck_Params_Data)");
class  PrefStoreConnector_Connect_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrefStoreConnector_Connect_Params_Data));
      new (data()) PrefStoreConnector_Connect_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrefStoreConnector_Connect_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrefStoreConnector_Connect_Params_Data>(index_);
    }
    PrefStoreConnector_Connect_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PrefRegistry_Data> pref_registry;

 private:
  PrefStoreConnector_Connect_Params_Data();
  ~PrefStoreConnector_Connect_Params_Data() = delete;
};
static_assert(sizeof(PrefStoreConnector_Connect_Params_Data) == 16,
              "Bad sizeof(PrefStoreConnector_Connect_Params_Data)");
class  PrefStoreConnector_Connect_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PrefStoreConnector_Connect_ResponseParams_Data));
      new (data()) PrefStoreConnector_Connect_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PrefStoreConnector_Connect_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PrefStoreConnector_Connect_ResponseParams_Data>(index_);
    }
    PrefStoreConnector_Connect_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PersistentPrefStoreConnection_Data> connection;
  mojo::internal::Pointer<internal::IncognitoPersistentPrefStoreConnection_Data> underlay;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::PrefRegistration_Data>>> remote_defaults;
  mojo::internal::Pointer<mojo::internal::Map_Data<int32_t, mojo::internal::Pointer<internal::PrefStoreConnection_Data>>> connections;

 private:
  PrefStoreConnector_Connect_ResponseParams_Data();
  ~PrefStoreConnector_Connect_ResponseParams_Data() = delete;
};
static_assert(sizeof(PrefStoreConnector_Connect_ResponseParams_Data) == 40,
              "Bad sizeof(PrefStoreConnector_Connect_ResponseParams_Data)");
class  PersistentPrefStore_SetValues_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_SetValues_Params_Data));
      new (data()) PersistentPrefStore_SetValues_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_SetValues_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_SetValues_Params_Data>(index_);
    }
    PersistentPrefStore_SetValues_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::PrefUpdate_Data>>> updates;

 private:
  PersistentPrefStore_SetValues_Params_Data();
  ~PersistentPrefStore_SetValues_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_SetValues_Params_Data) == 16,
              "Bad sizeof(PersistentPrefStore_SetValues_Params_Data)");
class  PersistentPrefStore_RequestValue_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_RequestValue_Params_Data));
      new (data()) PersistentPrefStore_RequestValue_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_RequestValue_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_RequestValue_Params_Data>(index_);
    }
    PersistentPrefStore_RequestValue_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> sub_pref_path;

 private:
  PersistentPrefStore_RequestValue_Params_Data();
  ~PersistentPrefStore_RequestValue_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_RequestValue_Params_Data) == 24,
              "Bad sizeof(PersistentPrefStore_RequestValue_Params_Data)");
class  PersistentPrefStore_CommitPendingWrite_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_CommitPendingWrite_Params_Data));
      new (data()) PersistentPrefStore_CommitPendingWrite_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_CommitPendingWrite_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_CommitPendingWrite_Params_Data>(index_);
    }
    PersistentPrefStore_CommitPendingWrite_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PersistentPrefStore_CommitPendingWrite_Params_Data();
  ~PersistentPrefStore_CommitPendingWrite_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_CommitPendingWrite_Params_Data) == 8,
              "Bad sizeof(PersistentPrefStore_CommitPendingWrite_Params_Data)");
class  PersistentPrefStore_CommitPendingWrite_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_CommitPendingWrite_ResponseParams_Data));
      new (data()) PersistentPrefStore_CommitPendingWrite_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_CommitPendingWrite_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_CommitPendingWrite_ResponseParams_Data>(index_);
    }
    PersistentPrefStore_CommitPendingWrite_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PersistentPrefStore_CommitPendingWrite_ResponseParams_Data();
  ~PersistentPrefStore_CommitPendingWrite_ResponseParams_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_CommitPendingWrite_ResponseParams_Data) == 8,
              "Bad sizeof(PersistentPrefStore_CommitPendingWrite_ResponseParams_Data)");
class  PersistentPrefStore_SchedulePendingLossyWrites_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_SchedulePendingLossyWrites_Params_Data));
      new (data()) PersistentPrefStore_SchedulePendingLossyWrites_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_SchedulePendingLossyWrites_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_SchedulePendingLossyWrites_Params_Data>(index_);
    }
    PersistentPrefStore_SchedulePendingLossyWrites_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PersistentPrefStore_SchedulePendingLossyWrites_Params_Data();
  ~PersistentPrefStore_SchedulePendingLossyWrites_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_SchedulePendingLossyWrites_Params_Data) == 8,
              "Bad sizeof(PersistentPrefStore_SchedulePendingLossyWrites_Params_Data)");
class  PersistentPrefStore_ClearMutableValues_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_ClearMutableValues_Params_Data));
      new (data()) PersistentPrefStore_ClearMutableValues_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_ClearMutableValues_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_ClearMutableValues_Params_Data>(index_);
    }
    PersistentPrefStore_ClearMutableValues_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PersistentPrefStore_ClearMutableValues_Params_Data();
  ~PersistentPrefStore_ClearMutableValues_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_ClearMutableValues_Params_Data) == 8,
              "Bad sizeof(PersistentPrefStore_ClearMutableValues_Params_Data)");
class  PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data));
      new (data()) PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data>(index_);
    }
    PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data();
  ~PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data() = delete;
};
static_assert(sizeof(PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data) == 8,
              "Bad sizeof(PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data)");
class  ResetOnLoadObserver_OnResetOnLoad_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ResetOnLoadObserver_OnResetOnLoad_Params_Data));
      new (data()) ResetOnLoadObserver_OnResetOnLoad_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ResetOnLoadObserver_OnResetOnLoad_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ResetOnLoadObserver_OnResetOnLoad_Params_Data>(index_);
    }
    ResetOnLoadObserver_OnResetOnLoad_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ResetOnLoadObserver_OnResetOnLoad_Params_Data();
  ~ResetOnLoadObserver_OnResetOnLoad_Params_Data() = delete;
};
static_assert(sizeof(ResetOnLoadObserver_OnResetOnLoad_Params_Data) == 8,
              "Bad sizeof(ResetOnLoadObserver_OnResetOnLoad_Params_Data)");

}  // namespace internal
class PrefStoreObserver_OnPrefsChanged_ParamsDataView {
 public:
  PrefStoreObserver_OnPrefsChanged_ParamsDataView() {}

  PrefStoreObserver_OnPrefsChanged_ParamsDataView(
      internal::PrefStoreObserver_OnPrefsChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUpdatesDataView(
      mojo::ArrayDataView<PrefUpdateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::prefs::mojom::PrefUpdateDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PrefStoreObserver_OnPrefsChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PrefStoreObserver_OnInitializationCompleted_ParamsDataView {
 public:
  PrefStoreObserver_OnInitializationCompleted_ParamsDataView() {}

  PrefStoreObserver_OnInitializationCompleted_ParamsDataView(
      internal::PrefStoreObserver_OnInitializationCompleted_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool succeeded() const {
    return data_->succeeded;
  }
 private:
  internal::PrefStoreObserver_OnInitializationCompleted_Params_Data* data_ = nullptr;
};

class PrefStoreObserver_OnPrefChangeAck_ParamsDataView {
 public:
  PrefStoreObserver_OnPrefChangeAck_ParamsDataView() {}

  PrefStoreObserver_OnPrefChangeAck_ParamsDataView(
      internal::PrefStoreObserver_OnPrefChangeAck_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PrefStoreObserver_OnPrefChangeAck_Params_Data* data_ = nullptr;
};

class PrefStoreConnector_Connect_ParamsDataView {
 public:
  PrefStoreConnector_Connect_ParamsDataView() {}

  PrefStoreConnector_Connect_ParamsDataView(
      internal::PrefStoreConnector_Connect_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPrefRegistryDataView(
      PrefRegistryDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPrefRegistry(UserType* output) {
    auto* pointer = data_->pref_registry.Get();
    return mojo::internal::Deserialize<::prefs::mojom::PrefRegistryDataView>(
        pointer, output, context_);
  }
 private:
  internal::PrefStoreConnector_Connect_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PrefStoreConnector_Connect_ResponseParamsDataView {
 public:
  PrefStoreConnector_Connect_ResponseParamsDataView() {}

  PrefStoreConnector_Connect_ResponseParamsDataView(
      internal::PrefStoreConnector_Connect_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetConnectionDataView(
      PersistentPrefStoreConnectionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConnection(UserType* output) {
    auto* pointer = data_->connection.Get();
    return mojo::internal::Deserialize<::prefs::mojom::PersistentPrefStoreConnectionDataView>(
        pointer, output, context_);
  }
  inline void GetUnderlayDataView(
      IncognitoPersistentPrefStoreConnectionDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUnderlay(UserType* output) {
    auto* pointer = data_->underlay.Get();
    return mojo::internal::Deserialize<::prefs::mojom::IncognitoPersistentPrefStoreConnectionDataView>(
        pointer, output, context_);
  }
  inline void GetRemoteDefaultsDataView(
      mojo::ArrayDataView<PrefRegistrationDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRemoteDefaults(UserType* output) {
    auto* pointer = data_->remote_defaults.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::prefs::mojom::PrefRegistrationDataView>>(
        pointer, output, context_);
  }
  inline void GetConnectionsDataView(
      mojo::MapDataView<PrefStoreType, PrefStoreConnectionDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConnections(UserType* output) {
    auto* pointer = data_->connections.Get();
    return mojo::internal::Deserialize<mojo::MapDataView<::prefs::mojom::PrefStoreType, ::prefs::mojom::PrefStoreConnectionDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PrefStoreConnector_Connect_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PersistentPrefStore_SetValues_ParamsDataView {
 public:
  PersistentPrefStore_SetValues_ParamsDataView() {}

  PersistentPrefStore_SetValues_ParamsDataView(
      internal::PersistentPrefStore_SetValues_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUpdatesDataView(
      mojo::ArrayDataView<PrefUpdateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::prefs::mojom::PrefUpdateDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PersistentPrefStore_SetValues_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PersistentPrefStore_RequestValue_ParamsDataView {
 public:
  PersistentPrefStore_RequestValue_ParamsDataView() {}

  PersistentPrefStore_RequestValue_ParamsDataView(
      internal::PersistentPrefStore_RequestValue_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetKeyDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadKey(UserType* output) {
    auto* pointer = data_->key.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  inline void GetSubPrefPathDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadSubPrefPath(UserType* output) {
    auto* pointer = data_->sub_pref_path.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, context_);
  }
 private:
  internal::PersistentPrefStore_RequestValue_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PersistentPrefStore_CommitPendingWrite_ParamsDataView {
 public:
  PersistentPrefStore_CommitPendingWrite_ParamsDataView() {}

  PersistentPrefStore_CommitPendingWrite_ParamsDataView(
      internal::PersistentPrefStore_CommitPendingWrite_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PersistentPrefStore_CommitPendingWrite_Params_Data* data_ = nullptr;
};

class PersistentPrefStore_CommitPendingWrite_ResponseParamsDataView {
 public:
  PersistentPrefStore_CommitPendingWrite_ResponseParamsDataView() {}

  PersistentPrefStore_CommitPendingWrite_ResponseParamsDataView(
      internal::PersistentPrefStore_CommitPendingWrite_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PersistentPrefStore_CommitPendingWrite_ResponseParams_Data* data_ = nullptr;
};

class PersistentPrefStore_SchedulePendingLossyWrites_ParamsDataView {
 public:
  PersistentPrefStore_SchedulePendingLossyWrites_ParamsDataView() {}

  PersistentPrefStore_SchedulePendingLossyWrites_ParamsDataView(
      internal::PersistentPrefStore_SchedulePendingLossyWrites_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PersistentPrefStore_SchedulePendingLossyWrites_Params_Data* data_ = nullptr;
};

class PersistentPrefStore_ClearMutableValues_ParamsDataView {
 public:
  PersistentPrefStore_ClearMutableValues_ParamsDataView() {}

  PersistentPrefStore_ClearMutableValues_ParamsDataView(
      internal::PersistentPrefStore_ClearMutableValues_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PersistentPrefStore_ClearMutableValues_Params_Data* data_ = nullptr;
};

class PersistentPrefStore_OnStoreDeletionFromDisk_ParamsDataView {
 public:
  PersistentPrefStore_OnStoreDeletionFromDisk_ParamsDataView() {}

  PersistentPrefStore_OnStoreDeletionFromDisk_ParamsDataView(
      internal::PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::PersistentPrefStore_OnStoreDeletionFromDisk_Params_Data* data_ = nullptr;
};

class ResetOnLoadObserver_OnResetOnLoad_ParamsDataView {
 public:
  ResetOnLoadObserver_OnResetOnLoad_ParamsDataView() {}

  ResetOnLoadObserver_OnResetOnLoad_ParamsDataView(
      internal::ResetOnLoadObserver_OnResetOnLoad_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ResetOnLoadObserver_OnResetOnLoad_Params_Data* data_ = nullptr;
};


inline void PrefStoreObserver_OnPrefsChanged_ParamsDataView::GetUpdatesDataView(
    mojo::ArrayDataView<PrefUpdateDataView>* output) {
  auto pointer = data_->updates.Get();
  *output = mojo::ArrayDataView<PrefUpdateDataView>(pointer, context_);
}






inline void PrefStoreConnector_Connect_ParamsDataView::GetPrefRegistryDataView(
    PrefRegistryDataView* output) {
  auto pointer = data_->pref_registry.Get();
  *output = PrefRegistryDataView(pointer, context_);
}


inline void PrefStoreConnector_Connect_ResponseParamsDataView::GetConnectionDataView(
    PersistentPrefStoreConnectionDataView* output) {
  auto pointer = data_->connection.Get();
  *output = PersistentPrefStoreConnectionDataView(pointer, context_);
}
inline void PrefStoreConnector_Connect_ResponseParamsDataView::GetUnderlayDataView(
    IncognitoPersistentPrefStoreConnectionDataView* output) {
  auto pointer = data_->underlay.Get();
  *output = IncognitoPersistentPrefStoreConnectionDataView(pointer, context_);
}
inline void PrefStoreConnector_Connect_ResponseParamsDataView::GetRemoteDefaultsDataView(
    mojo::ArrayDataView<PrefRegistrationDataView>* output) {
  auto pointer = data_->remote_defaults.Get();
  *output = mojo::ArrayDataView<PrefRegistrationDataView>(pointer, context_);
}
inline void PrefStoreConnector_Connect_ResponseParamsDataView::GetConnectionsDataView(
    mojo::MapDataView<PrefStoreType, PrefStoreConnectionDataView>* output) {
  auto pointer = data_->connections.Get();
  *output = mojo::MapDataView<PrefStoreType, PrefStoreConnectionDataView>(pointer, context_);
}


inline void PersistentPrefStore_SetValues_ParamsDataView::GetUpdatesDataView(
    mojo::ArrayDataView<PrefUpdateDataView>* output) {
  auto pointer = data_->updates.Get();
  *output = mojo::ArrayDataView<PrefUpdateDataView>(pointer, context_);
}


inline void PersistentPrefStore_RequestValue_ParamsDataView::GetKeyDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->key.Get();
  *output = mojo::StringDataView(pointer, context_);
}
inline void PersistentPrefStore_RequestValue_ParamsDataView::GetSubPrefPathDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->sub_pref_path.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, context_);
}













}  // namespace mojom
}  // namespace prefs

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_PREFERENCES_PUBLIC_MOJOM_PREFERENCES_MOJOM_PARAMS_DATA_H_