// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "services/preferences/public/mojom/preferences.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "mojo/public/mojom/base/file_path.mojom.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "mojo/public/mojom/base/values.mojom.h"
#include "services/preferences/public/mojom/tracked_preference_validation_delegate.mojom.h"


#ifndef SERVICES_PREFERENCES_PUBLIC_MOJOM_PREFERENCES_MOJOM_JUMBO_H_
#define SERVICES_PREFERENCES_PUBLIC_MOJOM_PREFERENCES_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/file_path_mojom_traits.h"
#include "mojo/public/cpp/base/string16_mojom_traits.h"
#include "mojo/public/cpp/base/values_mojom_traits.h"
#include "services/preferences/public/cpp/preferences_mojom_traits.h"
#endif


namespace prefs {
namespace mojom {


void PrefStoreObserverInterceptorForTesting::OnPrefsChanged(std::vector<PrefUpdatePtr> updates) {
  GetForwardingInterface()->OnPrefsChanged(std::move(updates));
}
void PrefStoreObserverInterceptorForTesting::OnInitializationCompleted(bool succeeded) {
  GetForwardingInterface()->OnInitializationCompleted(std::move(succeeded));
}
void PrefStoreObserverInterceptorForTesting::OnPrefChangeAck() {
  GetForwardingInterface()->OnPrefChangeAck();
}
PrefStoreObserverAsyncWaiter::PrefStoreObserverAsyncWaiter(
    PrefStoreObserver* proxy) : proxy_(proxy) {}

PrefStoreObserverAsyncWaiter::~PrefStoreObserverAsyncWaiter() = default;




void PrefStoreConnectorInterceptorForTesting::Connect(PrefRegistryPtr pref_registry, ConnectCallback callback) {
  GetForwardingInterface()->Connect(std::move(pref_registry), std::move(callback));
}
PrefStoreConnectorAsyncWaiter::PrefStoreConnectorAsyncWaiter(
    PrefStoreConnector* proxy) : proxy_(proxy) {}

PrefStoreConnectorAsyncWaiter::~PrefStoreConnectorAsyncWaiter() = default;

void PrefStoreConnectorAsyncWaiter::Connect(
    PrefRegistryPtr pref_registry, PersistentPrefStoreConnectionPtr* out_connection, IncognitoPersistentPrefStoreConnectionPtr* out_underlay, std::vector<PrefRegistrationPtr>* out_remote_defaults, base::flat_map<::PrefValueStore::PrefStoreType, PrefStoreConnectionPtr>* out_connections) {
  base::RunLoop loop;
  proxy_->Connect(std::move(pref_registry),
      base::BindOnce(
          [](base::RunLoop* loop,
             PersistentPrefStoreConnectionPtr* out_connection
,
             IncognitoPersistentPrefStoreConnectionPtr* out_underlay
,
             std::vector<PrefRegistrationPtr>* out_remote_defaults
,
             base::flat_map<::PrefValueStore::PrefStoreType, PrefStoreConnectionPtr>* out_connections
,
             PersistentPrefStoreConnectionPtr connection,
             IncognitoPersistentPrefStoreConnectionPtr underlay,
             std::vector<PrefRegistrationPtr> remote_defaults,
             base::flat_map<::PrefValueStore::PrefStoreType, PrefStoreConnectionPtr> connections) {*out_connection = std::move(connection);*out_underlay = std::move(underlay);*out_remote_defaults = std::move(remote_defaults);*out_connections = std::move(connections);
            loop->Quit();
          },
          &loop,
          out_connection,
          out_underlay,
          out_remote_defaults,
          out_connections));
  loop.Run();
}



void PersistentPrefStoreInterceptorForTesting::SetValues(std::vector<PrefUpdatePtr> updates) {
  GetForwardingInterface()->SetValues(std::move(updates));
}
void PersistentPrefStoreInterceptorForTesting::RequestValue(const std::string& key, const std::vector<std::string>& sub_pref_path) {
  GetForwardingInterface()->RequestValue(std::move(key), std::move(sub_pref_path));
}
void PersistentPrefStoreInterceptorForTesting::CommitPendingWrite(CommitPendingWriteCallback callback) {
  GetForwardingInterface()->CommitPendingWrite(std::move(callback));
}
void PersistentPrefStoreInterceptorForTesting::SchedulePendingLossyWrites() {
  GetForwardingInterface()->SchedulePendingLossyWrites();
}
void PersistentPrefStoreInterceptorForTesting::ClearMutableValues() {
  GetForwardingInterface()->ClearMutableValues();
}
void PersistentPrefStoreInterceptorForTesting::OnStoreDeletionFromDisk() {
  GetForwardingInterface()->OnStoreDeletionFromDisk();
}
PersistentPrefStoreAsyncWaiter::PersistentPrefStoreAsyncWaiter(
    PersistentPrefStore* proxy) : proxy_(proxy) {}

PersistentPrefStoreAsyncWaiter::~PersistentPrefStoreAsyncWaiter() = default;

void PersistentPrefStoreAsyncWaiter::CommitPendingWrite(
    ) {
  base::RunLoop loop;
  proxy_->CommitPendingWrite(
      base::BindOnce(
          [](base::RunLoop* loop) {
            loop->Quit();
          },
          &loop));
  loop.Run();
}



void ResetOnLoadObserverInterceptorForTesting::OnResetOnLoad() {
  GetForwardingInterface()->OnResetOnLoad();
}
ResetOnLoadObserverAsyncWaiter::ResetOnLoadObserverAsyncWaiter(
    ResetOnLoadObserver* proxy) : proxy_(proxy) {}

ResetOnLoadObserverAsyncWaiter::~ResetOnLoadObserverAsyncWaiter() = default;






}  // namespace mojom
}  // namespace prefs

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif