// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_TEST_UTILS_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_TEST_UTILS_H_

#include "services/resource_coordinator/public/mojom/coordination_unit.mojom.h"
#include "base/component_export.h"


namespace resource_coordinator {
namespace mojom {


class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) FrameCoordinationUnitInterceptorForTesting : public FrameCoordinationUnit {
  virtual FrameCoordinationUnit* GetForwardingInterface() = 0;
  void SetNetworkAlmostIdle(bool idle) override;
  void SetLifecycleState(::resource_coordinator::mojom::LifecycleState state) override;
  void SetHasNonEmptyBeforeUnload(bool has_nonempty_beforeunload) override;
  void SetInterventionPolicy(PolicyControlledIntervention intervention, InterventionPolicy policy) override;
  void OnNonPersistentNotificationCreated() override;
};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) FrameCoordinationUnitAsyncWaiter {
 public:
  explicit FrameCoordinationUnitAsyncWaiter(FrameCoordinationUnit* proxy);
  ~FrameCoordinationUnitAsyncWaiter();

 private:
  FrameCoordinationUnit* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(FrameCoordinationUnitAsyncWaiter);
};


class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) ProcessCoordinationUnitInterceptorForTesting : public ProcessCoordinationUnit {
  virtual ProcessCoordinationUnit* GetForwardingInterface() = 0;
  void SetExpectedTaskQueueingDuration(base::TimeDelta duration) override;
  void SetMainThreadTaskLoadIsLow(bool main_thread_task_load_is_low) override;
};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) ProcessCoordinationUnitAsyncWaiter {
 public:
  explicit ProcessCoordinationUnitAsyncWaiter(ProcessCoordinationUnit* proxy);
  ~ProcessCoordinationUnitAsyncWaiter();

 private:
  ProcessCoordinationUnit* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProcessCoordinationUnitAsyncWaiter);
};




}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_COORDINATION_UNIT_MOJOM_TEST_UTILS_H_