// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_PARAMS_DATA_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace resource_coordinator {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalReceiver_NotifyPageAlmostIdle_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalReceiver_NotifyPageAlmostIdle_Params_Data));
      new (data()) PageSignalReceiver_NotifyPageAlmostIdle_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalReceiver_NotifyPageAlmostIdle_Params_Data>(index_);
    }
    PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PageNavigationIdentity_Data> page_navigation_id;

 private:
  PageSignalReceiver_NotifyPageAlmostIdle_Params_Data();
  ~PageSignalReceiver_NotifyPageAlmostIdle_Params_Data() = delete;
};
static_assert(sizeof(PageSignalReceiver_NotifyPageAlmostIdle_Params_Data) == 16,
              "Bad sizeof(PageSignalReceiver_NotifyPageAlmostIdle_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data));
      new (data()) PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data>(index_);
    }
    PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PageNavigationIdentity_Data> page_navigation_id;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> duration;

 private:
  PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data();
  ~PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data() = delete;
};
static_assert(sizeof(PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data) == 24,
              "Bad sizeof(PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalReceiver_SetLifecycleState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalReceiver_SetLifecycleState_Params_Data));
      new (data()) PageSignalReceiver_SetLifecycleState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalReceiver_SetLifecycleState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalReceiver_SetLifecycleState_Params_Data>(index_);
    }
    PageSignalReceiver_SetLifecycleState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PageNavigationIdentity_Data> page_navigation_id;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  PageSignalReceiver_SetLifecycleState_Params_Data();
  ~PageSignalReceiver_SetLifecycleState_Params_Data() = delete;
};
static_assert(sizeof(PageSignalReceiver_SetLifecycleState_Params_Data) == 24,
              "Bad sizeof(PageSignalReceiver_SetLifecycleState_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data));
      new (data()) PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data>(index_);
    }
    PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PageNavigationIdentity_Data> page_navigation_id;

 private:
  PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data();
  ~PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data() = delete;
};
static_assert(sizeof(PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data) == 16,
              "Bad sizeof(PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data));
      new (data()) PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data>(index_);
    }
    PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::PageNavigationIdentity_Data> page_navigation_id;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> load_duration;
  mojo::internal::Pointer<::mojo_base::mojom::internal::TimeDelta_Data> cpu_usage_estimate;
  uint64_t private_footprint_kb_estimate;

 private:
  PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data();
  ~PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data() = delete;
};
static_assert(sizeof(PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data) == 40,
              "Bad sizeof(PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) PageSignalGenerator_AddReceiver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PageSignalGenerator_AddReceiver_Params_Data));
      new (data()) PageSignalGenerator_AddReceiver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PageSignalGenerator_AddReceiver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PageSignalGenerator_AddReceiver_Params_Data>(index_);
    }
    PageSignalGenerator_AddReceiver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data receiver;

 private:
  PageSignalGenerator_AddReceiver_Params_Data();
  ~PageSignalGenerator_AddReceiver_Params_Data() = delete;
};
static_assert(sizeof(PageSignalGenerator_AddReceiver_Params_Data) == 16,
              "Bad sizeof(PageSignalGenerator_AddReceiver_Params_Data)");

}  // namespace internal
class PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView {
 public:
  PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView() {}

  PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView(
      internal::PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView {
 public:
  PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView() {}

  PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView(
      internal::PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  inline void GetDurationDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDuration(UserType* output) {
    auto* pointer = data_->duration.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_SetLifecycleState_ParamsDataView {
 public:
  PageSignalReceiver_SetLifecycleState_ParamsDataView() {}

  PageSignalReceiver_SetLifecycleState_ParamsDataView(
      internal::PageSignalReceiver_SetLifecycleState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::LifecycleState>(
        data_value, output);
  }

  ::resource_coordinator::mojom::LifecycleState state() const {
    return static_cast<::resource_coordinator::mojom::LifecycleState>(data_->state);
  }
 private:
  internal::PageSignalReceiver_SetLifecycleState_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView {
 public:
  PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView() {}

  PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView(
      internal::PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView {
 public:
  PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView() {}

  PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView(
      internal::PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  inline void GetLoadDurationDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLoadDuration(UserType* output) {
    auto* pointer = data_->load_duration.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  inline void GetCpuUsageEstimateDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCpuUsageEstimate(UserType* output) {
    auto* pointer = data_->cpu_usage_estimate.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  uint64_t private_footprint_kb_estimate() const {
    return data_->private_footprint_kb_estimate;
  }
 private:
  internal::PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalGenerator_AddReceiver_ParamsDataView {
 public:
  PageSignalGenerator_AddReceiver_ParamsDataView() {}

  PageSignalGenerator_AddReceiver_ParamsDataView(
      internal::PageSignalGenerator_AddReceiver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::PageSignalReceiverPtrDataView>(
            &data_->receiver, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PageSignalGenerator_AddReceiver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};


inline void PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}
inline void PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView::GetDurationDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->duration.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}


inline void PageSignalReceiver_SetLifecycleState_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}
inline void PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView::GetLoadDurationDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->load_duration.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}
inline void PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView::GetCpuUsageEstimateDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->cpu_usage_estimate.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_PARAMS_DATA_H_