// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace resource_coordinator {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIGraphDump_GetCurrentGraph_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data));
      new (data()) WebUIGraphDump_GetCurrentGraph_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphDump_GetCurrentGraph_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphDump_GetCurrentGraph_Params_Data>(index_);
    }
    WebUIGraphDump_GetCurrentGraph_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  WebUIGraphDump_GetCurrentGraph_Params_Data();
  ~WebUIGraphDump_GetCurrentGraph_Params_Data() = delete;
};
static_assert(sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data) == 8,
              "Bad sizeof(WebUIGraphDump_GetCurrentGraph_Params_Data)");
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM_SHARED) WebUIGraphDump_GetCurrentGraph_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data));
      new (data()) WebUIGraphDump_GetCurrentGraph_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<WebUIGraphDump_GetCurrentGraph_ResponseParams_Data>(index_);
    }
    WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::WebUIGraph_Data> graph;

 private:
  WebUIGraphDump_GetCurrentGraph_ResponseParams_Data();
  ~WebUIGraphDump_GetCurrentGraph_ResponseParams_Data() = delete;
};
static_assert(sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data) == 16,
              "Bad sizeof(WebUIGraphDump_GetCurrentGraph_ResponseParams_Data)");

}  // namespace internal
class WebUIGraphDump_GetCurrentGraph_ParamsDataView {
 public:
  WebUIGraphDump_GetCurrentGraph_ParamsDataView() {}

  WebUIGraphDump_GetCurrentGraph_ParamsDataView(
      internal::WebUIGraphDump_GetCurrentGraph_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::WebUIGraphDump_GetCurrentGraph_Params_Data* data_ = nullptr;
};

class WebUIGraphDump_GetCurrentGraph_ResponseParamsDataView {
 public:
  WebUIGraphDump_GetCurrentGraph_ResponseParamsDataView() {}

  WebUIGraphDump_GetCurrentGraph_ResponseParamsDataView(
      internal::WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetGraphDataView(
      WebUIGraphDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGraph(UserType* output) {
    auto* pointer = data_->graph.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::WebUIGraphDataView>(
        pointer, output, context_);
  }
 private:
  internal::WebUIGraphDump_GetCurrentGraph_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void WebUIGraphDump_GetCurrentGraph_ResponseParamsDataView::GetGraphDataView(
    WebUIGraphDataView* output) {
  auto pointer = data_->graph.Get();
  *output = WebUIGraphDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace resource_coordinator

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_PARAMS_DATA_H_