// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_

#include "services/resource_coordinator/public/mojom/webui_graph_dump.mojom.h"
#include "base/component_export.h"


namespace resource_coordinator {
namespace mojom {


class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) WebUIGraphDumpInterceptorForTesting : public WebUIGraphDump {
  virtual WebUIGraphDump* GetForwardingInterface() = 0;
  void GetCurrentGraph(GetCurrentGraphCallback callback) override;
};
class COMPONENT_EXPORT(RESOURCE_COORDINATOR_PUBLIC_MOJOM) WebUIGraphDumpAsyncWaiter {
 public:
  explicit WebUIGraphDumpAsyncWaiter(WebUIGraphDump* proxy);
  ~WebUIGraphDumpAsyncWaiter();
  void GetCurrentGraph(
      WebUIGraphPtr* out_graph);

 private:
  WebUIGraphDump* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(WebUIGraphDumpAsyncWaiter);
};




}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_WEBUI_GRAPH_DUMP_MOJOM_TEST_UTILS_H_