// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_SERVICE_MANAGER_PUBLIC_MOJOM_SERVICE_FACTORY_MOJOM_TEST_UTILS_H_
#define SERVICES_SERVICE_MANAGER_PUBLIC_MOJOM_SERVICE_FACTORY_MOJOM_TEST_UTILS_H_

#include "services/service_manager/public/mojom/service_factory.mojom.h"
#include "base/component_export.h"


namespace service_manager {
namespace mojom {


class COMPONENT_EXPORT(SERVICE_MANAGER_MOJOM) ServiceFactoryInterceptorForTesting : public ServiceFactory {
  virtual ServiceFactory* GetForwardingInterface() = 0;
  void CreateService(::service_manager::mojom::ServiceRequest service, const std::string& name, ::service_manager::mojom::PIDReceiverPtr pid_receiver) override;
};
class COMPONENT_EXPORT(SERVICE_MANAGER_MOJOM) ServiceFactoryAsyncWaiter {
 public:
  explicit ServiceFactoryAsyncWaiter(ServiceFactory* proxy);
  ~ServiceFactoryAsyncWaiter();

 private:
  ServiceFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ServiceFactoryAsyncWaiter);
};




}  // namespace mojom
}  // namespace service_manager

#endif  // SERVICES_SERVICE_MANAGER_PUBLIC_MOJOM_SERVICE_FACTORY_MOJOM_TEST_UTILS_H_