// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_TRACING_PUBLIC_MOJOM_PERFETTO_SERVICE_MOJOM_PARAMS_DATA_H_
#define SERVICES_TRACING_PUBLIC_MOJOM_PERFETTO_SERVICE_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace tracing {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerHost_CommitData_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerHost_CommitData_Params_Data));
      new (data()) ProducerHost_CommitData_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerHost_CommitData_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerHost_CommitData_Params_Data>(index_);
    }
    ProducerHost_CommitData_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::CommitDataRequest_Data> data_request;

 private:
  ProducerHost_CommitData_Params_Data();
  ~ProducerHost_CommitData_Params_Data() = delete;
};
static_assert(sizeof(ProducerHost_CommitData_Params_Data) == 16,
              "Bad sizeof(ProducerHost_CommitData_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerHost_RegisterDataSource_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerHost_RegisterDataSource_Params_Data));
      new (data()) ProducerHost_RegisterDataSource_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerHost_RegisterDataSource_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerHost_RegisterDataSource_Params_Data>(index_);
    }
    ProducerHost_RegisterDataSource_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::DataSourceRegistration_Data> registration_info;

 private:
  ProducerHost_RegisterDataSource_Params_Data();
  ~ProducerHost_RegisterDataSource_Params_Data() = delete;
};
static_assert(sizeof(ProducerHost_RegisterDataSource_Params_Data) == 16,
              "Bad sizeof(ProducerHost_RegisterDataSource_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerHost_RegisterTraceWriter_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerHost_RegisterTraceWriter_Params_Data));
      new (data()) ProducerHost_RegisterTraceWriter_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerHost_RegisterTraceWriter_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerHost_RegisterTraceWriter_Params_Data>(index_);
    }
    ProducerHost_RegisterTraceWriter_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t writer_id;
  uint32_t target_buffer;

 private:
  ProducerHost_RegisterTraceWriter_Params_Data();
  ~ProducerHost_RegisterTraceWriter_Params_Data() = delete;
};
static_assert(sizeof(ProducerHost_RegisterTraceWriter_Params_Data) == 16,
              "Bad sizeof(ProducerHost_RegisterTraceWriter_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerHost_UnregisterTraceWriter_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerHost_UnregisterTraceWriter_Params_Data));
      new (data()) ProducerHost_UnregisterTraceWriter_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerHost_UnregisterTraceWriter_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerHost_UnregisterTraceWriter_Params_Data>(index_);
    }
    ProducerHost_UnregisterTraceWriter_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint32_t writer_id;
  uint8_t padfinal_[4];

 private:
  ProducerHost_UnregisterTraceWriter_Params_Data();
  ~ProducerHost_UnregisterTraceWriter_Params_Data() = delete;
};
static_assert(sizeof(ProducerHost_UnregisterTraceWriter_Params_Data) == 16,
              "Bad sizeof(ProducerHost_UnregisterTraceWriter_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_OnTracingStart_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_OnTracingStart_Params_Data));
      new (data()) ProducerClient_OnTracingStart_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_OnTracingStart_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_OnTracingStart_Params_Data>(index_);
    }
    ProducerClient_OnTracingStart_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data shared_memory;
  uint8_t padfinal_[4];

 private:
  ProducerClient_OnTracingStart_Params_Data();
  ~ProducerClient_OnTracingStart_Params_Data() = delete;
};
static_assert(sizeof(ProducerClient_OnTracingStart_Params_Data) == 16,
              "Bad sizeof(ProducerClient_OnTracingStart_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_StartDataSource_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_StartDataSource_Params_Data));
      new (data()) ProducerClient_StartDataSource_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_StartDataSource_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_StartDataSource_Params_Data>(index_);
    }
    ProducerClient_StartDataSource_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t id;
  mojo::internal::Pointer<internal::DataSourceConfig_Data> data_source_config;

 private:
  ProducerClient_StartDataSource_Params_Data();
  ~ProducerClient_StartDataSource_Params_Data() = delete;
};
static_assert(sizeof(ProducerClient_StartDataSource_Params_Data) == 24,
              "Bad sizeof(ProducerClient_StartDataSource_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_StartDataSource_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_StartDataSource_ResponseParams_Data));
      new (data()) ProducerClient_StartDataSource_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_StartDataSource_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_StartDataSource_ResponseParams_Data>(index_);
    }
    ProducerClient_StartDataSource_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProducerClient_StartDataSource_ResponseParams_Data();
  ~ProducerClient_StartDataSource_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProducerClient_StartDataSource_ResponseParams_Data) == 8,
              "Bad sizeof(ProducerClient_StartDataSource_ResponseParams_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_StopDataSource_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_StopDataSource_Params_Data));
      new (data()) ProducerClient_StopDataSource_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_StopDataSource_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_StopDataSource_Params_Data>(index_);
    }
    ProducerClient_StopDataSource_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t id;

 private:
  ProducerClient_StopDataSource_Params_Data();
  ~ProducerClient_StopDataSource_Params_Data() = delete;
};
static_assert(sizeof(ProducerClient_StopDataSource_Params_Data) == 16,
              "Bad sizeof(ProducerClient_StopDataSource_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_StopDataSource_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_StopDataSource_ResponseParams_Data));
      new (data()) ProducerClient_StopDataSource_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_StopDataSource_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_StopDataSource_ResponseParams_Data>(index_);
    }
    ProducerClient_StopDataSource_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProducerClient_StopDataSource_ResponseParams_Data();
  ~ProducerClient_StopDataSource_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProducerClient_StopDataSource_ResponseParams_Data) == 8,
              "Bad sizeof(ProducerClient_StopDataSource_ResponseParams_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ProducerClient_Flush_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProducerClient_Flush_Params_Data));
      new (data()) ProducerClient_Flush_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProducerClient_Flush_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProducerClient_Flush_Params_Data>(index_);
    }
    ProducerClient_Flush_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t flush_request_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint64_t>> data_source_ids;

 private:
  ProducerClient_Flush_Params_Data();
  ~ProducerClient_Flush_Params_Data() = delete;
};
static_assert(sizeof(ProducerClient_Flush_Params_Data) == 24,
              "Bad sizeof(ProducerClient_Flush_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) PerfettoService_ConnectToProducerHost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PerfettoService_ConnectToProducerHost_Params_Data));
      new (data()) PerfettoService_ConnectToProducerHost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PerfettoService_ConnectToProducerHost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PerfettoService_ConnectToProducerHost_Params_Data>(index_);
    }
    PerfettoService_ConnectToProducerHost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data producer_client;
  mojo::internal::Handle_Data producer_host;
  uint8_t padfinal_[4];

 private:
  PerfettoService_ConnectToProducerHost_Params_Data();
  ~PerfettoService_ConnectToProducerHost_Params_Data() = delete;
};
static_assert(sizeof(PerfettoService_ConnectToProducerHost_Params_Data) == 24,
              "Bad sizeof(PerfettoService_ConnectToProducerHost_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_EnableTracing_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_EnableTracing_Params_Data));
      new (data()) ConsumerHost_EnableTracing_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_EnableTracing_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_EnableTracing_Params_Data>(index_);
    }
    ConsumerHost_EnableTracing_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data tracing_session;
  mojo::internal::Pointer<internal::TraceConfig_Data> config;

 private:
  ConsumerHost_EnableTracing_Params_Data();
  ~ConsumerHost_EnableTracing_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_EnableTracing_Params_Data) == 24,
              "Bad sizeof(ConsumerHost_EnableTracing_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_ChangeTraceConfig_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_ChangeTraceConfig_Params_Data));
      new (data()) ConsumerHost_ChangeTraceConfig_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_ChangeTraceConfig_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_ChangeTraceConfig_Params_Data>(index_);
    }
    ConsumerHost_ChangeTraceConfig_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<internal::TraceConfig_Data> config;

 private:
  ConsumerHost_ChangeTraceConfig_Params_Data();
  ~ConsumerHost_ChangeTraceConfig_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_ChangeTraceConfig_Params_Data) == 16,
              "Bad sizeof(ConsumerHost_ChangeTraceConfig_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_DisableTracing_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_DisableTracing_Params_Data));
      new (data()) ConsumerHost_DisableTracing_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_DisableTracing_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_DisableTracing_Params_Data>(index_);
    }
    ConsumerHost_DisableTracing_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ConsumerHost_DisableTracing_Params_Data();
  ~ConsumerHost_DisableTracing_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_DisableTracing_Params_Data) == 8,
              "Bad sizeof(ConsumerHost_DisableTracing_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_ReadBuffers_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_ReadBuffers_Params_Data));
      new (data()) ConsumerHost_ReadBuffers_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_ReadBuffers_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_ReadBuffers_Params_Data>(index_);
    }
    ConsumerHost_ReadBuffers_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  ConsumerHost_ReadBuffers_Params_Data();
  ~ConsumerHost_ReadBuffers_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_ReadBuffers_Params_Data) == 16,
              "Bad sizeof(ConsumerHost_ReadBuffers_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_ReadBuffers_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_ReadBuffers_ResponseParams_Data));
      new (data()) ConsumerHost_ReadBuffers_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_ReadBuffers_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_ReadBuffers_ResponseParams_Data>(index_);
    }
    ConsumerHost_ReadBuffers_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ConsumerHost_ReadBuffers_ResponseParams_Data();
  ~ConsumerHost_ReadBuffers_ResponseParams_Data() = delete;
};
static_assert(sizeof(ConsumerHost_ReadBuffers_ResponseParams_Data) == 8,
              "Bad sizeof(ConsumerHost_ReadBuffers_ResponseParams_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_DisableTracingAndEmitJson_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_DisableTracingAndEmitJson_Params_Data));
      new (data()) ConsumerHost_DisableTracingAndEmitJson_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_DisableTracingAndEmitJson_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_DisableTracingAndEmitJson_Params_Data>(index_);
    }
    ConsumerHost_DisableTracingAndEmitJson_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> agent_label_filter;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  ConsumerHost_DisableTracingAndEmitJson_Params_Data();
  ~ConsumerHost_DisableTracingAndEmitJson_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_DisableTracingAndEmitJson_Params_Data) == 24,
              "Bad sizeof(ConsumerHost_DisableTracingAndEmitJson_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data));
      new (data()) ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data>(index_);
    }
    ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data();
  ~ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data() = delete;
};
static_assert(sizeof(ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data) == 8,
              "Bad sizeof(ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_RequestBufferUsage_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_RequestBufferUsage_Params_Data));
      new (data()) ConsumerHost_RequestBufferUsage_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_RequestBufferUsage_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_RequestBufferUsage_Params_Data>(index_);
    }
    ConsumerHost_RequestBufferUsage_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ConsumerHost_RequestBufferUsage_Params_Data();
  ~ConsumerHost_RequestBufferUsage_Params_Data() = delete;
};
static_assert(sizeof(ConsumerHost_RequestBufferUsage_Params_Data) == 8,
              "Bad sizeof(ConsumerHost_RequestBufferUsage_Params_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) ConsumerHost_RequestBufferUsage_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ConsumerHost_RequestBufferUsage_ResponseParams_Data));
      new (data()) ConsumerHost_RequestBufferUsage_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ConsumerHost_RequestBufferUsage_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ConsumerHost_RequestBufferUsage_ResponseParams_Data>(index_);
    }
    ConsumerHost_RequestBufferUsage_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[3];
  float percent_full;

 private:
  ConsumerHost_RequestBufferUsage_ResponseParams_Data();
  ~ConsumerHost_RequestBufferUsage_ResponseParams_Data() = delete;
};
static_assert(sizeof(ConsumerHost_RequestBufferUsage_ResponseParams_Data) == 16,
              "Bad sizeof(ConsumerHost_RequestBufferUsage_ResponseParams_Data)");
class COMPONENT_EXPORT(TRACING_MOJOM_SHARED) TracingSession_OnTracingEnabled_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(TracingSession_OnTracingEnabled_Params_Data));
      new (data()) TracingSession_OnTracingEnabled_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    TracingSession_OnTracingEnabled_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<TracingSession_OnTracingEnabled_Params_Data>(index_);
    }
    TracingSession_OnTracingEnabled_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  TracingSession_OnTracingEnabled_Params_Data();
  ~TracingSession_OnTracingEnabled_Params_Data() = delete;
};
static_assert(sizeof(TracingSession_OnTracingEnabled_Params_Data) == 8,
              "Bad sizeof(TracingSession_OnTracingEnabled_Params_Data)");

}  // namespace internal
class ProducerHost_CommitData_ParamsDataView {
 public:
  ProducerHost_CommitData_ParamsDataView() {}

  ProducerHost_CommitData_ParamsDataView(
      internal::ProducerHost_CommitData_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataRequestDataView(
      CommitDataRequestDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDataRequest(UserType* output) {
    auto* pointer = data_->data_request.Get();
    return mojo::internal::Deserialize<::tracing::mojom::CommitDataRequestDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProducerHost_CommitData_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProducerHost_RegisterDataSource_ParamsDataView {
 public:
  ProducerHost_RegisterDataSource_ParamsDataView() {}

  ProducerHost_RegisterDataSource_ParamsDataView(
      internal::ProducerHost_RegisterDataSource_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetRegistrationInfoDataView(
      DataSourceRegistrationDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadRegistrationInfo(UserType* output) {
    auto* pointer = data_->registration_info.Get();
    return mojo::internal::Deserialize<::tracing::mojom::DataSourceRegistrationDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProducerHost_RegisterDataSource_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProducerHost_RegisterTraceWriter_ParamsDataView {
 public:
  ProducerHost_RegisterTraceWriter_ParamsDataView() {}

  ProducerHost_RegisterTraceWriter_ParamsDataView(
      internal::ProducerHost_RegisterTraceWriter_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t writer_id() const {
    return data_->writer_id;
  }
  uint32_t target_buffer() const {
    return data_->target_buffer;
  }
 private:
  internal::ProducerHost_RegisterTraceWriter_Params_Data* data_ = nullptr;
};

class ProducerHost_UnregisterTraceWriter_ParamsDataView {
 public:
  ProducerHost_UnregisterTraceWriter_ParamsDataView() {}

  ProducerHost_UnregisterTraceWriter_ParamsDataView(
      internal::ProducerHost_UnregisterTraceWriter_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint32_t writer_id() const {
    return data_->writer_id;
  }
 private:
  internal::ProducerHost_UnregisterTraceWriter_Params_Data* data_ = nullptr;
};

class ProducerClient_OnTracingStart_ParamsDataView {
 public:
  ProducerClient_OnTracingStart_ParamsDataView() {}

  ProducerClient_OnTracingStart_ParamsDataView(
      internal::ProducerClient_OnTracingStart_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  mojo::ScopedSharedBufferHandle TakeSharedMemory() {
    mojo::ScopedSharedBufferHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedSharedBufferHandle>(
            &data_->shared_memory, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ProducerClient_OnTracingStart_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProducerClient_StartDataSource_ParamsDataView {
 public:
  ProducerClient_StartDataSource_ParamsDataView() {}

  ProducerClient_StartDataSource_ParamsDataView(
      internal::ProducerClient_StartDataSource_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t id() const {
    return data_->id;
  }
  inline void GetDataSourceConfigDataView(
      DataSourceConfigDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDataSourceConfig(UserType* output) {
    auto* pointer = data_->data_source_config.Get();
    return mojo::internal::Deserialize<::tracing::mojom::DataSourceConfigDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProducerClient_StartDataSource_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProducerClient_StartDataSource_ResponseParamsDataView {
 public:
  ProducerClient_StartDataSource_ResponseParamsDataView() {}

  ProducerClient_StartDataSource_ResponseParamsDataView(
      internal::ProducerClient_StartDataSource_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProducerClient_StartDataSource_ResponseParams_Data* data_ = nullptr;
};

class ProducerClient_StopDataSource_ParamsDataView {
 public:
  ProducerClient_StopDataSource_ParamsDataView() {}

  ProducerClient_StopDataSource_ParamsDataView(
      internal::ProducerClient_StopDataSource_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint64_t id() const {
    return data_->id;
  }
 private:
  internal::ProducerClient_StopDataSource_Params_Data* data_ = nullptr;
};

class ProducerClient_StopDataSource_ResponseParamsDataView {
 public:
  ProducerClient_StopDataSource_ResponseParamsDataView() {}

  ProducerClient_StopDataSource_ResponseParamsDataView(
      internal::ProducerClient_StopDataSource_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProducerClient_StopDataSource_ResponseParams_Data* data_ = nullptr;
};

class ProducerClient_Flush_ParamsDataView {
 public:
  ProducerClient_Flush_ParamsDataView() {}

  ProducerClient_Flush_ParamsDataView(
      internal::ProducerClient_Flush_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t flush_request_id() const {
    return data_->flush_request_id;
  }
  inline void GetDataSourceIdsDataView(
      mojo::ArrayDataView<uint64_t>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDataSourceIds(UserType* output) {
    auto* pointer = data_->data_source_ids.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<uint64_t>>(
        pointer, output, context_);
  }
 private:
  internal::ProducerClient_Flush_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PerfettoService_ConnectToProducerHost_ParamsDataView {
 public:
  PerfettoService_ConnectToProducerHost_ParamsDataView() {}

  PerfettoService_ConnectToProducerHost_ParamsDataView(
      internal::PerfettoService_ConnectToProducerHost_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeProducerClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::tracing::mojom::ProducerClientPtrDataView>(
            &data_->producer_client, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeProducerHost() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::tracing::mojom::ProducerHostRequestDataView>(
            &data_->producer_host, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PerfettoService_ConnectToProducerHost_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ConsumerHost_EnableTracing_ParamsDataView {
 public:
  ConsumerHost_EnableTracing_ParamsDataView() {}

  ConsumerHost_EnableTracing_ParamsDataView(
      internal::ConsumerHost_EnableTracing_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeTracingSession() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::tracing::mojom::TracingSessionPtrDataView>(
            &data_->tracing_session, &result, context_);
    DCHECK(ret);
    return result;
  }
  inline void GetConfigDataView(
      TraceConfigDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConfig(UserType* output) {
    auto* pointer = data_->config.Get();
    return mojo::internal::Deserialize<::tracing::mojom::TraceConfigDataView>(
        pointer, output, context_);
  }
 private:
  internal::ConsumerHost_EnableTracing_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ConsumerHost_ChangeTraceConfig_ParamsDataView {
 public:
  ConsumerHost_ChangeTraceConfig_ParamsDataView() {}

  ConsumerHost_ChangeTraceConfig_ParamsDataView(
      internal::ConsumerHost_ChangeTraceConfig_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetConfigDataView(
      TraceConfigDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadConfig(UserType* output) {
    auto* pointer = data_->config.Get();
    return mojo::internal::Deserialize<::tracing::mojom::TraceConfigDataView>(
        pointer, output, context_);
  }
 private:
  internal::ConsumerHost_ChangeTraceConfig_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ConsumerHost_DisableTracing_ParamsDataView {
 public:
  ConsumerHost_DisableTracing_ParamsDataView() {}

  ConsumerHost_DisableTracing_ParamsDataView(
      internal::ConsumerHost_DisableTracing_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ConsumerHost_DisableTracing_Params_Data* data_ = nullptr;
};

class ConsumerHost_ReadBuffers_ParamsDataView {
 public:
  ConsumerHost_ReadBuffers_ParamsDataView() {}

  ConsumerHost_ReadBuffers_ParamsDataView(
      internal::ConsumerHost_ReadBuffers_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  mojo::ScopedDataPipeProducerHandle TakeStream() {
    mojo::ScopedDataPipeProducerHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedDataPipeProducerHandle>(
            &data_->stream, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ConsumerHost_ReadBuffers_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ConsumerHost_ReadBuffers_ResponseParamsDataView {
 public:
  ConsumerHost_ReadBuffers_ResponseParamsDataView() {}

  ConsumerHost_ReadBuffers_ResponseParamsDataView(
      internal::ConsumerHost_ReadBuffers_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ConsumerHost_ReadBuffers_ResponseParams_Data* data_ = nullptr;
};

class ConsumerHost_DisableTracingAndEmitJson_ParamsDataView {
 public:
  ConsumerHost_DisableTracingAndEmitJson_ParamsDataView() {}

  ConsumerHost_DisableTracingAndEmitJson_ParamsDataView(
      internal::ConsumerHost_DisableTracingAndEmitJson_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetAgentLabelFilterDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadAgentLabelFilter(UserType* output) {
    auto* pointer = data_->agent_label_filter.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
  mojo::ScopedDataPipeProducerHandle TakeStream() {
    mojo::ScopedDataPipeProducerHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedDataPipeProducerHandle>(
            &data_->stream, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ConsumerHost_DisableTracingAndEmitJson_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ConsumerHost_DisableTracingAndEmitJson_ResponseParamsDataView {
 public:
  ConsumerHost_DisableTracingAndEmitJson_ResponseParamsDataView() {}

  ConsumerHost_DisableTracingAndEmitJson_ResponseParamsDataView(
      internal::ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ConsumerHost_DisableTracingAndEmitJson_ResponseParams_Data* data_ = nullptr;
};

class ConsumerHost_RequestBufferUsage_ParamsDataView {
 public:
  ConsumerHost_RequestBufferUsage_ParamsDataView() {}

  ConsumerHost_RequestBufferUsage_ParamsDataView(
      internal::ConsumerHost_RequestBufferUsage_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ConsumerHost_RequestBufferUsage_Params_Data* data_ = nullptr;
};

class ConsumerHost_RequestBufferUsage_ResponseParamsDataView {
 public:
  ConsumerHost_RequestBufferUsage_ResponseParamsDataView() {}

  ConsumerHost_RequestBufferUsage_ResponseParamsDataView(
      internal::ConsumerHost_RequestBufferUsage_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
  float percent_full() const {
    return data_->percent_full;
  }
 private:
  internal::ConsumerHost_RequestBufferUsage_ResponseParams_Data* data_ = nullptr;
};

class TracingSession_OnTracingEnabled_ParamsDataView {
 public:
  TracingSession_OnTracingEnabled_ParamsDataView() {}

  TracingSession_OnTracingEnabled_ParamsDataView(
      internal::TracingSession_OnTracingEnabled_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::TracingSession_OnTracingEnabled_Params_Data* data_ = nullptr;
};


inline void ProducerHost_CommitData_ParamsDataView::GetDataRequestDataView(
    CommitDataRequestDataView* output) {
  auto pointer = data_->data_request.Get();
  *output = CommitDataRequestDataView(pointer, context_);
}


inline void ProducerHost_RegisterDataSource_ParamsDataView::GetRegistrationInfoDataView(
    DataSourceRegistrationDataView* output) {
  auto pointer = data_->registration_info.Get();
  *output = DataSourceRegistrationDataView(pointer, context_);
}








inline void ProducerClient_StartDataSource_ParamsDataView::GetDataSourceConfigDataView(
    DataSourceConfigDataView* output) {
  auto pointer = data_->data_source_config.Get();
  *output = DataSourceConfigDataView(pointer, context_);
}








inline void ProducerClient_Flush_ParamsDataView::GetDataSourceIdsDataView(
    mojo::ArrayDataView<uint64_t>* output) {
  auto pointer = data_->data_source_ids.Get();
  *output = mojo::ArrayDataView<uint64_t>(pointer, context_);
}




inline void ConsumerHost_EnableTracing_ParamsDataView::GetConfigDataView(
    TraceConfigDataView* output) {
  auto pointer = data_->config.Get();
  *output = TraceConfigDataView(pointer, context_);
}


inline void ConsumerHost_ChangeTraceConfig_ParamsDataView::GetConfigDataView(
    TraceConfigDataView* output) {
  auto pointer = data_->config.Get();
  *output = TraceConfigDataView(pointer, context_);
}








inline void ConsumerHost_DisableTracingAndEmitJson_ParamsDataView::GetAgentLabelFilterDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->agent_label_filter.Get();
  *output = mojo::StringDataView(pointer, context_);
}









}  // namespace mojom
}  // namespace tracing

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // SERVICES_TRACING_PUBLIC_MOJOM_PERFETTO_SERVICE_MOJOM_PARAMS_DATA_H_