// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_PRODUCER_MOJOM_TEST_UTILS_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_PRODUCER_MOJOM_TEST_UTILS_H_

#include "services/video_capture/public/mojom/producer.mojom.h"


namespace video_capture {
namespace mojom {


class  ProducerInterceptorForTesting : public Producer {
  virtual Producer* GetForwardingInterface() = 0;
  void OnNewBuffer(int32_t buffer_id, ::media::mojom::VideoBufferHandlePtr buffer_handle, OnNewBufferCallback callback) override;
  void OnBufferRetired(int32_t buffer_id) override;
};
class  ProducerAsyncWaiter {
 public:
  explicit ProducerAsyncWaiter(Producer* proxy);
  ~ProducerAsyncWaiter();
  void OnNewBuffer(
      int32_t buffer_id, ::media::mojom::VideoBufferHandlePtr buffer_handle);

 private:
  Producer* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ProducerAsyncWaiter);
};




}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_PRODUCER_MOJOM_TEST_UTILS_H_