// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_
#define SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/video_capture/public/mojom/video_source.mojom-shared-internal.h"
#include "media/capture/mojom/image_capture.mojom-shared.h"
#include "media/capture/mojom/video_capture_types.mojom-shared.h"
#include "services/video_capture/public/mojom/receiver.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace video_capture {
namespace mojom {


}  // namespace mojom
}  // namespace video_capture

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace video_capture {
namespace mojom {


enum class CreatePushSubscriptionResultCode : int32_t {
  
  kCreatedWithRequestedSettings,
  
  kCreatedWithDifferentSettings,
  
  kFailed,
  kMinValue = 0,
  kMaxValue = 2,
};

 std::ostream& operator<<(std::ostream& os, CreatePushSubscriptionResultCode value);
inline bool IsKnownEnumValue(CreatePushSubscriptionResultCode value) {
  return internal::CreatePushSubscriptionResultCode_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class PushVideoStreamSubscriptionInterfaceBase {};

using PushVideoStreamSubscriptionPtrDataView =
    mojo::InterfacePtrDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionRequestDataView =
    mojo::InterfaceRequestDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PushVideoStreamSubscriptionInterfaceBase>;
using PushVideoStreamSubscriptionAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PushVideoStreamSubscriptionInterfaceBase>;
class VideoSourceInterfaceBase {};

using VideoSourcePtrDataView =
    mojo::InterfacePtrDataView<VideoSourceInterfaceBase>;
using VideoSourceRequestDataView =
    mojo::InterfaceRequestDataView<VideoSourceInterfaceBase>;
using VideoSourceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<VideoSourceInterfaceBase>;
using VideoSourceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<VideoSourceInterfaceBase>;


}  // namespace mojom
}  // namespace video_capture

namespace std {

template <>
struct hash<::video_capture::mojom::CreatePushSubscriptionResultCode>
    : public mojo::internal::EnumHashImpl<::video_capture::mojom::CreatePushSubscriptionResultCode> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::video_capture::mojom::CreatePushSubscriptionResultCode, ::video_capture::mojom::CreatePushSubscriptionResultCode> {
  static ::video_capture::mojom::CreatePushSubscriptionResultCode ToMojom(::video_capture::mojom::CreatePushSubscriptionResultCode input) { return input; }
  static bool FromMojom(::video_capture::mojom::CreatePushSubscriptionResultCode input, ::video_capture::mojom::CreatePushSubscriptionResultCode* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::video_capture::mojom::CreatePushSubscriptionResultCode, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::video_capture::mojom::CreatePushSubscriptionResultCode, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::video_capture::mojom::CreatePushSubscriptionResultCode>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace video_capture {
namespace mojom {


}  // namespace mojom
}  // namespace video_capture

#endif  // SERVICES_VIDEO_CAPTURE_PUBLIC_MOJOM_VIDEO_SOURCE_MOJOM_SHARED_H_