// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_EXTERNAL_BEGIN_FRAME_CONTROLLER_MOJOM_TEST_UTILS_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_EXTERNAL_BEGIN_FRAME_CONTROLLER_MOJOM_TEST_UTILS_H_

#include "services/viz/privileged/interfaces/compositing/external_begin_frame_controller.mojom.h"


namespace viz {
namespace mojom {


class  ExternalBeginFrameControllerInterceptorForTesting : public ExternalBeginFrameController {
  virtual ExternalBeginFrameController* GetForwardingInterface() = 0;
  void IssueExternalBeginFrame(const viz::BeginFrameArgs& args) override;
};
class  ExternalBeginFrameControllerAsyncWaiter {
 public:
  explicit ExternalBeginFrameControllerAsyncWaiter(ExternalBeginFrameController* proxy);
  ~ExternalBeginFrameControllerAsyncWaiter();

 private:
  ExternalBeginFrameController* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ExternalBeginFrameControllerAsyncWaiter);
};


class  ExternalBeginFrameControllerClientInterceptorForTesting : public ExternalBeginFrameControllerClient {
  virtual ExternalBeginFrameControllerClient* GetForwardingInterface() = 0;
  void OnNeedsBeginFrames(bool needs_begin_frames) override;
  void OnDisplayDidFinishFrame(const viz::BeginFrameAck& ack) override;
};
class  ExternalBeginFrameControllerClientAsyncWaiter {
 public:
  explicit ExternalBeginFrameControllerClientAsyncWaiter(ExternalBeginFrameControllerClient* proxy);
  ~ExternalBeginFrameControllerClientAsyncWaiter();

 private:
  ExternalBeginFrameControllerClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(ExternalBeginFrameControllerClientAsyncWaiter);
};




}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_EXTERNAL_BEGIN_FRAME_CONTROLLER_MOJOM_TEST_UTILS_H_