// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "gpu/ipc/common/surface_handle.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared-internal.h"
#include "services/viz/privileged/interfaces/compositing/display_private.mojom-shared-internal.h"
#include "services/viz/privileged/interfaces/compositing/external_begin_frame_controller.mojom-shared-internal.h"
#include "services/viz/privileged/interfaces/compositing/frame_sink_video_capture.mojom-shared-internal.h"
#include "services/viz/privileged/interfaces/compositing/renderer_settings.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/compositor_frame_sink.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/copy_output_request.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/frame_sink_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/local_surface_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_id.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/surface_info.mojom-shared-internal.h"
#include "services/viz/public/interfaces/hit_test/aggregated_hit_test_region.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "services/viz/public/interfaces/compositing/video_detector_observer.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"



namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace viz {
namespace mojom {
namespace internal {
class RootCompositorFrameSinkParams_Data;

#pragma pack(push, 1)
class  RootCompositorFrameSinkParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RootCompositorFrameSinkParams_Data));
      new (data()) RootCompositorFrameSinkParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RootCompositorFrameSinkParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RootCompositorFrameSinkParams_Data>(index_);
    }
    RootCompositorFrameSinkParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::viz::mojom::internal::FrameSinkId_Data> frame_sink_id;
  mojo::internal::Pointer<::gpu::mojom::internal::SurfaceHandle_Data> widget;
  uint8_t gpu_compositing : 1;
  uint8_t send_swap_size_notifications : 1;
  uint8_t disable_frame_rate_limit : 1;
  uint8_t pad4_[3];
  mojo::internal::AssociatedEndpointHandle_Data compositor_frame_sink;
  mojo::internal::Pointer<::viz::mojom::internal::RendererSettings_Data> renderer_settings;
  mojo::internal::Interface_Data compositor_frame_sink_client;
  mojo::internal::AssociatedEndpointHandle_Data display_private;
  mojo::internal::Interface_Data display_client;
  mojo::internal::AssociatedEndpointHandle_Data external_begin_frame_controller;
  mojo::internal::Interface_Data external_begin_frame_controller_client;

 private:
  RootCompositorFrameSinkParams_Data();
  ~RootCompositorFrameSinkParams_Data() = delete;
};
static_assert(sizeof(RootCompositorFrameSinkParams_Data) == 72,
              "Bad sizeof(RootCompositorFrameSinkParams_Data)");
// Used by RootCompositorFrameSinkParams::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct RootCompositorFrameSinkParams_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  RootCompositorFrameSinkParams_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~RootCompositorFrameSinkParams_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    RootCompositorFrameSinkParams_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    RootCompositorFrameSinkParams_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#endif  // SERVICES_VIZ_PRIVILEGED_INTERFACES_COMPOSITING_FRAME_SINK_MANAGER_MOJOM_SHARED_INTERNAL_H_