// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4065)
#endif

#include "services/viz/privileged/interfaces/compositing/overlay_strategy.mojom-shared.h"

#include <utility>

#include "base/logging.h"
#include "base/stl_util.h"  // for base::size()
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"

#include "services/viz/privileged/interfaces/compositing/overlay_strategy.mojom-params-data.h"
namespace viz {
namespace mojom {

std::ostream& operator<<(std::ostream& os, OverlayStrategy value) {
  switch(value) {
    case OverlayStrategy::kFullscreen:
      return os << "OverlayStrategy::kFullscreen";
    case OverlayStrategy::kSingleOnTop:
      return os << "OverlayStrategy::kSingleOnTop";
    case OverlayStrategy::kUnderlay:
      return os << "OverlayStrategy::kUnderlay";
    case OverlayStrategy::kUnderlayCast:
      return os << "OverlayStrategy::kUnderlayCast";
    default:
      return os << "Unknown OverlayStrategy value: " << static_cast<int32_t>(value);
  }
}

namespace internal {

}  // namespace internal
}  // namespace mojom
}  // namespace viz

#if defined(_MSC_VER)
#pragma warning(pop)
#endif