// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_PARAMS_DATA_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace blink {
namespace mojom {
namespace internal {
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Write_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Write_Params_Data));
      new (data()) FileWriter_Write_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Write_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Write_Params_Data>(index_);
    }
    FileWriter_Write_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t position;
  mojo::internal::Interface_Data blob;

 private:
  FileWriter_Write_Params_Data();
  ~FileWriter_Write_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_Write_Params_Data) == 24,
              "Bad sizeof(FileWriter_Write_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Write_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Write_ResponseParams_Data));
      new (data()) FileWriter_Write_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Write_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Write_ResponseParams_Data>(index_);
    }
    FileWriter_Write_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  uint64_t bytes_written;

 private:
  FileWriter_Write_ResponseParams_Data();
  ~FileWriter_Write_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_Write_ResponseParams_Data) == 24,
              "Bad sizeof(FileWriter_Write_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_WriteStream_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_WriteStream_Params_Data));
      new (data()) FileWriter_WriteStream_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_WriteStream_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_WriteStream_Params_Data>(index_);
    }
    FileWriter_WriteStream_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t position;
  mojo::internal::Handle_Data stream;
  uint8_t padfinal_[4];

 private:
  FileWriter_WriteStream_Params_Data();
  ~FileWriter_WriteStream_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_WriteStream_Params_Data) == 24,
              "Bad sizeof(FileWriter_WriteStream_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_WriteStream_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_WriteStream_ResponseParams_Data));
      new (data()) FileWriter_WriteStream_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_WriteStream_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_WriteStream_ResponseParams_Data>(index_);
    }
    FileWriter_WriteStream_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t pad0_[4];
  uint64_t bytes_written;

 private:
  FileWriter_WriteStream_ResponseParams_Data();
  ~FileWriter_WriteStream_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_WriteStream_ResponseParams_Data) == 24,
              "Bad sizeof(FileWriter_WriteStream_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Truncate_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Truncate_Params_Data));
      new (data()) FileWriter_Truncate_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Truncate_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Truncate_Params_Data>(index_);
    }
    FileWriter_Truncate_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint64_t length;

 private:
  FileWriter_Truncate_Params_Data();
  ~FileWriter_Truncate_Params_Data() = delete;
};
static_assert(sizeof(FileWriter_Truncate_Params_Data) == 16,
              "Bad sizeof(FileWriter_Truncate_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) FileWriter_Truncate_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(FileWriter_Truncate_ResponseParams_Data));
      new (data()) FileWriter_Truncate_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    FileWriter_Truncate_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<FileWriter_Truncate_ResponseParams_Data>(index_);
    }
    FileWriter_Truncate_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  uint8_t padfinal_[4];

 private:
  FileWriter_Truncate_ResponseParams_Data();
  ~FileWriter_Truncate_ResponseParams_Data() = delete;
};
static_assert(sizeof(FileWriter_Truncate_ResponseParams_Data) == 16,
              "Bad sizeof(FileWriter_Truncate_ResponseParams_Data)");

}  // namespace internal
class FileWriter_Write_ParamsDataView {
 public:
  FileWriter_Write_ParamsDataView() {}

  FileWriter_Write_ParamsDataView(
      internal::FileWriter_Write_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t position() const {
    return data_->position;
  }
  template <typename UserType>
  UserType TakeBlob() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::blink::mojom::BlobPtrDataView>(
            &data_->blob, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::FileWriter_Write_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FileWriter_Write_ResponseParamsDataView {
 public:
  FileWriter_Write_ResponseParamsDataView() {}

  FileWriter_Write_ResponseParamsDataView(
      internal::FileWriter_Write_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::mojo_base::mojom::FileError>(
        data_value, output);
  }

  ::mojo_base::mojom::FileError result() const {
    return static_cast<::mojo_base::mojom::FileError>(data_->result);
  }
  uint64_t bytes_written() const {
    return data_->bytes_written;
  }
 private:
  internal::FileWriter_Write_ResponseParams_Data* data_ = nullptr;
};

class FileWriter_WriteStream_ParamsDataView {
 public:
  FileWriter_WriteStream_ParamsDataView() {}

  FileWriter_WriteStream_ParamsDataView(
      internal::FileWriter_WriteStream_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  uint64_t position() const {
    return data_->position;
  }
  mojo::ScopedDataPipeConsumerHandle TakeStream() {
    mojo::ScopedDataPipeConsumerHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedDataPipeConsumerHandle>(
            &data_->stream, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::FileWriter_WriteStream_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class FileWriter_WriteStream_ResponseParamsDataView {
 public:
  FileWriter_WriteStream_ResponseParamsDataView() {}

  FileWriter_WriteStream_ResponseParamsDataView(
      internal::FileWriter_WriteStream_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::mojo_base::mojom::FileError>(
        data_value, output);
  }

  ::mojo_base::mojom::FileError result() const {
    return static_cast<::mojo_base::mojom::FileError>(data_->result);
  }
  uint64_t bytes_written() const {
    return data_->bytes_written;
  }
 private:
  internal::FileWriter_WriteStream_ResponseParams_Data* data_ = nullptr;
};

class FileWriter_Truncate_ParamsDataView {
 public:
  FileWriter_Truncate_ParamsDataView() {}

  FileWriter_Truncate_ParamsDataView(
      internal::FileWriter_Truncate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  uint64_t length() const {
    return data_->length;
  }
 private:
  internal::FileWriter_Truncate_Params_Data* data_ = nullptr;
};

class FileWriter_Truncate_ResponseParamsDataView {
 public:
  FileWriter_Truncate_ResponseParamsDataView() {}

  FileWriter_Truncate_ResponseParamsDataView(
      internal::FileWriter_Truncate_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadResult(UserType* output) const {
    auto data_value = data_->result;
    return mojo::internal::Deserialize<::mojo_base::mojom::FileError>(
        data_value, output);
  }

  ::mojo_base::mojom::FileError result() const {
    return static_cast<::mojo_base::mojom::FileError>(data_->result);
  }
 private:
  internal::FileWriter_Truncate_ResponseParams_Data* data_ = nullptr;
};













}  // namespace mojom
}  // namespace blink

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_FILESYSTEM_FILE_WRITER_MOJOM_PARAMS_DATA_H_