// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_PARAMS_DATA_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_PARAMS_DATA_H_

#include "base/logging.h"
#include "base/macros.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif
namespace ax {
namespace mojom {
namespace internal {
class  AXHost_RegisterRemoteHost_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_RegisterRemoteHost_Params_Data));
      new (data()) AXHost_RegisterRemoteHost_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_RegisterRemoteHost_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_RegisterRemoteHost_Params_Data>(index_);
    }
    AXHost_RegisterRemoteHost_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Interface_Data remote;

 private:
  AXHost_RegisterRemoteHost_Params_Data();
  ~AXHost_RegisterRemoteHost_Params_Data() = delete;
};
static_assert(sizeof(AXHost_RegisterRemoteHost_Params_Data) == 16,
              "Bad sizeof(AXHost_RegisterRemoteHost_Params_Data)");
class  AXHost_RegisterRemoteHost_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data));
      new (data()) AXHost_RegisterRemoteHost_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_RegisterRemoteHost_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_RegisterRemoteHost_ResponseParams_Data>(index_);
    }
    AXHost_RegisterRemoteHost_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  ::ax::mojom::internal::AXTreeID_Data tree_id;
  uint8_t automation_enabled : 1;
  uint8_t padfinal_[7];

 private:
  AXHost_RegisterRemoteHost_ResponseParams_Data();
  ~AXHost_RegisterRemoteHost_ResponseParams_Data() = delete;
};
static_assert(sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data) == 32,
              "Bad sizeof(AXHost_RegisterRemoteHost_ResponseParams_Data)");
class  AXHost_HandleAccessibilityEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXHost_HandleAccessibilityEvent_Params_Data));
      new (data()) AXHost_HandleAccessibilityEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXHost_HandleAccessibilityEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXHost_HandleAccessibilityEvent_Params_Data>(index_);
    }
    AXHost_HandleAccessibilityEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  ::ax::mojom::internal::AXTreeID_Data tree_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ax::mojom::internal::AXTreeUpdate_Data>>> updates;
  mojo::internal::Pointer<::ax::mojom::internal::AXEvent_Data> event;

 private:
  AXHost_HandleAccessibilityEvent_Params_Data();
  ~AXHost_HandleAccessibilityEvent_Params_Data() = delete;
};
static_assert(sizeof(AXHost_HandleAccessibilityEvent_Params_Data) == 40,
              "Bad sizeof(AXHost_HandleAccessibilityEvent_Params_Data)");
class  AXRemoteHost_OnAutomationEnabled_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data));
      new (data()) AXRemoteHost_OnAutomationEnabled_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXRemoteHost_OnAutomationEnabled_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXRemoteHost_OnAutomationEnabled_Params_Data>(index_);
    }
    AXRemoteHost_OnAutomationEnabled_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t enabled : 1;
  uint8_t padfinal_[7];

 private:
  AXRemoteHost_OnAutomationEnabled_Params_Data();
  ~AXRemoteHost_OnAutomationEnabled_Params_Data() = delete;
};
static_assert(sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data) == 16,
              "Bad sizeof(AXRemoteHost_OnAutomationEnabled_Params_Data)");
class  AXRemoteHost_PerformAction_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(AXRemoteHost_PerformAction_Params_Data));
      new (data()) AXRemoteHost_PerformAction_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    AXRemoteHost_PerformAction_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<AXRemoteHost_PerformAction_Params_Data>(index_);
    }
    AXRemoteHost_PerformAction_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::ax::mojom::internal::AXActionData_Data> data;

 private:
  AXRemoteHost_PerformAction_Params_Data();
  ~AXRemoteHost_PerformAction_Params_Data() = delete;
};
static_assert(sizeof(AXRemoteHost_PerformAction_Params_Data) == 16,
              "Bad sizeof(AXRemoteHost_PerformAction_Params_Data)");

}  // namespace internal
class AXHost_RegisterRemoteHost_ParamsDataView {
 public:
  AXHost_RegisterRemoteHost_ParamsDataView() {}

  AXHost_RegisterRemoteHost_ParamsDataView(
      internal::AXHost_RegisterRemoteHost_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeRemote() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::ax::mojom::AXRemoteHostPtrDataView>(
            &data_->remote, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::AXHost_RegisterRemoteHost_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXHost_RegisterRemoteHost_ResponseParamsDataView {
 public:
  AXHost_RegisterRemoteHost_ResponseParamsDataView() {}

  AXHost_RegisterRemoteHost_ResponseParamsDataView(
      internal::AXHost_RegisterRemoteHost_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTreeIdDataView(
      ::ax::mojom::AXTreeIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTreeId(UserType* output) {
    auto* pointer = !data_->tree_id.is_null() ? &data_->tree_id : nullptr;
    return mojo::internal::Deserialize<::ax::mojom::AXTreeIDDataView>(
        pointer, output, context_);
  }
  bool automation_enabled() const {
    return data_->automation_enabled;
  }
 private:
  internal::AXHost_RegisterRemoteHost_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXHost_HandleAccessibilityEvent_ParamsDataView {
 public:
  AXHost_HandleAccessibilityEvent_ParamsDataView() {}

  AXHost_HandleAccessibilityEvent_ParamsDataView(
      internal::AXHost_HandleAccessibilityEvent_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetTreeIdDataView(
      ::ax::mojom::AXTreeIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTreeId(UserType* output) {
    auto* pointer = !data_->tree_id.is_null() ? &data_->tree_id : nullptr;
    return mojo::internal::Deserialize<::ax::mojom::AXTreeIDDataView>(
        pointer, output, context_);
  }
  inline void GetUpdatesDataView(
      mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUpdates(UserType* output) {
    auto* pointer = data_->updates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>>(
        pointer, output, context_);
  }
  inline void GetEventDataView(
      ::ax::mojom::AXEventDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadEvent(UserType* output) {
    auto* pointer = data_->event.Get();
    return mojo::internal::Deserialize<::ax::mojom::AXEventDataView>(
        pointer, output, context_);
  }
 private:
  internal::AXHost_HandleAccessibilityEvent_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class AXRemoteHost_OnAutomationEnabled_ParamsDataView {
 public:
  AXRemoteHost_OnAutomationEnabled_ParamsDataView() {}

  AXRemoteHost_OnAutomationEnabled_ParamsDataView(
      internal::AXRemoteHost_OnAutomationEnabled_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool enabled() const {
    return data_->enabled;
  }
 private:
  internal::AXRemoteHost_OnAutomationEnabled_Params_Data* data_ = nullptr;
};

class AXRemoteHost_PerformAction_ParamsDataView {
 public:
  AXRemoteHost_PerformAction_ParamsDataView() {}

  AXRemoteHost_PerformAction_ParamsDataView(
      internal::AXRemoteHost_PerformAction_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDataDataView(
      ::ax::mojom::AXActionDataDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadData(UserType* output) {
    auto* pointer = data_->data.Get();
    return mojo::internal::Deserialize<::ax::mojom::AXActionDataDataView>(
        pointer, output, context_);
  }
 private:
  internal::AXRemoteHost_PerformAction_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};




inline void AXHost_RegisterRemoteHost_ResponseParamsDataView::GetTreeIdDataView(
    ::ax::mojom::AXTreeIDDataView* output) {
  auto pointer = &data_->tree_id;
  *output = ::ax::mojom::AXTreeIDDataView(pointer, context_);
}


inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetTreeIdDataView(
    ::ax::mojom::AXTreeIDDataView* output) {
  auto pointer = &data_->tree_id;
  *output = ::ax::mojom::AXTreeIDDataView(pointer, context_);
}
inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetUpdatesDataView(
    mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>* output) {
  auto pointer = data_->updates.Get();
  *output = mojo::ArrayDataView<::ax::mojom::AXTreeUpdateDataView>(pointer, context_);
}
inline void AXHost_HandleAccessibilityEvent_ParamsDataView::GetEventDataView(
    ::ax::mojom::AXEventDataView* output) {
  auto pointer = data_->event.Get();
  *output = ::ax::mojom::AXEventDataView(pointer, context_);
}




inline void AXRemoteHost_PerformAction_ParamsDataView::GetDataDataView(
    ::ax::mojom::AXActionDataDataView* output) {
  auto pointer = data_->data.Get();
  *output = ::ax::mojom::AXActionDataDataView(pointer, context_);
}

}  // namespace mojom
}  // namespace ax

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif

#endif  // UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_PARAMS_DATA_H_