// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif


#include "ui/accessibility/mojom/ax_host.mojom-test-utils.h"

#include <utility>

#include "base/bind.h"
#include "base/run_loop.h"
#include "ui/accessibility/ax_enums.mojom.h"
#include "ui/accessibility/mojom/ax_action_data.mojom.h"
#include "ui/accessibility/mojom/ax_event.mojom.h"
#include "ui/accessibility/mojom/ax_tree_id.mojom.h"
#include "ui/accessibility/mojom/ax_tree_update.mojom.h"


#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_JUMBO_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_JUMBO_H_
#include "mojo/public/cpp/base/unguessable_token_mojom_traits.h"
#include "ui/accessibility/mojom/ax_action_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_event_mojom_traits.h"
#include "ui/accessibility/mojom/ax_node_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_relative_bounds_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_data_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_id_mojom_traits.h"
#include "ui/accessibility/mojom/ax_tree_update_mojom_traits.h"
#include "ui/gfx/geometry/mojo/geometry_struct_traits.h"
#include "ui/gfx/mojo/transform_struct_traits.h"
#endif


namespace ax {
namespace mojom {


void AXHostInterceptorForTesting::RegisterRemoteHost(AXRemoteHostPtr remote, RegisterRemoteHostCallback callback) {
  GetForwardingInterface()->RegisterRemoteHost(std::move(remote), std::move(callback));
}
void AXHostInterceptorForTesting::HandleAccessibilityEvent(const ui::AXTreeID& tree_id, const std::vector<ui::AXTreeUpdate>& updates, const ui::AXEvent& event) {
  GetForwardingInterface()->HandleAccessibilityEvent(std::move(tree_id), std::move(updates), std::move(event));
}
AXHostAsyncWaiter::AXHostAsyncWaiter(
    AXHost* proxy) : proxy_(proxy) {}

AXHostAsyncWaiter::~AXHostAsyncWaiter() = default;

void AXHostAsyncWaiter::RegisterRemoteHost(
    AXRemoteHostPtr remote, ui::AXTreeID* out_tree_id, bool* out_automation_enabled) {
  base::RunLoop loop;
  proxy_->RegisterRemoteHost(std::move(remote),
      base::BindOnce(
          [](base::RunLoop* loop,
             ui::AXTreeID* out_tree_id
,
             bool* out_automation_enabled
,
             const ui::AXTreeID& tree_id,
             bool automation_enabled) {*out_tree_id = std::move(tree_id);*out_automation_enabled = std::move(automation_enabled);
            loop->Quit();
          },
          &loop,
          out_tree_id,
          out_automation_enabled));
  loop.Run();
}



void AXRemoteHostInterceptorForTesting::OnAutomationEnabled(bool enabled) {
  GetForwardingInterface()->OnAutomationEnabled(std::move(enabled));
}
void AXRemoteHostInterceptorForTesting::PerformAction(const ui::AXActionData& data) {
  GetForwardingInterface()->PerformAction(std::move(data));
}
AXRemoteHostAsyncWaiter::AXRemoteHostAsyncWaiter(
    AXRemoteHost* proxy) : proxy_(proxy) {}

AXRemoteHostAsyncWaiter::~AXRemoteHostAsyncWaiter() = default;






}  // namespace mojom
}  // namespace ax

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif