// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_TEST_UTILS_H_
#define UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_TEST_UTILS_H_

#include "ui/accessibility/mojom/ax_host.mojom.h"


namespace ax {
namespace mojom {


class  AXHostInterceptorForTesting : public AXHost {
  virtual AXHost* GetForwardingInterface() = 0;
  void RegisterRemoteHost(AXRemoteHostPtr remote, RegisterRemoteHostCallback callback) override;
  void HandleAccessibilityEvent(const ui::AXTreeID& tree_id, const std::vector<ui::AXTreeUpdate>& updates, const ui::AXEvent& event) override;
};
class  AXHostAsyncWaiter {
 public:
  explicit AXHostAsyncWaiter(AXHost* proxy);
  ~AXHostAsyncWaiter();
  void RegisterRemoteHost(
      AXRemoteHostPtr remote, ui::AXTreeID* out_tree_id, bool* out_automation_enabled);

 private:
  AXHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AXHostAsyncWaiter);
};


class  AXRemoteHostInterceptorForTesting : public AXRemoteHost {
  virtual AXRemoteHost* GetForwardingInterface() = 0;
  void OnAutomationEnabled(bool enabled) override;
  void PerformAction(const ui::AXActionData& data) override;
};
class  AXRemoteHostAsyncWaiter {
 public:
  explicit AXRemoteHostAsyncWaiter(AXRemoteHost* proxy);
  ~AXRemoteHostAsyncWaiter();

 private:
  AXRemoteHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AXRemoteHostAsyncWaiter);
};




}  // namespace mojom
}  // namespace ax

#endif  // UI_ACCESSIBILITY_MOJOM_AX_HOST_MOJOM_TEST_UTILS_H_